/*
 * filewrite.c - auto-generated by CHDK code_gen.
 */
#include "lolevel.h"
#include "platform.h"

typedef struct {
    unsigned int address;
    unsigned int length;
} cam_ptp_data_chunk; //camera specific structure

#define MAX_CHUNKS_FOR_JPEG 3 // filewritetask is prepared for this many chunks
/*
 * fwt_data_struct: defined here as it's camera dependent
 * unneeded members are designated with unkn
 * file_offset, full_size, seek_flag only needs to be defined for DryOS>=r50 generation cameras
 * pdc is always required
 * name is not currently used
 */
typedef struct
{
    int unkn1[5];
    cam_ptp_data_chunk pdc[MAX_CHUNKS_FOR_JPEG];
    char name[32];
} fwt_data_struct;

#include "../../../generic/filewrite.c"

/*************************************************************/
//** filewritetask @ 0xFFDDBC84 - 0xFFDDBD64, length=57
void __attribute__((naked,noinline)) filewritetask() {
asm volatile (
"    STMFD   SP!, {R1-R5,LR} \n"
"    LDR     R4, =0x8750 \n"

"loc_FFDDBC8C:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #8 \n"
"    BL      sub_FFC163C8 /*_ReceiveMessageQueue*/ \n"
"    CMP     R0, #0 \n"
"    BNE     loc_FFDDBCBC \n"
"    LDR     R0, [SP, #8] \n"
"    LDR     R1, [R0] \n"
"    CMP     R1, #1 \n"
"    BNE     loc_FFDDBCC4 \n"
"    LDR     R0, [R4, #8] \n"
"    BL      _GiveSemaphore \n"

"loc_FFDDBCBC:\n"
"    BL      _ExitTask \n"
"    LDMFD   SP!, {R1-R5,PC} \n"

"loc_FFDDBCC4:\n"
"    SUB     R1, R1, #2 \n"
"    CMP     R1, #5 \n"
"    ADDLS   PC, PC, R1, LSL#2 \n"
"    B       loc_FFDDBC8C \n"
"    B       loc_FFDDBCEC \n"
"    B       loc_FFDDBD50 \n"
"    B       loc_FFDDBD58 \n"
"    B       loc_FFDDBD58 \n"
"    B       loc_FFDDBD58 \n"
"    B       loc_FFDDBD60 \n"

"loc_FFDDBCEC:\n"
"    MOV     R0, #0 \n"
"    STR     R0, [SP] \n"

"loc_FFDDBCF4:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R1, SP \n"
"    BL      sub_FFC1660C /*_GetNumberOfPostedMessages*/ \n"
"    LDR     R0, [SP] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FFDDBD20 \n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_FFC163C8 /*_ReceiveMessageQueue*/ \n"
"    B       loc_FFDDBCF4 \n"

"loc_FFDDBD20:\n"
"    LDR     R0, [R4] \n"
"    CMN     R0, #1 \n"
"    BEQ     loc_FFDDBD44 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    MVN     R0, #0 \n"
"    STR     R0, [R4] \n"
"    LDR     R0, =0xB7D00 \n"
"    BL      sub_FFC3ED18 \n"
"    BL      sub_FFC3D2A4 \n"

"loc_FFDDBD44:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      _GiveSemaphore \n"
"    B       loc_FFDDBC8C \n"

"loc_FFDDBD50:\n"
"    BL      sub_FFDDBF38_my \n"  // --> Patched. Old value = 0xFFDDBF38. Open stage
"    B       loc_FFDDBC8C \n"

"loc_FFDDBD58:\n"
"    BL      sub_FFDDC084_my \n"  // --> Patched. Old value = 0xFFDDC084. Write stage
"    B       loc_FFDDBC8C \n"

"loc_FFDDBD60:\n"
"    BL      sub_FFDDC180_my \n"  // --> Patched. Old value = 0xFFDDC180. Close stage
"    B       loc_FFDDBC8C \n"
);
}

/*************************************************************/
//** sub_FFDDBF38_my @ 0xFFDDBF38 - 0xFFDDBF78, length=17
void __attribute__((naked,noinline)) sub_FFDDBF38_my() {
asm volatile (
"    STMFD   SP!, {R4-R8,LR} \n"
"    MOV     R4, R0 \n"
"    ADD     R0, R0, #0x2C \n"
"    SUB     SP, SP, #0x38 \n"
"    BL      sub_FFC3ED18 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FFC3D254 \n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FFC3B6FC \n"
"    LDR     R7, [R4, #8] \n"
"    LDR     R8, =0x1B6 \n"
"    ADD     R6, R4, #0x2C \n"
"    LDR     R5, [R4, #0xC] \n"
//hook start
"    STMFD SP!, {R4-R12,LR}\n"
"    MOV R0, R4\n"
"    BL filewrite_main_hook\n"
"    LDMFD SP!, {R4-R12,LR}\n"
//hook end
"    MOV     R0, R6 \n"
"    MOV     R1, R7 \n"
"    MOV     R2, R8 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.
"    LDR     PC, =0xFFDDBF7C \n"  // Continue in firmware
);
}

/*************************************************************/
//** sub_FFDDC084_my @ 0xFFDDC084 - 0xFFDDC17C, length=63
void __attribute__((naked,noinline)) sub_FFDDC084_my() {
asm volatile (
"    STMFD   SP!, {R4-R10,LR} \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R0] \n"
"    CMP     R0, #4 \n"
"    LDREQ   R6, [R4, #0x18] \n"
"    LDREQ   R7, [R4, #0x14] \n"
"    BEQ     loc_FFDDC0C0 \n"
"    CMP     R0, #5 \n"
"    LDREQ   R6, [R4, #0x20] \n"
"    LDREQ   R7, [R4, #0x1C] \n"
"    BEQ     loc_FFDDC0C0 \n"
"    CMP     R0, #6 \n"
"    BNE     loc_FFDDC0D4 \n"
"    LDR     R6, [R4, #0x28] \n"
"    LDR     R7, [R4, #0x24] \n"

"loc_FFDDC0C0:\n"
"    CMP     R6, #0 \n"
"    BNE     loc_FFDDC0E4 \n"

"loc_FFDDC0C8:\n"
"    MOV     R1, R4 \n"
"    MOV     R0, #7 \n"
"    B       loc_FFDDC178 \n"

"loc_FFDDC0D4:\n"
"    LDR     R1, =0x20D \n"
"    LDR     R0, =0xFFDDC064 /*'dwFWrite.c'*/ \n"
"    BL      _DebugAssert \n"
"    B       loc_FFDDC0C8 \n"

"loc_FFDDC0E4:\n"
"    LDR     R9, =0x8750 \n"
"    MOV     R5, R6 \n"

"loc_FFDDC0EC:\n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R5, #0x1000000 \n"
"    MOVLS   R8, R5 \n"
"    MOVHI   R8, #0x1000000 \n"
"    BIC     R1, R0, #0xFF000000 \n"
"    CMP     R1, #0 \n"
"    BICNE   R0, R0, #0xFF000000 \n"
"    RSBNE   R0, R0, #0x1000000 \n"
"    CMPNE   R8, R0 \n"
"    MOVHI   R8, R0 \n"
"    LDR     R0, [R9] \n"
"    MOV     R2, R8 \n"
"    MOV     R1, R7 \n"
"    BL      fwt_write \n"  // --> Patched. Old value = _Write.
"    LDR     R1, [R4, #4] \n"
"    CMP     R8, R0 \n"
"    ADD     R1, R1, R0 \n"
"    STR     R1, [R4, #4] \n"
"    BEQ     loc_FFDDC14C \n"
"    LDR     R0, =0x10B1 \n"
"    BL      sub_FFC5C850 /*_IsControlEventActive_FW*/ \n"
"    LDR     R1, =0x9200005 \n"
"    STR     R1, [R4, #0x10] \n"
"    B       loc_FFDDC0C8 \n"

"loc_FFDDC14C:\n"
"    SUB     R5, R5, R0 \n"
"    CMP     R5, R6 \n"
"    ADD     R7, R7, R0 \n"
"    LDRCS   R0, =0xFFDDC064 /*'dwFWrite.c'*/ \n"
"    MOVCS   R1, #0x23C \n"
"    BLCS    _DebugAssert \n"
"    CMP     R5, #0 \n"
"    BNE     loc_FFDDC0EC \n"
"    LDR     R0, [R4] \n"
"    MOV     R1, R4 \n"
"    ADD     R0, R0, #1 \n"

"loc_FFDDC178:\n"
"    LDMFD   SP!, {R4-R10,LR} \n"
"    B       sub_FFDDBBDC \n"
);
}

/*************************************************************/
//** sub_FFDDC180_my @ 0xFFDDC180 - 0xFFDDC19C, length=8
void __attribute__((naked,noinline)) sub_FFDDC180_my() {
asm volatile (
"    STMFD   SP!, {R4,R5,LR} \n"
"    LDR     R5, =0x8750 \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R5] \n"
"    SUB     SP, SP, #0x1C \n"
"    CMN     R0, #1 \n"
"    BEQ     sub_FFDDC1B4 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    LDR     PC, =0xFFDDC1A0 \n"  // Continue in firmware
);
}
