PLATFORMID=12838


PLATFORMOS=dryos

# Force EXMEM on for a800 - not enough heap to work in low memory
#override OPT_EXMEM_MALLOC=1
#override OPT_CHDK_IN_EXMEM=1

# Force ARAM on for A800, and load CHDK in ARAM
override OPT_ARAM_MALLOC=1
override OPT_CHDK_IN_ARAM=1
 
# Base address 0xFFC00000 for A800
ROMBASEADDR=0xFFC00000

# de stubs_entry.S e em 0xFFC66958 (0x12000000 => 0x2000000 - 1)
MAXRAMADDR = 0x01ffffff

# Set up size variables for AgentRAM
ARAM_HEAP_START=0x2ce000
ARAM_HEAP_SIZE=0x32000

# Set up size variables for EXMEM
EXMEM_BUFFER_SIZE=0xA0000  # 40000=256KB, 80000=512KB, A0000=640kb, C0000=768KB, 100000=1MB - colado de IXUS220
EXMEM_HEAP_SKIP=0

ifdef OPT_CHDK_IN_ARAM
MEMISOSTART=$(ARAM_HEAP_START)
else
ifdef OPT_CHDK_IN_EXMEM
   MEMISOSTART=0x1F5FFE0  # MAXRAMADDR+1 - EXMEM_HEAP_SKIP - EXMEM_BUFFER_SIZE - 32(0x20) (exmem allocates 64 bytes extra, 32 before and 32 after block allocated)
else					#265kb=79467E0, 512kb=79067E0, 640kb=78E67E0
# ROM:FFC0014C (ok)
   MEMISOSTART=0x13A700 #Valor Original
endif
endif

# type of diskboot encoding: undefined = none; 1 = original; 2 = sx200, d10; 3 = ixus200...
# Dancing Bits
NEED_ENCODED_DISKBOOT=6

# FIR (requires correct keys in platform/fi2.inc)
KEYSYS=d4c

PLATFORMOSVER=47
