# Camera settings for the G12 1.00c

# Force ARAM on for G12, and load CHDK in ARAM
override OPT_ARAM_MALLOC=1
override OPT_CHDK_IN_ARAM=1

# Set up size variables for AgentRAM
ARAM_HEAP_START=0x3ce000
ARAM_HEAP_SIZE=0x32000

# Set up size variables for EXMEM
EXMEM_HEAP_SKIP=0x2F7600	#(0x48000000-0x47D08A00) from sub_FF890270 = size of video buffers in EXMEM area
EXMEM_BUFFER_SIZE=0x400000	# Amount of EXMEM memory to allocate for CHDK = 4MB

ifdef OPT_CHDK_IN_ARAM
MEMISOSTART=$(ARAM_HEAP_START)
else
ifdef OPT_CHDK_IN_EXMEM
MEMISOSTART=0x79089e0		# MAXRAMADDR+1 - EXMEM_HEAP_SKIP - EXMEM_BUFFER_SIZE - 32 (exmem allocates 64 bytes extra, 32 before and 32 after block allocated)
else
MEMISOSTART=0x16E820
endif
endif
