/*
 * filewrite.c - auto-generated by CHDK code_gen.
 */
#include "lolevel.h"
#include "platform.h"

typedef struct {
    unsigned int address;
    unsigned int length;
} cam_ptp_data_chunk; //camera specific structure

#define MAX_CHUNKS_FOR_JPEG 7   // filewritetask is prepared for this many chunks
/*
 * fwt_data_struct: defined here as it's camera dependent
 * unneeded members are designated with unkn
 * pdc is required, everything after that is optional (DryOS < R50)
 * file_offset, full_size, seek_flag only needs to be defined for DryOS>=r50 generation cameras
 */
typedef struct
{
    int unkn1[5];
    cam_ptp_data_chunk pdc[MAX_CHUNKS_FOR_JPEG];
    int unkn2;
    char name[32];
} fwt_data_struct;

#include "../../../generic/filewrite.c"

/*************************************************************/
//** filewritetask @ 0xFF34A928 - 0xFF34AA0C, length=58
void __attribute__((naked,noinline)) filewritetask() {
asm volatile (
"    STMFD   SP!, {R1-R5,LR} \n"
"    LDR     R5, =0xFEB4 \n"

"loc_FF34A930:\n"
"    MOV     R2, #0 \n"
"    LDR     R0, [R5, #0x10] \n"
"    ADD     R1, SP, #8 \n"
"    BL      sub_FF029EA8 /*_ReceiveMessageQueue*/ \n"
"    CMP     R0, #0 \n"
"    LDRNE   R1, =0x35B \n"
"    LDRNE   R0, =0xFF34AA20 /*'dwFWrite.c'*/ \n"
"    BLNE    _DebugAssert \n"
"    LDR     R0, [SP, #8] \n"
"    LDR     R1, [R0] \n"
"    CMP     R1, #0xA \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF34A930 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA00 \n"
"    B       loc_FF34AA08 \n"
"    B       loc_FF34A98C \n"
"    B       loc_FF34A9F8 \n"

"loc_FF34A98C:\n"
"    MOV     R0, #0 \n"
"    MOV     R4, R5 \n"
"    STR     R0, [SP] \n"

"loc_FF34A998:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R1, SP \n"
"    BL      sub_FF02A0EC /*_GetNumberOfPostedMessages*/ \n"
"    LDR     R0, [SP] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FF34A9C4 \n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_FF029EA8 /*_ReceiveMessageQueue*/ \n"
"    B       loc_FF34A998 \n"

"loc_FF34A9C4:\n"
"    LDR     R0, [R4, #4] \n"
"    CMN     R0, #1 \n"
"    BEQ     loc_FF34A9EC \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    MVN     R0, #0 \n"
"    STR     R0, [R4, #4] \n"
"    LDR     R0, =0x162874 \n"
"    BL      sub_FF06CDB8 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF06B034 \n"

"loc_FF34A9EC:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      _GiveSemaphore \n"
"    B       loc_FF34A930 \n"

"loc_FF34A9F8:\n"
"    BL      sub_FF34AC0C_my \n"  // --> Patched. Old value = 0xFF34AC0C.
"    B       loc_FF34A930 \n"

"loc_FF34AA00:\n"
"    BL      sub_FF34ACCC_my \n"  // --> Patched. Old value = 0xFF34ACCC.
"    B       loc_FF34A930 \n"

"loc_FF34AA08:\n"
"    BL      sub_FF34A7BC_my \n"  // --> Patched. Old value = 0xFF34A7BC.
"    B       loc_FF34A930 \n"
);
}

/*************************************************************/
//** sub_FF34AC0C_my @ 0xFF34AC0C - 0xFF34AC50, length=18
void __attribute__((naked,noinline)) sub_FF34AC0C_my() {
asm volatile (
"    STMFD   SP!, {R4-R6,LR} \n"
"    MOV     R4, R0 \n"
"    ADD     R0, R0, #0x50 \n"
"    BL      sub_FF06CDB8 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF06AEF8 \n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF000348 \n"
"    LDR     R0, [R4, #0x4C] \n"
"    LDR     R2, =0x1B6 \n"
"    CMP     R0, #1 \n"
"    LDREQ   R0, [R4, #8] \n"
"    ORREQ   R0, R0, #0x8000 \n"
"    STREQ   R0, [R4, #8] \n"
//hook start
"    STMFD   SP!, {R2-R12,LR} \n"
"    MOV     R0, R4 \n"
"    BL      filewrite_main_hook \n"
"    LDMFD   SP!, {R2-R12,LR} \n"
//hook end
"    LDR     R1, [R4, #8] \n"
"    LDR     R3, [R4, #0xC] \n"
"    ADD     R0, R4, #0x50 \n"
"    BL      sub_FF34ADAC_my \n"  // --> Patched. Old value = 0xFF34ADAC.
"    LDR     PC, =0xFF34AC54 \n"  // Continue in firmware
);
}

/*************************************************************/
//** sub_FF34ADAC_my @ 0xFF34ADAC - 0xFF34AE84, length=55
void __attribute__((naked,noinline)) sub_FF34ADAC_my() {
asm volatile (
"    STMFD   SP!, {R4-R10,LR} \n"
"    SUB     SP, SP, #0x38 \n"
"    MOV     R7, R0 \n"
"    MOV     R8, R1 \n"
"    MOV     R9, R2 \n"
"    MOV     R5, R3 \n"
"    BL      sub_FF205AB0 /*_PTM_GetWorkingCaptureMode_FW*/ \n"
"    AND     R0, R0, #0x7F \n"
"    CMP     R0, #8 \n"
"    CMPNE   R0, #0x22 \n"
"    MOV     R6, #0 \n"
"    MOVEQ   R4, #1 \n"
"    MOVNE   R4, R6 \n"
"    CMP     R4, #1 \n"
"    BLEQ    sub_FF1D0BE4 \n"
"    MOV     R2, R9 \n"
"    MOV     R1, R8 \n"
"    MOV     R0, R7 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.
"    CMP     R4, #1 \n"
"    MOV     R10, R0 \n"
"    BLEQ    sub_FF1D0C34 \n"
"    CMN     R10, #1 \n"
"    MOVNE   R0, R10 \n"
"    BNE     loc_FF34AE80 \n"
"    CMP     R4, #1 \n"
"    BLEQ    sub_FF1D0BE4 \n"
"    MOV     R0, R7 \n"
"    BL      sub_FF026AE4 \n"
"    MOV     R2, #0xF \n"
"    MOV     R1, R7 \n"
"    MOV     R0, SP \n"
"    BL      sub_FF45F614 \n"
"    LDR     R0, =0x41FF \n"
"    STRB    R6, [SP, #0xF] \n"
"    STR     R0, [SP, #0x20] \n"
"    MOV     R0, #0x10 \n"
"    STR     R0, [SP, #0x24] \n"
"    ADD     R1, SP, #0x20 \n"
"    MOV     R0, SP \n"
"    STR     R6, [SP, #0x28] \n"
"    STR     R5, [SP, #0x2C] \n"
"    STR     R5, [SP, #0x30] \n"
"    STR     R5, [SP, #0x34] \n"
"    BL      sub_FF06A86C \n"
"    MOV     R2, R9 \n"
"    MOV     R1, R8 \n"
"    MOV     R0, R7 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.
"    CMP     R4, #1 \n"
"    MOV     R5, R0 \n"
"    BLEQ    sub_FF1D0C34 \n"
"    MOV     R0, R5 \n"

"loc_FF34AE80:\n"
"    ADD     SP, SP, #0x38 \n"
"    LDMFD   SP!, {R4-R10,PC} \n"
);
}

/*************************************************************/
//** sub_FF34ACCC_my @ 0xFF34ACCC - 0xFF34AD94, length=51
void __attribute__((naked,noinline)) sub_FF34ACCC_my() {
asm volatile (
"    STMFD   SP!, {R4-R10,LR} \n"
"    MOV     R5, R0 \n"
"    LDR     R0, [R0] \n"
"    CMP     R0, #6 \n"
"    BHI     loc_FF34ACF8 \n"
"    ADD     R0, R5, R0, LSL#3 \n"
"    LDR     R8, [R0, #0x14]! \n"
"    LDR     R7, [R0, #4] \n"
"    CMP     R7, #0 \n"
"    BNE     loc_FF34AD10 \n"
"    B       loc_FF34AD04 \n"

"loc_FF34ACF8:\n"
"    LDR     R1, =0x2BB \n"
"    LDR     R0, =0xFF34AA20 /*'dwFWrite.c'*/ \n"
"    BL      _DebugAssert \n"

"loc_FF34AD04:\n"
"    MOV     R1, R5 \n"
"    MOV     R0, #7 \n"
"    B       sub_FF34ADA4 \n"

"loc_FF34AD10:\n"
"    LDR     R9, =0xFEB4 \n"
"    MOV     R4, R7 \n"

"loc_FF34AD18:\n"
"    LDR     R0, [R5, #4] \n"
"    CMP     R4, #0x1000000 \n"
"    MOVLS   R6, R4 \n"
"    MOVHI   R6, #0x1000000 \n"
"    BIC     R1, R0, #0xFF000000 \n"
"    CMP     R1, #0 \n"
"    BICNE   R0, R0, #0xFF000000 \n"
"    RSBNE   R0, R0, #0x1000000 \n"
"    CMPNE   R6, R0 \n"
"    MOVHI   R6, R0 \n"
"    LDR     R0, [R9, #4] \n"
"    MOV     R2, R6 \n"
"    MOV     R1, R8 \n"
"    BL      fwt_write \n"  // --> Patched. Old value = _Write.
"    LDR     R1, [R5, #4] \n"
"    CMP     R6, R0 \n"
"    ADD     R1, R1, R0 \n"
"    STR     R1, [R5, #4] \n"
"    BEQ     loc_FF34AD78 \n"
"    CMN     R0, #1 \n"
"    LDRNE   R0, =0x9200015 \n"
"    LDREQ   R0, =0x9200005 \n"
"    STR     R0, [R5, #0x10] \n"
"    B       loc_FF34AD04 \n"

"loc_FF34AD78:\n"
"    SUB     R4, R4, R0 \n"
"    CMP     R4, R7 \n"
"    LDRCS   R1, =0x2E6 \n"
"    ADD     R8, R8, R0 \n"
"    LDRCS   R0, =0xFF34AA20 /*'dwFWrite.c'*/ \n"
"    BLCS    _DebugAssert \n"
"    CMP     R4, #0 \n"
"    BNE     loc_FF34AD18 \n"
"    LDR     PC, =0xFF34AD98 \n"  // Continue in firmware
);
}

/*************************************************************/
//** sub_FF34A7BC_my @ 0xFF34A7BC - 0xFF34A7F0, length=14
void __attribute__((naked,noinline)) sub_FF34A7BC_my() {
asm volatile (
"    STMFD   SP!, {R4-R6,LR} \n"
"    LDR     R5, =0xFEB4 \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R5, #4] \n"
"    SUB     SP, SP, #0x38 \n"
"    CMN     R0, #1 \n"
"    BEQ     sub_FF34A804 \n"
"    LDR     R1, [R4, #8] \n"
"    LDR     R6, =0x9200003 \n"
"    TST     R1, #0x8000 \n"
"    BEQ     loc_FF34A7F0 \n"
//mod start
"    LDR R3, =current_write_ignored\n"
"    LDR R3, [R3]\n"
"    CMP R3, #0\n"
"    BNE loc_D\n" // jump over the next block
//mod end
"    BL      sub_FF026508 \n"
"    B       sub_FF34A7F4 \n"

"loc_FF34A7F0:\n"
"loc_D:\n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    LDR     PC, =0xFF34A7F4 \n"  // Continue in firmware
);
}
