/*
 * filewrite.c - auto-generated by CHDK code_gen.
 */
#include "lolevel.h"
#include "platform.h"

typedef struct {
    unsigned int address;
    unsigned int length;
} cam_ptp_data_chunk; //camera specific structure

#define MAX_CHUNKS_FOR_JPEG 7 // filewritetask is prepared for this many chunks


/*
 * fwt_data_struct: defined here as it's camera dependent
 * unneeded members are designated with unkn
 * file_offset, full_size, seek_flag only needs to be defined for DryOS>=r50 generation cameras
 * pdc is always required
 * name is not currently used
 */
typedef struct
{
    int unkn1;
    int file_offset;
    int full_size;
    int unkn2, unkn3;
    cam_ptp_data_chunk pdc[MAX_CHUNKS_FOR_JPEG];
    int seek_flag;      // offset from start 0x4c = 76 bytes = 19 words
    int unkn4, unkn5;
    char name[32];      // offset from start 0x58 = 88 bytes = 22 words
} fwt_data_struct;
// seek_flag is different:
// seek state is activated (from state 0xc, open) when
// (word at 0x4c) AND 0x40
// OR
// write offset is not 0
#define FWT_MUSTSEEK    0x40   // value of the masked seek_flag indicating seek is required
#define FWT_SEEKMASK    0x40   // masks out unneeded bits of seek_flag

#include "../../../generic/filewrite.c"


/*************************************************************/
//** filewritetask @ 0xFFAA2554 - 0xFFAA26F8, length=106
void __attribute__((naked,noinline)) filewritetask() {
asm volatile (
"    STMFD   SP!, {R1-R7,LR} \n"
"    LDR     R5, =0xB460 \n"
"    MOV     R6, #0 \n"

"loc_FFAA2560:\n"
"    LDR     R0, [R5, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #8 \n"
"    BL      sub_006B8458 /*_ReceiveMessageQueue*/ \n"
"    CMP     R0, #0 \n"
"    LDRNE   R2, =0x3F5 \n"
"    LDRNE   R1, =0xFFAA2720 /*'dwFWrite.c'*/ \n"
"    MOVNE   R0, #0 \n"
"    BLNE    _DebugAssert \n"
"    LDR     R0, [SP, #8] \n"
"    LDR     R1, [R0] \n"
"    CMP     R1, #0xD \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FFAA2560 \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26EC \n"
"    B       loc_FFAA26F4 \n"
"    B       loc_FFAA25CC \n"
"    B       loc_FFAA2668 \n"
"    B       loc_FFAA2698 \n"
"    B       loc_FFAA2634 \n"
"    B       loc_FFAA2660 \n"

"loc_FFAA25CC:\n"
"    MOV     R4, R5 \n"
"    STR     R6, [SP] \n"

"loc_FFAA25D4:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R1, SP \n"
"    BL      sub_006B86D4 /*_GetNumberOfPostedMessages*/ \n"
"    LDR     R0, [SP] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FFAA2600 \n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_006B8458 /*_ReceiveMessageQueue*/ \n"
"    B       loc_FFAA25D4 \n"

"loc_FFAA2600:\n"
"    LDR     R0, [R4, #4] \n"
"    CMN     R0, #1 \n"
"    BEQ     loc_FFAA2628 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    MVN     R0, #0 \n"
"    STR     R0, [R4, #4] \n"
"    LDR     R0, =0xFC318 \n"
"    BL      sub_FF830358 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF82E1CC \n"

"loc_FFAA2628:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      _GiveSemaphore \n"
"    B       loc_FFAA2560 \n"

"loc_FFAA2634:\n"
"    MOV     R4, R0 \n"
"    ADD     R0, R0, #0x58 \n"
"    BL      sub_FF830358 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF82E08C \n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF82D128 \n"

//mod start
"    LDR R3, =ignore_current_write\n" // !!
"    LDR R3, [R3]\n"
"    CMP R3, #0\n"
"    BNE loc_A\n" // skip creating directory
//mod end
"    ADD     R0, R4, #0x58 \n"
"    BL      sub_FF8277FC \n"
"loc_A:\n"
"    ADD     R0, R4, #0x58 \n"
"    B       loc_FFAA26CC \n"

"loc_FFAA2660:\n"
"    BL      sub_FFAA2234_my \n"  // --> Patched. Old value = 0xFFAA2234. Open stage
"    B       loc_FFAA2560 \n"

"loc_FFAA2668:\n"
"    LDR     R1, [R0, #4] \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R5, #4] \n"
"    MOV     R2, #0 \n"
"    BL      fwt_lseek \n"  // --> Patched. Old value = _lseek.
"    CMN     R0, #1 \n"
"    LDREQ   R0, =0x9200013 \n"
"    MOVEQ   R1, R4 \n"
"    STREQ   R0, [R4, #0x10] \n"
"    MOVEQ   R0, #7 \n"
"    BLEQ    sub_FFAA2174 \n"
"    B       loc_FFAA2560 \n"

"loc_FFAA2698:\n"
"    MOV     R4, R0 \n"
"    LDRSB   R0, [R0, #0x58] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FFAA2560 \n"
"    STRB    R0, [SP, #4] \n"
"    ADD     R0, R4, #0x58 \n"
"    STRB    R6, [SP, #5] \n"
"    BL      sub_FF830358 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF82E08C \n"

//mod start
"    LDR R3, =ignore_current_write\n" // !!
"    LDR R3, [R3]\n"
"    CMP R3, #0\n"
"    BNE loc_B\n" // skip flushing the cache
//mod end

"    ADD     R0, SP, #4 \n"
"    BL      sub_FF82D140 \n"
"loc_B:\n"
"    ADD     R0, R4, #0x58 \n"

"loc_FFAA26CC:\n"
"    BL      sub_FF830358 \n"
"    LDR     R1, [R5, #0x1C] \n"
"    BL      sub_FF82E1CC \n"
"    LDR     R1, [R5, #0x14] \n"
"    CMP     R1, #0 \n"
"    LDRNE   R0, [R4, #0x10] \n"
"    BLXNE   R1 \n"
"    B       loc_FFAA2560 \n"

"loc_FFAA26EC:\n"
"    BL      sub_FFAA2914_my \n"  // --> Patched. Old value = 0xFFAA2914. Write stage
"    B       loc_FFAA2560 \n"

"loc_FFAA26F4:\n"
"    BL      sub_FFAA23CC_my \n"  // --> Patched. Old value = 0xFFAA23CC. Close stage
"    B       loc_FFAA2560 \n"
);
}

/*************************************************************/
//** sub_FFAA2234_my @ 0xFFAA2234 - 0xFFAA23C8, length=102
void __attribute__((naked,noinline)) sub_FFAA2234_my() {
asm volatile (
"    STMFD   SP!, {R4-R9,LR} \n"
"    MOV     R4, R0 \n"

//hook placed here to avoid conditional branch a few instructions below (watch out for registers!)
"    MOV   R0, R4\n"      //data block start, commented out as R0 is already holding what we need
"    BL filewrite_main_hook\n"
"    MOV     R0, R4\n"      //restore register(s)
//hook end

"    LDR     R0, [R0, #0x4C] \n"
"    SUB     SP, SP, #0x3C \n"
"    TST     R0, #1 \n"
"    BEQ     loc_FFAA239C \n"
"    LDR     R7, =0xB460 \n"
"    LDR     R0, [R7, #0x18] \n"
"    CMP     R0, #0 \n"
"    BLXNE   R0 \n"
"    ADD     R0, R4, #0x58 \n"
"    BL      sub_FF830358 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF82E08C \n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF82D128 \n"
"    LDR     R0, [R4, #0x4C] \n"
"    LDR     R5, =0x301 \n"
"    TST     R0, #0x10 \n"
"    MOVNE   R5, #9 \n"
"    BNE     loc_FFAA2290 \n"
"    TST     R0, #0x40 \n"
"    MOVNE   R5, #1 \n"

"loc_FFAA2290:\n"
"    TST     R0, #0x20 \n"
"    BNE     loc_FFAA22A4 \n"
"    LDR     R0, [R4, #0x54] \n"
"    CMP     R0, #1 \n"
"    BNE     loc_FFAA22A8 \n"

"loc_FFAA22A4:\n"
"    ORR     R5, R5, #0x8000 \n"

"loc_FFAA22A8:\n"
"    LDR     R9, =0x1B6 \n"
"    ADD     R8, R4, #0x58 \n"
"    LDR     R6, [R4, #0xC] \n"
"    MOV     R2, R9 \n"
"    MOV     R1, R5 \n"
"    MOV     R0, R8 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.
"    CMN     R0, #1 \n"
"    BNE     loc_FFAA2328 \n"
"    MOV     R0, R8 \n"
"    BL      sub_FF8277FC \n"
"    MOV     R2, #0xF \n"
"    MOV     R1, R8 \n"
"    ADD     R0, SP, #4 \n"
"    BL      sub_006BCD9C \n"
"    MOV     R0, #0 \n"
"    LDR     R1, =0x41FF \n"
"    STRB    R0, [SP, #0x13] \n"
"    STR     R1, [SP, #0x24] \n"
"    MOV     R1, #0x10 \n"
"    STR     R0, [SP, #0x2C] \n"
"    STR     R1, [SP, #0x28] \n"
"    ADD     R1, SP, #0x24 \n"
"    ADD     R0, SP, #4 \n"
"    STR     R6, [SP, #0x30] \n"
"    STR     R6, [SP, #0x34] \n"
"    STR     R6, [SP, #0x38] \n"
"    BL      sub_FF82D9F0 \n"
"    MOV     R2, R9 \n"
"    MOV     R1, R5 \n"
"    MOV     R0, R8 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.

"loc_FFAA2328:\n"
"    CMN     R0, #1 \n"
"    MOV     R5, R0 \n"
"    STR     R0, [R7, #4] \n"
"    BNE     loc_FFAA2364 \n"
"    ADD     R0, R4, #0x58 \n"
"    BL      sub_FF830358 \n"
"    LDR     R1, [R7, #0x1C] \n"
"    BL      sub_FF82E1CC \n"
"    LDR     R1, [R7, #0x14] \n"
"    CMP     R1, #0 \n"
"    BEQ     loc_FFAA23C4 \n"
"    ADD     SP, SP, #0x3C \n"
"    LDMFD   SP!, {R4-R9,LR} \n"
"    LDR     R0, =0x9200001 \n"
"    BX      R1 \n"

"loc_FFAA2364:\n"
"    LDR     R0, =0xFC318 \n"
"    MOV     R2, #0x20 \n"
"    ADD     R1, R4, #0x58 \n"
"    BL      sub_006BCF84 \n"

//mod start
"    LDR R3, =current_write_ignored\n"
"    LDR R3, [R3]\n"
"    CMP R3, #0\n"
"    BNE loc_C\n" // jump over the next block
//mod end

"    LDR     R0, [R4, #0x4C] \n"
"    TST     R0, #0x80 \n"
"    BEQ     loc_FFAA239C \n"
"    LDR     R1, [R4, #8] \n"
"    MOV     R0, R5 \n"
"    BL      sub_FF8274CC \n"
"    CMP     R0, #0 \n"
"    MOVEQ   R1, R4 \n"
"    MOVEQ   R0, #7 \n"
"    BEQ     loc_FFAA23C0 \n"

"loc_FFAA239C:\n"
"loc_C:\n"
"    LDR     R0, [R4, #0x4C] \n"
"    TST     R0, #0x40 \n"
"    LDREQ   R0, [R4, #4] \n"
"    CMPEQ   R0, #0 \n"
"    MOVNE   R1, R4 \n"
"    MOVNE   R0, #9 \n"
"    BLNE    sub_FFAA2174 \n"
"    MOV     R1, R4 \n"
"    MOV     R0, #0 \n"

"loc_FFAA23C0:\n"
"    BL      sub_FFAA2174 \n"

"loc_FFAA23C4:\n"
"    ADD     SP, SP, #0x3C \n"
"    LDMFD   SP!, {R4-R9,PC} \n"
);
}

/*************************************************************/
//** sub_FFAA2914_my @ 0xFFAA2914 - 0xFFAA29F8, length=58
void __attribute__((naked,noinline)) sub_FFAA2914_my() {
asm volatile (
"    STMFD   SP!, {R4-R10,LR} \n"
"    MOV     R5, R0 \n"
"    LDR     R0, [R0] \n"
"    CMP     R0, #6 \n"
"    BHI     loc_FFAA2940 \n"
"    ADD     R0, R5, R0, LSL#3 \n"
"    LDR     R8, [R0, #0x14]! \n"
"    LDR     R7, [R0, #4] \n"
"    CMP     R7, #0 \n"
"    BNE     loc_FFAA295C \n"
"    B       loc_FFAA2950 \n"

"loc_FFAA2940:\n"
"    LDR     R2, =0x34A \n"
"    LDR     R1, =0xFFAA2720 /*'dwFWrite.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"

"loc_FFAA2950:\n"
"    MOV     R1, R5 \n"
"    MOV     R0, #7 \n"
"    B       loc_FFAA29F4 \n"

"loc_FFAA295C:\n"
"    LDR     R9, =0xB460 \n"
"    MOV     R4, R7 \n"

"loc_FFAA2964:\n"
"    LDR     R0, [R5, #4] \n"
"    CMP     R4, #0x1000000 \n"
"    MOVLS   R6, R4 \n"
"    MOVHI   R6, #0x1000000 \n"
"    BIC     R1, R0, #0xFF000000 \n"
"    CMP     R1, #0 \n"
"    BICNE   R0, R0, #0xFF000000 \n"
"    RSBNE   R0, R0, #0x1000000 \n"
"    CMPNE   R6, R0 \n"
"    MOVHI   R6, R0 \n"
"    LDR     R0, [R9, #4] \n"
"    MOV     R2, R6 \n"
"    MOV     R1, R8 \n"
"    BL      fwt_write \n"  // --> Patched. Old value = _Write.
"    LDR     R1, [R5, #4] \n"
"    CMP     R6, R0 \n"
"    ADD     R1, R1, R0 \n"
"    STR     R1, [R5, #4] \n"
"    BEQ     loc_FFAA29C4 \n"
"    CMN     R0, #1 \n"
"    LDRNE   R0, =0x9200015 \n"
"    LDREQ   R0, =0x9200005 \n"
"    STR     R0, [R5, #0x10] \n"
"    B       loc_FFAA2950 \n"

"loc_FFAA29C4:\n"
"    SUB     R4, R4, R0 \n"
"    CMP     R4, R7 \n"
"    LDRCS   R2, =0x375 \n"
"    ADD     R8, R8, R0 \n"
"    LDRCS   R1, =0xFFAA2720 /*'dwFWrite.c'*/ \n"
"    MOVCS   R0, #0 \n"
"    BLCS    _DebugAssert \n"
"    CMP     R4, #0 \n"
"    BNE     loc_FFAA2964 \n"
"    LDR     R0, [R5] \n"
"    MOV     R1, R5 \n"
"    ADD     R0, R0, #1 \n"

"loc_FFAA29F4:\n"
"    LDMFD   SP!, {R4-R10,LR} \n"
"    B       sub_FFAA2174 \n"
"    .ltorg\n" //+
);
}

/*************************************************************/
//** sub_FFAA23CC_my @ 0xFFAA23CC - 0xFFAA240C, length=17
void __attribute__((naked,noinline)) sub_FFAA23CC_my() {
asm volatile (
"    STMFD   SP!, {R4-R6,LR} \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R0, #0x4C] \n"
"    LDR     R5, =0xB460 \n"
"    TST     R0, #2 \n"
"    SUB     SP, SP, #0x38 \n"
"    BEQ     sub_FFAA2534 \n"
"    LDR     R0, [R5, #4] \n"
"    CMN     R0, #1 \n"
"    BEQ     sub_FFAA2420 \n"
"    LDR     R1, [R4, #0x54] \n"
"    LDR     R6, =0x9200003 \n"
"    CMP     R1, #1 \n"
"    BNE     loc_FFAA240C \n"
//mod start
"    LDR R3, =current_write_ignored\n"
"    LDR R3, [R3]\n"
"    CMP R3, #0\n"
"    BNE loc_D\n" // jump over the next block
//mod end

"    BL      sub_FF827220 \n"
"    B       sub_FFAA2410 \n"

"loc_FFAA240C:\n"
"loc_D:\n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    LDR     PC, =0xFFAA2410 \n"  // Continue in firmware
);
}
