#include "lolevel.h"
#include "platform.h"
#include "core.h"

static long *nrflag = (long*)0x6DB0;    // ROM:FF970AA0 at taskcreate_ShutterSoundTask(), above String "ShutterSoundTask"

#include "../../../generic/capt_seq.c"

// ROM:FF87D2D8 task_CaptSeqTask()
void __attribute__((naked,noinline)) capt_seq_task() {
    asm volatile (
            "STMFD   SP!, {R3-R9,LR}\n"
            "LDR     R6, =0x2C7C\n"
            "LDR     R4, =0x396C4\n"
            "MOV     R9, #1\n"
            "MOV     R7, #0\n"
        "loc_FF87D2EC:\n"
            "LDR     R0, [R6,#4]\n"
            "MOV     R2, #0\n"
            "MOV     R1, SP\n"
            "BL      sub_FF83994C\n"             // LOCATION: KerQueue.c:0
            "TST     R0, #1\n"
            "BEQ     loc_FF87D318\n"
            "LDR     R1, =0x5BE\n"
            "LDR     R0, =0xFF87CE68\n"          // "SsShootTask.c"
            "BL      sub_FF81EB14\n"             // DebugAssert()
            "BL      sub_FF81EACC\n"             // eventproc_export_ExitTask()
            "LDMFD   SP!, {R3-R9,PC}\n"
        "loc_FF87D318:\n"
            "LDR     R0, [SP]\n"
            "LDR     R1, [R0]\n"
            "CMP     R1, #0x1D\n"
            "ADDLS   PC, PC, R1,LSL#2\n"
            "B       loc_FF87D62C\n"
        //"loc_FF87D32C:\n"
            "B       loc_FF87D3A4\n"
        //"loc_FF87D330:\n"
            "B       loc_FF87D408\n"
        //"loc_FF87D334:\n"
            "B       loc_FF87D4BC\n"
        //"loc_FF87D338:\n"
            "B       loc_FF87D4D0\n"
        //"loc_FF87D33C:\n"
            "B       loc_FF87D4C8\n"
        //"loc_FF87D340:\n"
            "B       loc_FF87D4D8\n"
        //"loc_FF87D344:\n"
            "B       loc_FF87D4E0\n"
        //"loc_FF87D348:\n"
            "B       loc_FF87D4E8\n"
        //"loc_FF87D34C:\n"
            "B       loc_FF87D540\n"
        //"loc_FF87D350:\n"
            "B       loc_FF87D568\n"
        //"loc_FF87D354:\n"
            "B       loc_FF87D54C\n"
        //"loc_FF87D358:\n"
            "B       loc_FF87D558\n"
        //"loc_FF87D35C:\n"
            "B       loc_FF87D560\n"
        //"loc_FF87D360:\n"
            "B       loc_FF87D570\n"
        //"loc_FF87D364:\n"
            "B       loc_FF87D578\n"
        //"loc_FF87D368:\n"
            "B       loc_FF87D580\n"
        //"loc_FF87D36C:\n"
            "B       loc_FF87D588\n"
        //"loc_FF87D370:\n"
            "B       loc_FF87D590\n"
        //"loc_FF87D374:\n"
            "B       loc_FF87D59C\n"
        //"loc_FF87D378:\n"
            "B       loc_FF87D5A4\n"
        //"loc_FF87D37C:\n"
            "B       loc_FF87D5AC\n"
        //"loc_FF87D380:\n"
            "B       loc_FF87D5B4\n"
        //"loc_FF87D384:\n"
            "B       loc_FF87D5BC\n"
        //"loc_FF87D388:\n"
            "B       loc_FF87D5C8\n"
        //"loc_FF87D38C:\n"
            "B       loc_FF87D5D0\n"
        //"loc_FF87D390:\n"
            "B       loc_FF87D5D8\n"
        //"loc_FF87D394:\n"
            "B       loc_FF87D5E0\n"
        //"loc_FF87D398:\n"
            "B       loc_FF87D5E8\n"
        //"loc_FF87D39C:\n"
            "B       loc_FF87D5F4\n"
        //"loc_FF87D3A0:\n"
            "B       loc_FF87D638\n"
        "loc_FF87D3A4:\n"                        // jumptable FF87D324 entry 0
            //"BL      shooting_expo_param_override\n"  // +, ToDo: required to make Canon OSD reflect Overrides like SD1000 (http://chdk.setepontos.com/index.php?topic=5574.msg61888#msg61888) ?
            "BL      sub_FF87DC9C\n"             // SsPrepareSeq.c

            "BL      shooting_expo_param_override\n"  // +
            "BL      sub_FF87AD78\n"

            // ToDo: do we need the short press hack ?
            // this code added to avoid some incorrect behavior if overrides are used.
            // but it can cause some unexpected side effects. In this case, remove this code!
            //"MOV     R0, #0\n"
            //"STR     R0, [R4,#0x24]\n"  // fixes overrides behavior at short shutter press

            "LDR     R0, [R4,#0x24]\n"
            "CMP     R0, #0\n"
            "BEQ     loc_FF87D638\n"
            "BL      sub_FF87CB48\n"
            "MOV     R5, R0\n"
            "LDR     R0, [R4,#0x24]\n"
            "CMP     R0, #0\n"
            "BEQ     loc_FF87D3EC\n"
            "MOV     R0, #0xC\n"
            "BL      sub_FF882264\n"
            "TST     R0, #1\n"
            "STRNE   R9, [R6,#0x10]\n"
            "LDRNE   R0, [R5,#8]\n"
            "ORRNE   R0, R0, #0x40000000\n"
            "STRNE   R0, [R5,#8]\n"
            "BNE     loc_FF87D638\n"
        "loc_FF87D3EC:\n"
            "MOV     R0, R5\n"
            "BL      sub_FF87CDEC\n"
            "MOV     R0, R5\n"

            //"BL      sub_FF970A8C\n"           // taskcreate_ShutterSoundTask()
            "BL      sub_FF970A8C_my\n"          // +
            "BL      capt_seq_hook_raw_here\n"   // +

            "TST     R0, #1\n"
            "STRNE   R9, [R6,#0x10]\n"
            "B       loc_FF87D638\n"
        "loc_FF87D408:\n"                        // jumptable FF87D324 entry 1
            "LDR     R1, [R4,#0x24]\n"
            "CMP     R1, #0\n"
            "BNE     loc_FF87D4AC\n"
            "LDR     R1, [R4,#0xB0]\n"
            "CMP     R1, #1\n"
            "BNE     loc_FF87D488\n"
            "LDRH    R1, [R4]\n"
            "LDR     R12, =0x820C\n"
            "CMP     R1, R12\n"
            "LDRNEH  R1, [R4,#0x92]\n"
            "CMPNE   R1, #3\n"
            "LDRNE   R0, [R0,#0xC]\n"
            "LDRNE   R0, [R0,#0xC]\n"
            "CMPNE   R0, #1\n"
            "BLS     loc_FF87D458\n"
            "BL      sub_FF832E04\n"             // LOCATION: Battery.c:0
            "TST     R0, #1\n"
            "BEQ     loc_FF87D4AC\n"
            "BL      sub_FF8822CC\n"
            "B       loc_FF87D498\n"
        "loc_FF87D458:\n"
            "MOV     R0, #0xC\n"
            "BL      sub_FF882264\n"
            "TST     R0, #1\n"
            "BEQ     loc_FF87D4AC\n"
            "LDR     R0, [SP]\n"
            "MOV     R1, #1\n"
            "LDR     R2, [R0,#0xC]\n"
            "MOV     R0, #1\n"
            "BL      sub_FF87B788\n"             // LOCATION: SsShootCtrl.c:0
            "BL      sub_FF971700\n"
            "BL      sub_FF87B434\n"
            "B       loc_FF87D638\n"
        "loc_FF87D488:\n"
            "MOV     R0, #0xC\n"
            "BL      sub_FF882264\n"
            "TST     R0, #1\n"
            "BEQ     loc_FF87D4AC\n"
        "loc_FF87D498:\n"
            "LDR     R0, [SP]\n"
            "MOV     R1, #1\n"
            "LDR     R2, [R0,#0xC]\n"
            "MOV     R0, #1\n"
            "B       loc_FF87D538\n"
        "loc_FF87D4AC:\n"
            "LDR     R0, [SP]\n"

            //"BL      sub_FF87D754\n"
            "BL      sub_FF87D754_my\n"          // +

        "loc_FF87D4B4:\n"
            "STR     R7, [R4,#0x24]\n"
            "B       loc_FF87D638\n"
        "loc_FF87D4BC:\n"                        // jumptable FF87D324 entry 2
            "MOV     R0, #1\n"
            "BL      sub_FF87DF40\n"             // LOCATION: SsPrepareSeq.c:0
            "B       loc_FF87D638\n"
        "loc_FF87D4C8:\n"                        // jumptable FF87D324 entry 4
            "BL      sub_FF87D924\n"
            "B       loc_FF87D4B4\n"
        "loc_FF87D4D0:\n"                        // jumptable FF87D324 entry 3
            "BL      sub_FF87DC7C\n"
            "B       loc_FF87D4B4\n"
        "loc_FF87D4D8:\n"                        // jumptable FF87D324 entry 5
            "BL      sub_FF87DC84\n"
            "B       loc_FF87D638\n"
        "loc_FF87D4E0:\n"                        // jumptable FF87D324 entry 6
            "BL      sub_FF87DE50\n"             // SsPrepareSeq.c 0
            "B       loc_FF87D544\n"
        "loc_FF87D4E8:\n"                        // jumptable FF87D324 entry 7
            "LDR     R5, [R0,#0xC]\n"
            "BL      sub_FF87DC8C\n"
            "MOV     R0, R5\n"
            "BL      sub_FF96F8A4\n"             // LOCATION: SsPrePreSeq.c:1024
            "TST     R0, #1\n"
            "MOV     R8, R0\n"
            "BNE     loc_FF87D528\n"
            "BL      sub_FF88F7F0\n"             // LOCATION: PropertyCase.c:0
            "STR     R0, [R5,#0x18]\n"
            "MOV     R0, R5\n"
            "BL      sub_FF9709A4\n"             // LOCATION: SsCaptureSeq.c:1
            "MOV     R0, R5\n"
            "BL      sub_FF970D48\n"             // LOCATION: SsCaptureSeq.c:0
            "MOV     R8, R0\n"
            "LDR     R0, [R5,#0x18]\n"
            "BL      sub_FF88FA28\n"             // LOCATION: PropertyCase.c:0
        "loc_FF87D528:\n"
            "BL      sub_FF87DC7C\n"
            "MOV     R2, R5\n"
            "MOV     R1, #9\n"
            "MOV     R0, R8\n"
        "loc_FF87D538:\n"
            "BL      sub_FF87B788\n"             // SsShootCtrl.c 0
            "B       loc_FF87D638\n"
        "loc_FF87D540:\n"                        // jumptable FF87D324 entry 8
            "BL      sub_FF87DEB8\n"             // SsPrepareSeq.c 0
        "loc_FF87D544:\n"
            "BL      sub_FF87AD78\n"
            "B       loc_FF87D638\n"
        "loc_FF87D54C:\n"                        // jumptable FF87D324 entry 10
            "LDR     R0, [R4,#0x54]\n"
            "BL      sub_FF87E3B0\n"             // SsMovieRec.c 186
            "B       loc_FF87D638\n"
        "loc_FF87D558:\n"                        // jumptable FF87D324 entry 11
            "BL      sub_FF87E688\n"             // SsMovieRec.c 2
            "B       loc_FF87D638\n"
        "loc_FF87D560:\n"                        // jumptable FF87D324 entry 12
            "BL      sub_FF87E720\n"             // SsMovieRec.c 632
            "B       loc_FF87D638\n"
        "loc_FF87D568:\n"                        // jumptable FF87D324 entry 9
            "BL      sub_FF87DC7C\n"
            "B       loc_FF87D638\n"
        "loc_FF87D570:\n"                        // jumptable FF87D324 entry 13
            "BL      sub_FF96FAD0\n"
            "B       loc_FF87D638\n"
        "loc_FF87D578:\n"                        // jumptable FF87D324 entry 14
            "BL      sub_FF96FCE4\n"
            "B       loc_FF87D638\n"
        "loc_FF87D580:\n"                        // jumptable FF87D324 entry 15
            "BL      sub_FF96FD7C\n"             // SsExpCompSeq.c 115
            "B       loc_FF87D638\n"
        "loc_FF87D588:\n"                        // jumptable FF87D324 entry 16
            "BL      sub_FF96FE4C\n"
            "B       loc_FF87D638\n"
        "loc_FF87D590:\n"                        // jumptable FF87D324 entry 17
            "MOV     R0, #0\n"
            "BL      sub_FF9700B4\n"
            "B       loc_FF87D638\n"
        "loc_FF87D59C:\n"                        // jumptable FF87D324 entry 18
            "BL      sub_FF970214\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5A4:\n"                        // jumptable FF87D324 entry 19
            "BL      sub_FF9702B0\n"             // SsMFSeq.c 110
            "B       loc_FF87D638\n"
        "loc_FF87D5AC:\n"                        // jumptable FF87D324 entry 20
            "BL      sub_FF970390\n"             // SsMFSeq.c 188
            "B       loc_FF87D638\n"
        "loc_FF87D5B4:\n"                        // jumptable FF87D324 entry 21
            "BL      sub_FF87E0C8\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5BC:\n"                        // jumptable FF87D324 entry 22
            "BL      sub_FF87E170\n"
            "BL      sub_FF83794C\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5C8:\n"                        // jumptable FF87D324 entry 23
            "BL      sub_FF96FF18\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5D0:\n"                        // jumptable FF87D324 entry 24
            "BL      sub_FF96FF84\n"             // SsChgExpSeq.c 440
            "B       loc_FF87D638\n"
        "loc_FF87D5D8:\n"                        // jumptable FF87D324 entry 25
            "BL      sub_FF880858\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5E0:\n"                        // jumptable FF87D324 entry 26
            "BL      sub_FF8808E0\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5E8:\n"                        // jumptable FF87D324 entry 27
            "BL      sub_FF88093C\n"
            "BL      sub_FF8808FC\n"
            "B       loc_FF87D638\n"
        "loc_FF87D5F4:\n"                        // jumptable FF87D324 entry 28
            "MOV     R0, #1\n"
            "BL      sub_FF971874\n"
            "MOV     R0, #1\n"
            "BL      sub_FF9719A8\n"
            "LDRH    R0, [R4,#0x94]\n"
            "CMP     R0, #4\n"
            "LDRNEH  R0, [R4]\n"
            "SUBNE   R12, R0, #0x8200\n"
            "SUBNES  R12, R12, #0x2A\n"
            "BNE     loc_FF87D638\n"
            "BL      sub_FF8808E0\n"
            "BL      sub_FF880E50\n"
            "BL      sub_FF880D60\n"             // LOCATION: SsLiveFunc.c:0
            "B       loc_FF87D638\n"
        "loc_FF87D62C:\n"                        // jumptable FF87D324 default entry
            "LDR     R1, =0x72C\n"
            //"ADR     R0, 0xFF87CE68\n"         // "SsShootTask.c"
            "LDR     R0, =0xFF87CE68\n"          // compiler does not like ADR
            "BL      sub_FF81EB14\n"             // DebugAssert()
        "loc_FF87D638:\n"                    // jumptable FF87D324 entry 29
            "LDR     R0, [SP]\n"
            "LDR     R1, [R0,#4]\n"
            "LDR     R0, [R6]\n"
            "BL      sub_FF8873E4\n"
            "LDR     R5, [SP]\n"
            "LDR     R0, [R5,#8]\n"
            "CMP     R0, #0\n"
            "LDREQ   R1, =0x132\n"
            "LDREQ   R0, =0xFF87CE68\n"          // "SsShootTask.c"
            "BLEQ    sub_FF81EB14\n"             // DebugAssert()
            "STR     R7, [R5,#8]\n"
            "B       loc_FF87D2EC\n"
    );
}

// ROM:FF970A8C taskcreate_ShutterSoundTask(), LOCATION: SsCaptureSeq.c:0
void __attribute__((naked,noinline)) sub_FF970A8C_my() {
    asm volatile (
            "STMFD   SP!, {R0-R8,LR}\n"
            "MOV     R4, R0\n"
            "BL      sub_FF971B78\n"             // LOCATION: SsShootEvent.c:76
            "MVN     R1, #0\n"                   // original ?!?
            //"MOV     R1, #0xFFFFFFFF\n"
            //"LDR    R1,=0xFFFFFFFF\n"          // like G11
            "BL      sub_FF887418\n"
            "LDR     R5, =0x6DB0\n"
            "LDR     R0, [R5,#0xC]\n"
            "CMP     R0, #0\n"
            "BNE     loc_FF970ADC\n"
            "MOV     R1, #1\n"
            "MOV     R0, #0\n"
            "BL      sub_FF83A194\n"             // LOCATION: KernelMisc.c:31
            "STR     R0, [R5,#0xC]\n"
            "MOV     R3, #0\n"
            "STR     R3, [SP]\n"
            "LDR     R3, =0xFF970488\n"          // task_ShutterSoundTask(), LOCATION: SsCaptureSeq.c:187
            //"ADR     R0, 0xFF970D18\n"         // "ShutterSoundTask"
            "LDR     R0, =0xFF970D18\n"          // compiler does not like ADR
            "MOV     R2, #0x400\n"
            "MOV     R1, #0x17\n"
            "BL      sub_FF83A160\n"             // KernelCreateTask(), LOCATION: KernelMisc.c:19
        "loc_FF970ADC:\n"
            "MOV     R2, #4\n"
            "ADD     R1, SP, #8\n"
            "MOV     R0, #0x8A\n"
            "BL      sub_FF88F660\n"             // PT_GetPropertyCaseString(), LOCATION: PropertyCase.c:0
            "TST     R0, #1\n"
            "LDRNE   R1, =0x3EA\n"
            "LDRNE   R0, =0xFF9706D4\n"          // "SsCaptureSeq.c"
            "BLNE    sub_FF81EB14\n"             // DebugAssert()
            "LDR     R6, =0x3978C\n"
            "LDR     R7, =0x396C4\n"
            "LDR     R3, [R6]\n"
            "LDRSH   R2, [R6,#0xC]\n"
            "LDRSH   R1, [R6,#0xE]\n"
            "LDR     R0, [R7,#0x88]\n"
            "BL      sub_FF936770\n"
            "BL      sub_FF86522C\n"             // GetCCDTemperature(), LOCATION: Thermometer.c:0
            "LDR     R3, =0x6DB8\n"
            "STRH    R0, [R4,#0xA4]\n"
            "SUB     R2, R3, #4\n"
            "STRD    R2, [SP]\n"
            "MOV     R1, R0\n"
            "LDRH    R0, [R7,#0x5C]\n"
            "LDRSH   R2, [R6,#0xC]\n"
            "SUB     R3, R3, #8\n"
            "BL      sub_FF973794\n"

            "BL      wait_until_remote_button_is_released\n"   // +
            "BL      capt_seq_hook_set_nr\n"     // +

            "B       sub_FF970B40\n"             // + continue in canon firmware

        /*
            "LDR     R0, [R4,#0x1C]\n"
            "CMP     R0, #0\n"
            "MOVNE   R0, #1\n"
            "STRNE   R0, [R5]\n"
            "LDR     R0, [R5]\n"
            "MOV     R1, R0,LSL#16\n"
            "LDRH    R0, [R7,#0x5C]\n"
            "MOV     R1, R1,LSR#16\n"
            "BL      sub_FF97390C\n"
            "STR     R0, [R4,#0xAC]\n"
            "LDR     R0, [R5,#4]\n"
            "BL      sub_FF93A77C\n"             // LOCATION: DefMarkMan.c:0
            "LDR     R0, [R5,#8]\n"
            "BL      sub_FF8B8C50\n"
            "MOV     R0, #1\n"
            "BL      sub_FF8B8C68\n"             // nullsub_234()
            "LDR     R0, =0xFF970518\n"          // LOCATION: SsCaptureSeq.c:252
            "MOV     R1, R4\n"
            "BL      sub_FF8B8C2C\n"
            "BL      sub_FF87FF9C\n"             // LOCATION: SsImgCtrl.c:0
            "LDR     R0, [R5]\n"
            "CMP     R0, #7\n"
            "ADDLS   PC, PC, R0,LSL#2\n"
            "B       loc_FF970C60\n"
                    "loc_FF970BA0:\n"
            "B       loc_FF970C60\n"
                    "loc_FF970BA4:\n"
            "B       loc_FF970BC0\n"
                    "loc_FF970BA8:\n"
            "B       loc_FF970BC8\n"
                    "loc_FF970BAC:\n"
            "B       loc_FF970BE8\n"
                    "loc_FF970BB0:\n"
            "B       loc_FF970C04\n"
                    "loc_FF970BB4:\n"
            "B       loc_FF970C20\n"
                    "loc_FF970BB8:\n"
            "B       loc_FF970C28\n"
                    "loc_FF970BBC:\n"
            "B       loc_FF970C44\n"
                    "loc_FF970BC0:\n"                        // jumptable FF970B98 entry 1
            "MOV     R0, #1\n"
            "B       loc_FF970C48\n"
                    "loc_FF970BC8:\n"                        // jumptable FF970B98 entry 2
            "MOV     R0, #1\n"
            "BL      sub_FF8B8C5C\n"
            "LDR     R2, [SP,#8]\n"
            "ADD     R1, SP, #0xC\n"
            "MOV     R0, R4\n"
            "BL      sub_FF970E0C\n"
                    "loc_FF970BE0:\n"
            "MOV     R8, R0\n"
            "B       loc_FF970C6C\n"
                    "loc_FF970BE8:\n"                        //jumptable FF970B98 entry 3
            "MOV     R0, #1\n"
            "BL      sub_FF8B8C5C\n"
            "LDR     R2, [SP,#8]\n"
            "ADD     R1, SP, #0xC\n"
            "MOV     R0, R4\n"
            "BL      sub_FF970EFC\n"             // LOCATION: SsCaptureSeq.c:7
            "B       loc_FF970BE0\n"
                    "loc_FF970C04:\n"                        // jumptable FF970B98 entry 4
            "MOV     R0, #1\n"
            "BL      sub_FF8B8C5C\n"
            "LDR     R2, [SP,#8]\n"
            "ADD     R1, SP, #0xC\n"
            "MOV     R0, R4\n"
            "BL      sub_FF97102C\n"
            "B       loc_FF970BE0\n"
                    "loc_FF970C20:\n"                        // jumptable FF970B98 entry 5
            "MOV     R0, #1\n"
            "B       loc_FF970C2C\n"
        "loc_FF970C28:\n"                    // jumptable FF970B98 entry 6
            "MOV     R0, #0\n"
                    "loc_FF970C2C:\n"
            "BL      sub_FF8B8C5C\n"
            "LDR     R2, [SP,#8]\n"
            "ADD     R1, SP, #0x1C\n"
            "MOV     R0, R4\n"
            "BL      sub_FF9708A8\n"
            "B       loc_FF970BE0\n"
                    "loc_FF970C44:\n"                        // jumptable FF970B98 entry 7
            "MOV     R0, #0\n"
                    "loc_FF970C48:\n"
            "BL      sub_FF8B8C5C\n"
            "LDR     R2, [SP,#8]\n"
            "ADD     R1, SP, #0xC\n"
            "MOV     R0, R4\n"
            "BL      sub_FF970814\n"
            "B       loc_FF970BE0\n"
                    "loc_FF970C60:\n"                        // jumptable FF970B98 default entry, jumptable FF970B98 entry 0
            "LDR     R1, =0x449\n"
            "LDR     R0, =0xFF9706D4\n"          // "SsCaptureSeq.c"
            "BL      sub_FF81EB14\n"             // DebugAssert()
                    "loc_FF970C6C:\n"
            "TST     R8, #1\n"
            "MOVNE   R0, R8\n"
            "BNE     loc_FF970CEC\n"
            "MOV     R1, #0\n"
            //"ADR     R0, 0xFF970554\n"         // nullsub_296()
            "LDR     R0, =0xFF970554\n"          // compiler does not like ADR
            "BL      sub_FF8B8C2C\n"
            "LDRH    R0, [R7]\n"
            "SUB     R12, R0, #0x8000\n"
            "SUBS    R12, R12, #0x20C\n"
            "BLEQ    sub_FF8A3DF8\n"
            "LDR     R2, =0x6DB4\n"
            "LDR     R0, [R4,#0x18]\n"
            "MOV     R3, #4\n"
            "MOV     R1, #0x45\n"
            "BL      sub_FF88FB44\n"             // LOCATION: PropertyCase.c:496
            "MOV     R0, #1\n"
            "BL      sub_FF9367DC\n"
            "STR     R0, [R4,#0xD8]\n"
            "BL      sub_FF971B78\n"             // LOCATION: SsShootEvent.c:76
            "LDR     R5, =0x469\n"
            //"ADR     R3, 0xFF9706D4\n"         // "SsCaptureSeq.c"
            "LDR     R3, =0xFF9706D4\n"          // compiler does not like ADR
            "STR     R5, [SP]\n"
            "LDR     R2, =0x3A98\n"
            "MOV     R1, #4\n"
            "BL      sub_FF8825E0\n"
            "CMP     R0, #0\n"
            "LDRNE   R0, =0xFF9706D4\n"          // "SsCaptureSeq.c"
            "MOVNE   R1, R5\n"
            "BLNE    sub_FF81EB14\n"             // DebugAssert()
            "LDRH    R0, [SP,#0xC]\n"
            "STRH    R0, [R4,#0x14]\n"
            "MOV     R0, #0\n"
                    "loc_FF970CEC:\n"
            "ADD     SP, SP, #0x10\n"
            "LDMFD   SP!, {R4-R8,PC}\n"
        */
    );
}

void __attribute__((naked,noinline)) sub_FF87D754_my() {
    asm volatile (
            "STMFD   SP!, {R4-R6,LR}\n"
            "LDR     R4, [R0,#0xC]\n"
            "LDR     R5, =0x396C4\n"
            "LDR     R0, [R4,#8]\n"
            "MOV     R6, #0\n"
            "ORR     R0, R0, #1\n"
            "STR     R0, [R4,#8]\n"
            "LDR     R0, [R5,#0x24]\n"
            "CMP     R0, #0\n"
            "BNE     loc_FF87D7B0\n"
            "LDR     R0, [R5,#0xB0]\n"
            "CMP     R0, #1\n"
            "BNE     loc_FF87D7A8\n"
            "LDRH    R0, [R5]\n"
            "LDR     R12, =0x820C\n"
            "CMP     R0, R12\n"
            "LDRNEH  R0, [R5,#0x92]\n"
            "CMPNE   R0, #3\n"
            "LDRNE   R0, [R4,#0xC]\n"
            "CMPNE   R0, #1\n"
            "BHI     loc_FF87D7B0\n"
        "loc_FF87D7A8:\n"
            "MOV     R0, #2\n"
            "BL      sub_FF87941C\n"
        "loc_FF87D7B0:\n"
            "BL      sub_FF87DC8C\n"
            "LDR     R0, [R5,#0x24]\n"
            "CMP     R0, #0\n"
            "BNE     loc_FF87D84C\n"
            "MOV     R0, #0\n"
            "BL      sub_FF971874\n"
            "MOV     R0, #0\n"
            "BL      sub_FF9719A8\n"
            "MOV     R0, R4\n"
            "BL      sub_FF87E070\n"
            "MOV     R0, R4\n"
            "BL      sub_FF96F4AC\n"
            "CMP     R0, #0\n"
            "BEQ     loc_FF87D814\n"
            "BL      sub_FF9718B4\n"
            "BL      sub_FF9719EC\n"
            "BL      sub_FF971A3C\n"
            "MOV     R0, R4\n"
            "BL      sub_FF96F590\n"             // LOCATION: SsPrePreSeq.c:0
            "TST     R0, #1\n"
            "MOVNE   R2, R4\n"
            "LDMNEFD SP!, {R4-R6,LR}\n"
            "MOVNE   R1, #1\n"
            "BNE     sub_FF87B788\n"             // LOCATION: SsShootCtrl.c:0
            "B       loc_FF87D828\n"
        "loc_FF87D814:\n"
            "MOV     R0, R4\n"
            "BL      sub_FF96F52C\n"
            "BL      sub_FF9718B4\n"
            "BL      sub_FF9719EC\n"
            "BL      sub_FF971A3C\n"
        "loc_FF87D828:\n"
            "MOV     R0, R4\n"
            "BL      sub_FF87CDEC\n"
            "MOV     R0, R4\n"
            "BL      sub_FF9709A4\n"             // LOCATION: SsCaptureSeq.c:1
            "BL      sub_FF971640\n"             // LOCATION: SsShootLib.c:4096
            "MOV     R0, R4\n"

            //"BL      sub_FF970A8C\n"           // taskcreate_ShutterSoundTask(), LOCATION: SsCaptureSeq.c:0
            "BL      sub_FF970A8C_my\n"          // +

            "MOV     R6, R0\n"

            //"BL      capt_seq_hook_raw_here\n"   // +

            "B       loc_FF87D85C\n"
        "loc_FF87D84C:\n"
            "LDR     R0, =0x2C7C\n"
            "LDR     R0, [R0,#0x10]\n"
            "CMP     R0, #0\n"
            "MOVNE   R6, #0x1D\n"
        "loc_FF87D85C:\n"
            "BL      capt_seq_hook_raw_here\n"   // + (like D10)

            "BL      sub_FF8808E0\n"
            "BL      sub_FF880928\n"
            "BL      sub_FF880968\n"
            "MOV     R2, R4\n"
            "MOV     R1, #1\n"
            "MOV     R0, R6\n"
            "BL      sub_FF87B788\n"             // LOCATION: SsShootCtrl.c:0
            "BL      sub_FF9707C8\n"
            "CMP     R0, #0\n"
            "LDRNE   R0, [R4,#8]\n"
            "ORRNE   R0, R0, #0x2000\n"
            "STRNE   R0, [R4,#8]\n"
            "LDMFD   SP!, {R4-R6,PC}\n"
    );
}

// ROM:FF8C25DC task_ExpDrvTask()
void __attribute__((naked,noinline)) exp_drv_task() {
    asm volatile (
            "STMFD   SP!, {R4-R8,LR}\n"
            "SUB     SP, SP, #0x20\n"
            "LDR     R8, =0xBB8\n"
            "LDR     R7, =0x43E4\n"
            "LDR     R5, =0x42D18\n"
            "MOV     R0, #0\n"
            "ADD     R6, SP, #0x10\n"
            "STR     R0, [SP,#0xC]\n"
        "loc_FF8C25FC:\n"
            "LDR     R0, [R7,#0x20]\n"
            "MOV     R2, #0\n"
            "ADD     R1, SP, #0x1C\n"
            "BL      sub_FF83994C\n"        // LOCATION: KerQueue.c:0\n"
            "LDR     R0, [SP,#0xC]\n"
            "CMP     R0, #1\n"
            "BNE     loc_FF8C2648\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R0, [R0]\n"
            "CMP     R0, #0x14\n"
            "CMPNE   R0, #0x15\n"
            "CMPNE   R0, #0x16\n"
            "CMPNE   R0, #0x17\n"
            "BEQ     loc_FF8C27AC\n"
            "CMP     R0, #0x29\n"
            "BEQ     loc_FF8C2734\n"
            "ADD     R1, SP, #0xC\n"
            "MOV     R0, #0\n"
            "BL      sub_FF8C258C\n"        // LOCATION: ExpDrv.c:512\n"
        "loc_FF8C2648:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R1, [R0]\n"
            "CMP     R1, #0x2F\n"
            "BNE     loc_FF8C2678\n"
            "LDR     R0, [SP,#0x1C]\n"
            "BL      sub_FF8C39C0\n"        // LOCATION: ExpDrv.c:0\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R1, #1\n"
            "BL      sub_FF8873E4\n"
            "BL      sub_FF81EACC\n"        // eventproc_export_ExitTask(), LOCATION: KerTask.c:0
            "ADD     SP, SP, #0x20\n"
            "LDMFD   SP!, {R4-R8,PC}\n"
        "loc_FF8C2678:\n"
            "CMP     R1, #0x2E\n"
            "BNE     loc_FF8C2694\n"
            "LDR     R2, [R0,#0x8C]!\n"
            "LDR     R1, [R0,#4]\n"
            "MOV     R0, R1\n"
            "BLX     R2\n"
            "B       loc_FF8C2BE0\n"
        "loc_FF8C2694:\n"
            "CMP     R1, #0x27\n"
            "BNE     loc_FF8C26E4\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R1, #0x80\n"
            "BL      sub_FF887418\n"
            "LDR     R0, =0xFF8BEA6C\n"
            "MOV     R1, #0x80\n"
            "BL      sub_FF963560\n"        // LOCATION: IrisController.c:98\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R2, R8\n"
            "MOV     R1, #0x80\n"
            "BL      sub_FF887324\n"        // LOCATION: KerFlag.c:0\n"
            "TST     R0, #1\n"
            "LDRNE   R1, =0xEE7\n"
            "BNE     loc_FF8C27A0\n"
        "loc_FF8C26D0:\n"
            "LDR     R1, [SP,#0x1C]\n"
            "LDR     R0, [R1,#0x90]\n"
            "LDR     R1, [R1,#0x8C]\n"
            "BLX     R1\n"
            "B       loc_FF8C2BE0\n"
        "loc_FF8C26E4:\n"
            "CMP     R1, #0x28\n"
            "BNE     loc_FF8C272C\n"
            "ADD     R1, SP, #0xC\n"
            "BL      sub_FF8C258C\n"        // LOCATION: ExpDrv.c:512\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R1, #0x100\n"
            "BL      sub_FF887418\n"
            "LDR     R0, =0xFF8BEA7C\n"
            "MOV     R1, #0x100\n"
            "BL      sub_FF963F90\n"        // LOCATION: IrisController.c:0\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R2, R8\n"
            "MOV     R1, #0x100\n"
            "BL      sub_FF887324\n"        // LOCATION: KerFlag.c:0\n"
            "TST     R0, #1\n"
            "BEQ     loc_FF8C26D0\n"
            "LDR     R1, =0xEF1\n"
            "B       loc_FF8C27A0\n"
        "loc_FF8C272C:\n"
            "CMP     R1, #0x29\n"
            "BNE     loc_FF8C2744\n"
        "loc_FF8C2734:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "ADD     R1, SP, #0xC\n"
            "BL      sub_FF8C258C\n"        // LOCATION: ExpDrv.c:512\n"
            "B       loc_FF8C26D0\n"
        "loc_FF8C2744:\n"
            "CMP     R1, #0x2C\n"
            "BNE     loc_FF8C275C\n"
            "BL      sub_FF8B12D4\n"        // LOCATION: Shutter.c:2\n"
            "BL      sub_FF8B1EF4\n"        // LOCATION: ImgPixel.c:272\n"
            "BL      sub_FF8B1A58\n"        // LOCATION: ImgGain.c:0\n"
            "B       loc_FF8C26D0\n"
        "loc_FF8C275C:\n"
            "CMP     R1, #0x2D\n"
            "BNE     loc_FF8C27AC\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R1, #4\n"
            "BL      sub_FF887418\n"
            "LDR     R1, =0xFF8BEA9C\n"
            "LDR     R0, =0xFFFFF400\n"
            "MOV     R2, #4\n"
            "BL      sub_FF8B0D50\n"
            "BL      sub_FF8B0FD8\n"        // LOCATION: Shutter.c:0\n"
            "LDR     R0, [R7,#0x1C]\n"
            "MOV     R2, R8\n"
            "MOV     R1, #4\n"
            "BL      sub_FF887240\n"        // LOCATION: KerFlag.c:0\n"
            "TST     R0, #1\n"
            "BEQ     loc_FF8C26D0\n"
            "LDR     R1, =0xF19\n"
        "loc_FF8C27A0:\n"
            "LDR     R0, =0xFF8BF130\n"     // "ExpDrv.c"
            "BL      sub_FF81EB14\n"    // DebugAssert()
            "B       loc_FF8C26D0\n"
        "loc_FF8C27AC:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "MOV     R4, #1\n"
            "LDR     R1, [R0]\n"
            "CMP     R1, #0x12\n"
            "CMPNE   R1, #0x13\n"
            "BNE     loc_FF8C281C\n"
            "LDR     R1, [R0,#0x7C]\n"
            "ADD     R1, R1, R1,LSL#1\n"
            "ADD     R1, R0, R1,LSL#2\n"
            "SUB     R1, R1, #8\n"
            "LDMIA   R1, {R2-R4}\n"
            "STMIA   R6, {R2-R4}\n"
            "BL      sub_FF8C0F58\n"        // LOCATION: ExpDrv.c:2\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R1, [R0,#0x7C]\n"
            "LDR     R3, [R0,#0x8C]\n"
            "LDR     R2, [R0,#0x90]\n"
            "ADD     R0, R0, #4\n"
            "BLX     R3\n"
            "LDR     R0, [SP,#0x1C]\n"
            "BL      sub_FF8C3D7C\n"        // LOCATION: ExpDrv.c:0\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R1, [R0,#0x7C]\n"
            "LDR     R3, [R0,#0x94]\n"
            "LDR     R2, [R0,#0x98]\n"
            "ADD     R0, R0, #4\n"
            "BLX     R3\n"
            "B       loc_FF8C2B20\n"
        "loc_FF8C281C:\n"
            "CMP     R1, #0x14\n"
            "CMPNE   R1, #0x15\n"
            "CMPNE   R1, #0x16\n"
            "CMPNE   R1, #0x17\n"
            "BNE     loc_FF8C28D4\n"
            "ADD     R3, SP, #0xC\n"
            "MOV     R2, SP\n"
            "ADD     R1, SP, #0x10\n"
            "BL      sub_FF8C11AC\n"        // LOCATION: ExpDrv.c:0\n"
            "CMP     R0, #1\n"
            "MOV     R4, R0\n"
            "CMPNE   R4, #5\n"
            "BNE     loc_FF8C2870\n"
            "LDR     R0, [SP,#0x1C]\n"
            "MOV     R2, R4\n"
            "LDR     R1, [R0,#0x7C]!\n"
            "LDR     R12, [R0,#0x10]!\n"
            "LDR     R3, [R0,#4]\n"
            "MOV     R0, SP\n"
            "BLX     R12\n"
            "B       loc_FF8C28A8\n"
        "loc_FF8C2870:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "CMP     R4, #2\n"
            "LDR     R3, [R0,#0x90]\n"
            "CMPNE   R4, #6\n"
            "BNE     loc_FF8C28BC\n"
            "LDR     R12, [R0,#0x8C]\n"
            "MOV     R0, SP\n"
            "MOV     R2, R4\n"
            "MOV     R1, #1\n"
            "BLX     R12\n"
            "LDR     R0, [SP,#0x1C]\n"
            "MOV     R2, SP\n"
            "ADD     R1, SP, #0x10\n"
            "BL      sub_FF8C22D8\n"        // LOCATION: ExpDrv.c:0\n"
        "loc_FF8C28A8:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R2, [SP,#0xC]\n"
            "MOV     R1, R4\n"
            "BL      sub_FF8C252C\n"        // LOCATION: ExpDrv.c:2\n"
            "B       loc_FF8C2B20\n"
        "loc_FF8C28BC:\n"
            "LDR     R1, [R0,#0x7C]\n"
            "LDR     R12, [R0,#0x8C]\n"
            "ADD     R0, R0, #4\n"
            "MOV     R2, R4\n"
            "BLX     R12\n"
            "B       loc_FF8C2B20\n"
        "loc_FF8C28D4:\n"
            "CMP     R1, #0x23\n"
            "CMPNE   R1, #0x24\n"
            "BNE     loc_FF8C2920\n"
            "LDR     R1, [R0,#0x7C]\n"
            "ADD     R1, R1, R1,LSL#1\n"
            "ADD     R1, R0, R1,LSL#2\n"
            "SUB     R1, R1, #8\n"
            "LDMIA   R1, {R2-R4}\n"
            "STMIA   R6, {R2-R4}\n"
            "BL      sub_FF8C021C\n"        // LOCATION: ExpDrv.c:0\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R1, [R0,#0x7C]\n"
            "LDR     R3, [R0,#0x8C]\n"
            "LDR     R2, [R0,#0x90]\n"
            "ADD     R0, R0, #4\n"
            "BLX     R3\n"
            "LDR     R0, [SP,#0x1C]\n"
            "BL      sub_FF8C051C\n"        // LOCATION: ExpDrv.c:0
            "B       loc_FF8C2B20\n"
        "loc_FF8C2920:\n"
            "ADD     R1, R0, #4\n"
            "LDMIA   R1, {R2,R3,R12}\n"
            "STMIA   R6, {R2,R3,R12}\n"
            "LDR     R1, [R0]\n"
            "CMP     R1, #0x26\n"
            "ADDLS   PC, PC, R1,LSL#2\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C293C:\n"
            "B       loc_FF8C29D8\n"
        "loc_FF8C2940:\n"
            "B       loc_FF8C29D8\n"
        "loc_FF8C2944:\n"
            "B       loc_FF8C29E0\n"
        "loc_FF8C2948:\n"
            "B       loc_FF8C29E8\n"
        "loc_FF8C294C:\n"
            "B       loc_FF8C29E8\n"
        "loc_FF8C2950:\n"
            "B       loc_FF8C29E8\n"
        "loc_FF8C2954:\n"
            "B       loc_FF8C29D8\n"
        "loc_FF8C2958:\n"
            "B       loc_FF8C29E0\n"
        "loc_FF8C295C:\n"
            "B       loc_FF8C29E8\n"
        "loc_FF8C2960:\n"
            "B       loc_FF8C29E8\n"
        "loc_FF8C2964:\n"
            "B       loc_FF8C2A00\n"
        "loc_FF8C2968:\n"
            "B       loc_FF8C2A00\n"
        "loc_FF8C296C:\n"
         "B       loc_FF8C2AEC\n"
        "loc_FF8C2970:\n"
            "B       loc_FF8C2AF4\n"
        "loc_FF8C2974:\n"
            "B       loc_FF8C2AF4\n"
        "loc_FF8C2978:\n"
            "B       loc_FF8C2AF4\n"
        "loc_FF8C297C:\n"
            "B       loc_FF8C2AF4\n"
        "loc_FF8C2980:\n"
            "B       loc_FF8C2AFC\n"
        "loc_FF8C2984:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C2988:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C298C:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C2990:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C2994:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C2998:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C299C:\n"
            "B       loc_FF8C29F0\n"
        "loc_FF8C29A0:\n"
            "B       loc_FF8C29F8\n"
        "loc_FF8C29A4:\n"
            "B       loc_FF8C29F8\n"
        "loc_FF8C29A8:\n"
            "B       loc_FF8C2A0C\n"
        "loc_FF8C29AC:\n"
            "B       loc_FF8C2A0C\n"
        "loc_FF8C29B0:\n"
            "B       loc_FF8C2A14\n"
        "loc_FF8C29B4:\n"
            "B       loc_FF8C2A44\n"
        "loc_FF8C29B8:\n"
            "B       loc_FF8C2A74\n"
        "loc_FF8C29BC:\n"
            "B       loc_FF8C2AA4\n"
        "loc_FF8C29C0:\n"
            "B       loc_FF8C2AD4\n"
        "loc_FF8C29C4:\n"
            "B       loc_FF8C2AD4\n"
        "loc_FF8C29C8:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C29CC:\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C29D0:\n"
            "B       loc_FF8C2ADC\n"
        "loc_FF8C29D4:\n"
            "B       loc_FF8C2AE4\n"
        "loc_FF8C29D8:\n"                   // jumptable FF8C2934 entries 0,1,6
            "BL      sub_FF8BEF8C\n"        // ExpDrv.c 0
        "B       loc_FF8C2B00\n"
            "loc_FF8C29E0:\n"                   // jumptable FF8C2934 entries 2,7
        "BL      sub_FF8BF25C\n"        // ExpDrv.c 0
            "B       loc_FF8C2B00\n"
        "loc_FF8C29E8:\n"                   // jumptable FF8C2934 entries 3-5,8,9
            "BL      sub_FF8BF4A4\n"        // ExpDrv.c 0
            "B       loc_FF8C2B00\n"
        "loc_FF8C29F0:\n"                   // jumptable FF8C2934 entry 24
            "BL      sub_FF8BF6F4\n"        // ExpDrv.c 2
            "B       loc_FF8C2B00\n"
        "loc_FF8C29F8:\n"                   // jumptable FF8C2934 entries 25,26
            "BL      sub_FF8BF8EC\n"        // ExpDrv.c 0
            "B       loc_FF8C2B00\n"
        "loc_FF8C2A00:\n"                   // jumptable FF8C2934 entries 10,11
            "BL      sub_FF8BFBA8\n"        // ExpDrv.c 2
            "MOV     R4, #0\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C2A0C:\n"                   // jumptable FF8C2934 entries 27,28
            "BL      sub_FF8BFCE8\n"        // ExpDrv.c 0
            "B       loc_FF8C2B00\n"
        "loc_FF8C2A14:\n"                   // jumptable FF8C2934 entry 29
            "LDRH    R1, [R0,#4]\n"
            "STRH    R1, [SP,#0x10]\n"
            "LDRH    R1, [R5,#2]\n"
            "STRH    R1, [SP,#0x12]\n"
            "LDRH    R1, [R5,#4]\n"
            "STRH    R1, [SP,#0x14]\n"
            "LDRH    R1, [R5,#6]\n"
            "STRH    R1, [SP,#0x16]\n"
            "LDRH    R1, [R0,#0xC]\n"
            "STRH    R1, [SP,#0x18]\n"
            "BL      sub_FF8C3A34\n"         // LOCATION: ExpDrv.c:2
            "B       loc_FF8C2B00\n"
        "loc_FF8C2A44:\n"                   // jumptable FF8C2934 entry 30
            "LDRH    R1, [R0,#4]\n"
            "STRH    R1, [SP,#0x10]\n"
            "LDRH    R1, [R5,#2]\n"
            "STRH    R1, [SP,#0x12]\n"
            "LDRH    R1, [R5,#4]\n"
            "STRH    R1, [SP,#0x14]\n"
            "LDRH    R1, [R5,#6]\n"
            "STRH    R1, [SP,#0x16]\n"
            "LDRH    R1, [R5,#8]\n"
            "STRH    R1, [SP,#0x18]\n"
            "BL      sub_FF8C3B94\n"        // LOCATION: ExpDrv.c:2
            "B       loc_FF8C2B00\n"
        "loc_FF8C2A74:\n"                   // jumptable FF8C2934 entry 31
            "LDRH    R1, [R5]\n"
            "STRH    R1, [SP,#0x10]\n"
            "LDRH    R1, [R0,#6]\n"
            "STRH    R1, [SP,#0x12]\n"
            "LDRH    R1, [R5,#4]\n"
            "STRH    R1, [SP,#0x14]\n"
            "LDRH    R1, [R5,#6]\n"
            "STRH    R1, [SP,#0x16]\n"
            "LDRH    R1, [R5,#8]\n"
            "STRH    R1, [SP,#0x18]\n"
            "BL      sub_FF8C3C40\n"        // LOCATION: ExpDrv.c:0\n"
            "B       loc_FF8C2B00\n"
        "loc_FF8C2AA4:\n"                   // jumptable FF8C2934 entry 32
            "LDRH    R1, [R5]\n"
            "STRH    R1, [SP,#0x10]\n"
            "LDRH    R1, [R5,#2]\n"
            "STRH    R1, [SP,#0x12]\n"
            "LDRH    R1, [R5,#4]\n"
            "STRH    R1, [SP,#0x14]\n"
            "LDRH    R1, [R5,#6]\n"
            "STRH    R1, [SP,#0x16]\n"
            "LDRH    R1, [R0,#0xC]\n"
            "STRH    R1, [SP,#0x18]\n"
            "BL      sub_FF8C3CE0\n"        // LOCATION: ExpDrv.c:32
            "B       loc_FF8C2B00\n"
        "loc_FF8C2AD4:\n"                   // jumptable FF8C2934 entries 33,34
            "BL      sub_FF8C0058\n"        // ExpDrv.c 0
            "B       loc_FF8C2B00\n"
        "loc_FF8C2ADC:\n"                   // jumptable FF8C2934 entry 37
            "BL      sub_FF8C0620\n"        // ExpDrv.c 10
            "B       loc_FF8C2B00\n"
        "loc_FF8C2AE4:\n"                   // jumptable FF8C2934 entry 38
            "BL      sub_FF8C085C\n"        // ExpDrv.c 0
            "B       loc_FF8C2B00\n"
        "loc_FF8C2AEC:\n"                   // jumptable FF8C2934 entry 12
            "BL      sub_FF8C09D8\n"        // ExpDrv.c 2
            "B       loc_FF8C2B00\n"
        "loc_FF8C2AF4:\n"                   // jumptable FF8C2934 entries 13-16
            "BL      sub_FF8C0B74\n"        // ExpDrv.c 128
            "B       loc_FF8C2B00\n"
        "loc_FF8C2AFC:\n"                   // jumptable FF8C2934 entry 17
            "BL      sub_FF8C0CD8\n"        // ExpDrv.c 2
        "loc_FF8C2B00:\n"                   // jumptable FF8C2934 default entry, jumptable FF8C2934 entries 18-23,35,36
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R1, [R0,#0x7C]\n"
            "LDR     R3, [R0,#0x8C]\n"
            "LDR     R2, [R0,#0x90]\n"
            "ADD     R0, R0, #4\n"
            "BLX     R3\n"
            "CMP     R4, #1\n"
            "BNE     loc_FF8C2B68\n"
        "loc_FF8C2B20:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "MOV     R2, #0xC\n"
            "LDR     R1, [R0,#0x7C]\n"
            "ADD     R1, R1, R1,LSL#1\n"
            "ADD     R0, R0, R1,LSL#2\n"
            "SUB     R4, R0, #8\n"
            "LDR     R0, =0x42D18\n"
            "ADD     R1, SP, #0x10\n"
            "BL      sub_FFB597C0\n"
            "LDR     R0, =0x42D24\n"
            "MOV     R2, #0xC\n"
            "ADD     R1, SP, #0x10\n"
            "BL      sub_FFB597C0\n"
            "LDR     R0, =0x42D30\n"
            "MOV     R2, #0xC\n"
            "MOV     R1, R4\n"
            "BL      sub_FFB597C0\n"
            "B       loc_FF8C2BE0\n"
        "loc_FF8C2B68:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "LDR     R0, [R0]\n"
            "CMP     R0, #0xB\n"
            "BNE     loc_FF8C2BB0\n"
            "MOV     R3, #0\n"
            "STR     R3, [SP]\n"
            "MOV     R3, #1\n"
            "MOV     R2, #1\n"
            "MOV     R1, #1\n"
            "MOV     R0, #0\n"
            "BL      sub_FF8BED94\n"
            "MOV     R3, #0\n"
            "STR     R3, [SP]\n"
            "MOV     R3, #1\n"
            "MOV     R2, #1\n"
            "MOV     R1, #1\n"
            "MOV     R0, #0\n"
            "B       loc_FF8C2BDC\n"
        "loc_FF8C2BB0:\n"
            "MOV     R3, #1\n"
            "MOV     R2, #1\n"
            "MOV     R1, #1\n"
            "MOV     R0, #1\n"
            "STR     R3, [SP]\n"
            "BL      sub_FF8BED94\n"
            "MOV     R3, #1\n"
            "MOV     R2, #1\n"
            "MOV     R1, #1\n"
            "MOV     R0, #1\n"
            "STR     R3, [SP]\n"
        "loc_FF8C2BDC:\n"
            "BL      sub_FF8BEED4\n"
        "loc_FF8C2BE0:\n"
            "LDR     R0, [SP,#0x1C]\n"
            "BL      sub_FF8C39C0\n"        // LOCATION: ExpDrv.c:0
            "B       loc_FF8C25FC\n"
    );
}
