/*
 * filewrite.c - auto-generated by CHDK code_gen.
 */
#include "lolevel.h"
#include "platform.h"

typedef struct {
    unsigned int address;
    unsigned int length;
} cam_ptp_data_chunk; //camera specific structure

#define MAX_CHUNKS_FOR_JPEG 3 //filewritetask is prepared for this many chunks
/*
 * fwt_data_struct: defined here as it's camera dependent
 * unneeded members are designated with unkn
 * file_offset, full_size, seek_flag only needs to be defined for DryOS>=r50 generation cameras
 * pdc is always required
 * name is not currently used
 */
typedef struct
{
    int unkn1[5];                                //
    cam_ptp_data_chunk pdc[MAX_CHUNKS_FOR_JPEG];
    char name[32];
} fwt_data_struct;

#include "../../../generic/filewrite.c"

/*************************************************************/
//** filewritetask @ 0xFFA101B8 - 0xFFA10298, length=57
void __attribute__((naked,noinline)) filewritetask() {
asm volatile (
"    STMFD   SP!, {R1-R5,LR} \n"
"    LDR     R4, =0xC0AC \n"

"loc_FFA101C0:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #8 \n"
"    BL      sub_FF827D8C /*_ReceiveMessageQueue*/ \n"
"    CMP     R0, #0 \n"
"    BNE     loc_FFA101F0 \n"
"    LDR     R0, [SP, #8] \n"
"    LDR     R1, [R0] \n"
"    CMP     R1, #1 \n"
"    BNE     loc_FFA101F8 \n"
"    LDR     R0, [R4, #8] \n"
"    BL      _GiveSemaphore \n"

"loc_FFA101F0:\n"
"    BL      _ExitTask \n"
"    LDMFD   SP!, {R1-R5,PC} \n"

"loc_FFA101F8:\n"
"    SUB     R1, R1, #2 \n"
"    CMP     R1, #5 \n"
"    ADDLS   PC, PC, R1, LSL#2 \n"
"    B       loc_FFA101C0 \n"
"    B       loc_FFA10220 \n"
"    B       loc_FFA10284 \n"
"    B       loc_FFA1028C \n"
"    B       loc_FFA1028C \n"
"    B       loc_FFA1028C \n"
"    B       loc_FFA10294 \n"

"loc_FFA10220:\n"
"    MOV     R0, #0 \n"
"    STR     R0, [SP] \n"

"loc_FFA10228:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R1, SP \n"
"    BL      sub_FF827F90 /*_GetNumberOfPostedMessages*/ \n"
"    LDR     R0, [SP] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FFA10254 \n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_FF827D8C /*_ReceiveMessageQueue*/ \n"
"    B       loc_FFA10228 \n"

"loc_FFA10254:\n"
"    LDR     R0, [R4] \n"
"    CMN     R0, #1 \n"
"    BEQ     loc_FFA10278 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    MVN     R0, #0 \n"
"    STR     R0, [R4] \n"
"    LDR     R0, =0xA1FE8 \n"
"    BL      sub_FF84F3C0 \n"
"    BL      sub_FF850C74 \n"

"loc_FFA10278:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      _GiveSemaphore \n"
"    B       loc_FFA101C0 \n"

"loc_FFA10284:\n"
"    BL      sub_FFA10458_my \n"  // --> Patched. Old value = 0xFFA10458. Open stage
"    B       loc_FFA101C0 \n"

"loc_FFA1028C:\n"
"    BL      sub_FFA10598_my \n"  // --> Patched. Old value = 0xFFA10598. Write stage
"    B       loc_FFA101C0 \n"

"loc_FFA10294:\n"
"    BL      sub_FFA10694_my \n"  // --> Patched. Old value = 0xFFA10694. Close stage
"    B       loc_FFA101C0 \n"
);
}

/*************************************************************/
//** sub_FFA10458_my @ 0xFFA10458 - 0xFFA10498, length=17
void __attribute__((naked,noinline)) sub_FFA10458_my() {
asm volatile (
"    STMFD   SP!, {R4-R8,LR} \n"
"    MOV     R4, R0 \n"
"    ADD     R0, R0, #0x2C \n"
"    SUB     SP, SP, #0x38 \n"
"    BL      sub_FF84F3C0 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF850C24 \n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF851514 \n"
"    LDR     R7, [R4, #8] \n"
"    LDR     R8, =0x1B6 \n"
"    ADD     R6, R4, #0x2C \n"
"    LDR     R5, [R4, #0xC] \n"
//hook start
"    STMFD SP!, {R4-R12,LR}\n"
"    MOV R0, R4\n"
"    BL filewrite_main_hook\n"
"    LDMFD SP!, {R4-R12,LR}\n"
//hook end
"    MOV     R0, R6 \n"
"    MOV     R1, R7 \n"
"    MOV     R2, R8 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.
"    LDR     PC, =0xFFA1049C \n"  // Continue in firmware
);
}

/*************************************************************/
//** sub_FFA10598_my @ 0xFFA10598 - 0xFFA10690, length=63
void __attribute__((naked,noinline)) sub_FFA10598_my() {
asm volatile (
"    STMFD   SP!, {R4-R10,LR} \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R0] \n"
"    CMP     R0, #4 \n"
"    LDREQ   R6, [R4, #0x18] \n"
"    LDREQ   R7, [R4, #0x14] \n"
"    BEQ     loc_FFA105D4 \n"
"    CMP     R0, #5 \n"
"    LDREQ   R6, [R4, #0x20] \n"
"    LDREQ   R7, [R4, #0x1C] \n"
"    BEQ     loc_FFA105D4 \n"
"    CMP     R0, #6 \n"
"    BNE     loc_FFA105E8 \n"
"    LDR     R6, [R4, #0x28] \n"
"    LDR     R7, [R4, #0x24] \n"

"loc_FFA105D4:\n"
"    CMP     R6, #0 \n"
"    BNE     loc_FFA105F8 \n"

"loc_FFA105DC:\n"
"    MOV     R1, R4 \n"
"    MOV     R0, #7 \n"
"    B       loc_FFA1068C \n"

"loc_FFA105E8:\n"
"    LDR     R1, =0x1E2 \n"
"    LDR     R0, =0xFFA10578 /*'dwFWrite.c'*/ \n"
"    BL      _DebugAssert \n"
"    B       loc_FFA105DC \n"

"loc_FFA105F8:\n"
"    LDR     R9, =0xC0AC \n"
"    MOV     R5, R6 \n"

"loc_FFA10600:\n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R5, #0x1000000 \n"
"    MOVLS   R8, R5 \n"
"    MOVHI   R8, #0x1000000 \n"
"    BIC     R1, R0, #0xFF000000 \n"
"    CMP     R1, #0 \n"
"    BICNE   R0, R0, #0xFF000000 \n"
"    RSBNE   R0, R0, #0x1000000 \n"
"    CMPNE   R8, R0 \n"
"    MOVHI   R8, R0 \n"
"    LDR     R0, [R9] \n"
"    MOV     R2, R8 \n"
"    MOV     R1, R7 \n"
"    BL      fwt_write \n"  // --> Patched. Old value = _Write.
"    LDR     R1, [R4, #4] \n"
"    CMP     R8, R0 \n"
"    ADD     R1, R1, R0 \n"
"    STR     R1, [R4, #4] \n"
"    BEQ     loc_FFA10660 \n"
"    LDR     R0, =0x10B1 \n"
"    BL      _IsControlEventActive \n"
"    LDR     R1, =0x9200005 \n"
"    STR     R1, [R4, #0x10] \n"
"    B       loc_FFA105DC \n"

"loc_FFA10660:\n"
"    SUB     R5, R5, R0 \n"
"    CMP     R5, R6 \n"
"    ADD     R7, R7, R0 \n"
"    LDRCS   R1, =0x211 \n"
"    LDRCS   R0, =0xFFA10578 /*'dwFWrite.c'*/ \n"
"    BLCS    _DebugAssert \n"
"    CMP     R5, #0 \n"
"    BNE     loc_FFA10600 \n"
"    LDR     R0, [R4] \n"
"    MOV     R1, R4 \n"
"    ADD     R0, R0, #1 \n"

"loc_FFA1068C:\n"
"    LDMFD   SP!, {R4-R10,LR} \n"
"    B       sub_FFA10110 \n"
);
}

/*************************************************************/
//** sub_FFA10694_my @ 0xFFA10694 - 0xFFA106B0, length=8
void __attribute__((naked,noinline)) sub_FFA10694_my() {
asm volatile (
"    STMFD   SP!, {R4,R5,LR} \n"
"    LDR     R5, =0xC0AC \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R5] \n"
"    SUB     SP, SP, #0x1C \n"
"    CMN     R0, #1 \n"
"    BEQ     sub_FFA106C8 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    LDR     PC, =0xFFA106B4 \n"  // Continue in firmware
);
}
