/*
 * boot.c - auto-generated by CHDK code_gen.
 */
#include "lolevel.h"
#include "platform.h"
#include "core.h"

/* Ours stuff */
extern void createHook (void *pNewTcb);
extern void deleteHook (void *pTcb);
const char * const new_sa = &_end;

void boot();

/* "relocated" functions */
void __attribute__((naked,noinline)) h_usrInit();
void __attribute__((naked,noinline)) h_usrKernelInit();
void __attribute__((naked,noinline)) h_usrRoot();

void boot()
{
    long *canon_data_src = (void*)0xffae8270; // This is the address of the "Startofdata"-4 string on the firmware
    long *canon_data_dst = (void*)MEMBASEADDR; // This is where the boot data is copiedduring firmware update
    long canon_data_len = 0xE7D0; // This is the length of data from "Startofdata" to the end of the firmware dump
    long *canon_bss_start = (void*) (canon_data_len + MEMBASEADDR); //  = 0xEB60 + 0x1900,  just after data
    long canon_bss_len = MEMISOSTART - (long) canon_bss_start; // The original address of h_usrKernelInit - bss start
    long i;

    asm volatile (
    "MRC     p15, 0, R0,c1,c0\n"
    "ORR     R0, R0, #0x1000\n"
    "ORR     R0, R0, #4\n"
    "ORR     R0, R0, #1\n"
    "MCR     p15, 0, R0,c1,c0\n"
    :::"r0");


    for(i=0;i<canon_data_len/4;i++)
    canon_data_dst[i]=canon_data_src[i];

    for(i=0;i<canon_bss_len/4;i++)
    canon_bss_start[i]=0;

    asm volatile (
    "MRC     p15, 0, R0,c1,c0\n"
    "ORR     R0, R0, #0x1000\n"
    "BIC     R0, R0, #4\n"
    "ORR     R0, R0, #1\n"
    "MCR     p15, 0, R0,c1,c0\n"
    :::"r0");
    
    h_usrInit();
}


/*************************************************************/
//** h_usrInit @ 0xFF811A64 - 0xFF811A88, length=10
void __attribute__((naked,noinline)) h_usrInit() {
asm volatile (
"    STR     LR, [SP, #-4]! \n"
"    BL      sub_FF811A40 \n"
"    MOV     R0, #2 \n"
"    MOV     R1, R0 \n"
"    BL      sub_FFACBEC8 \n"
"    BL      sub_FFAB85A0 \n"
"    BL      sub_FF811298 \n"
"    BL      sub_FF811800 \n"
"    LDR     LR, [SP], #4 \n"
"    B       h_usrKernelInit \n"  // --> Patched. Old value = 0xFF81181C.
);
}

/*************************************************************/
//** h_usrKernelInit @ 0xFF81181C - 0xFF811894, length=31
void __attribute__((naked,noinline)) h_usrKernelInit() {
asm volatile (
"    STMFD   SP!, {R4,LR} \n"
"    SUB     SP, SP, #8 \n"
"    BL      sub_FFACC3C8 \n"
"    BL      sub_FFAE16B4 \n"
"    LDR     R3, =0xF05C \n"
"    LDR     R2, =0xA4740 \n"
"    LDR     R1, [R3] \n"
"    LDR     R0, =0xA7FB0 \n"
"    MOV     R3, #0x100 \n"
"    BL      sub_FFADA504 \n"
"    LDR     R3, =0xF01C \n"
"    LDR     R0, =0xF8E4 \n"
"    LDR     R1, [R3] \n"
"    BL      sub_FFADA504 \n"
"    LDR     R3, =0xF0D8 \n"
"    LDR     R0, =0xA7F84 \n"
"    LDR     R1, [R3] \n"
"    BL      sub_FFADA504 \n"
"    BL      sub_FFAE6234 \n"
"    BL      sub_FF811384 \n"
"    MOV     R4, #0 \n"
"    MOV     R3, R0 \n"
"    MOV     R12, #0x800 \n"
//"  LDR     R0, =0xFF811B44 \n"  // -

    "LDR     R0, =h_usrRoot\n" // +

"    MOV     R1, #0x4000 \n"
//"  LDR     R2, =0xA85F0 \n"  // -

    "LDR     R2, =new_sa\n"    // +
    "LDR     R2, [R2]\n"       // +

"    STR     R12, [SP] \n"
"    STR     R4, [SP, #4] \n"
"    BL      sub_FFADE8F4 \n"
"    ADD     SP, SP, #8 \n"
"    LDMFD   SP!, {R4,PC} \n"
);
}

/*************************************************************/
//** h_usrRoot @ 0xFF811B44 - 0xFF811B94, length=21
void __attribute__((naked,noinline)) h_usrRoot() {
asm volatile (
"    STMFD   SP!, {R4,R5,LR} \n"
"    MOV     R5, R0 \n"
"    MOV     R4, R1 \n"
"    BL      sub_FF811AA8 \n"
"    MOV     R1, R4 \n"
"    MOV     R0, R5 \n"
"    BL      sub_FFAD2544 \n"
"    MOV     R1, R4 \n"
"    MOV     R0, R5 \n"
"    BL      sub_FFAD2FBC \n"
"    BL      sub_FF8118C0 \n"
"    BL      sub_FF8117DC \n"
"    MOV     R0, #0x32 \n"
"    BL      sub_FFAD4F60 \n"
"    BL      sub_FF811AEC \n"
"    BL      sub_FF811ACC \n"
"    BL      sub_FF811B18 \n"
"    BL      sub_FFAD4820 \n"
"    BL      sub_FF811A9C \n"
);

    _taskCreateHookAdd(createHook);
    _taskDeleteHookAdd(deleteHook);

    drv_self_hide();

asm volatile (
"    LDMFD   SP!, {R4,R5,LR} \n"
"    B       sub_FF811444 \n"
);
}
