/*
 * filewrite.c - auto-generated by CHDK code_gen.
 */
#include "lolevel.h"
#include "platform.h"

typedef struct {
    unsigned int address;
    unsigned int length;
} cam_ptp_data_chunk; //camera specific structure

#define MAX_CHUNKS_FOR_JPEG 3 //filewritetask is prepared for this many chunks
/*
 * fwt_data_struct: defined here as it's camera dependent
 * unneeded members are designated with unkn
 * file_offset, full_size, seek_flag only needs to be defined for DryOS>=r50 generation cameras
 * pdc is always required
 * name is not currently used
 */
typedef struct
{
    int unkn1[5];                                //
    cam_ptp_data_chunk pdc[MAX_CHUNKS_FOR_JPEG];
    char name[32];                               // open stage: sub_FFDBFF20 --> "ADD     R0, R0, #0x2C"
                                                 // offset of 'name' from start = 0x2C = 44 bytes = 11 words
} fwt_data_struct;

#include "../../../generic/filewrite.c"

/*************************************************************/
//** filewritetask @ 0xFFA25B10 - 0xFFA25BF0, length=57
void __attribute__((naked,noinline)) filewritetask() {
asm volatile (
"    STMFD   SP!, {R1-R5,LR} \n"
"    LDR     R4, =0xE3C4 \n"

"loc_FFA25B18:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #8 \n"
"    BL      sub_FF82A4F8 /*_ReceiveMessageQueue*/ \n"
"    CMP     R0, #0 \n"
"    BNE     loc_FFA25B48 \n"
"    LDR     R0, [SP, #8] \n"
"    LDR     R1, [R0] \n"
"    CMP     R1, #1 \n"
"    BNE     loc_FFA25B50 \n"
"    LDR     R0, [R4, #8] \n"
"    BL      _GiveSemaphore \n"

"loc_FFA25B48:\n"
"    BL      _ExitTask \n"
"    LDMFD   SP!, {R1-R5,PC} \n"

"loc_FFA25B50:\n"
"    SUB     R1, R1, #2 \n"
"    CMP     R1, #5 \n"
"    ADDLS   PC, PC, R1, LSL#2 \n"
"    B       loc_FFA25B18 \n"
"    B       loc_FFA25B78 \n"
"    B       loc_FFA25BDC \n"
"    B       loc_FFA25BE4 \n"
"    B       loc_FFA25BE4 \n"
"    B       loc_FFA25BE4 \n"
"    B       loc_FFA25BEC \n"

"loc_FFA25B78:\n"
"    MOV     R0, #0 \n"
"    STR     R0, [SP] \n"

"loc_FFA25B80:\n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R1, SP \n"
"    BL      sub_FF82A6FC /*_GetNumberOfPostedMessages*/ \n"
"    LDR     R0, [SP] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FFA25BAC \n"
"    LDR     R0, [R4, #0x10] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_FF82A4F8 /*_ReceiveMessageQueue*/ \n"
"    B       loc_FFA25B80 \n"

"loc_FFA25BAC:\n"
"    LDR     R0, [R4] \n"
"    CMN     R0, #1 \n"
"    BEQ     loc_FFA25BD0 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    MVN     R0, #0 \n"
"    STR     R0, [R4] \n"
"    LDR     R0, =0x88B20 \n"
"    BL      sub_FF856E44 \n"
"    BL      sub_FF85845C \n"

"loc_FFA25BD0:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      _GiveSemaphore \n"
"    B       loc_FFA25B18 \n"

"loc_FFA25BDC:\n"
"    BL      sub_FFA25DA8_my \n"  // --> Patched. Old value = 0xFFA25DA8. Open stage
"    B       loc_FFA25B18 \n"

"loc_FFA25BE4:\n"
"    BL      sub_FFA25ED4_my \n"  // --> Patched. Old value = 0xFFA25ED4. Write stage
"    B       loc_FFA25B18 \n"

"loc_FFA25BEC:\n"
"    BL      sub_FFA25FA4_my \n"  // --> Patched. Old value = 0xFFA25FA4. Close stage
"    B       loc_FFA25B18 \n"
);
}

/*************************************************************/
//** sub_FFA25DA8_my @ 0xFFA25DA8 - 0xFFA25DE8, length=17
void __attribute__((naked,noinline)) sub_FFA25DA8_my() {
asm volatile (
"    STMFD   SP!, {R4-R8,LR} \n"
"    MOV     R4, R0 \n"
"    ADD     R0, R0, #0x2C \n"
"    SUB     SP, SP, #0x38 \n"
"    BL      sub_FF856E44 \n"
"    MOV     R1, #0 \n"
"    BL      sub_FF858414 \n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF858CF0 \n"
"    LDR     R7, [R4, #8] \n"
"    LDR     R8, =0x1B6 \n"
"    ADD     R6, R4, #0x2C \n"
"    LDR     R5, [R4, #0xC] \n"
//hook start
"    STMFD SP!, {R4-R12,LR}\n"
"    MOV R0, R4\n"
"    BL filewrite_main_hook\n"
"    LDMFD SP!, {R4-R12,LR}\n"
//hook end
"    MOV     R0, R6 \n"
"    MOV     R1, R7 \n"
"    MOV     R2, R8 \n"
"    BL      fwt_open \n"  // --> Patched. Old value = _Open.
"    LDR     PC, =0xFFA25DEC \n"  // Continue in firmware
);
}

/*************************************************************/
//** sub_FFA25ED4_my @ 0xFFA25ED4 - 0xFFA25FA0, length=52
void __attribute__((naked,noinline)) sub_FFA25ED4_my() {
asm volatile (
"    STMFD   SP!, {R4-R6,LR} \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R0] \n"
"    CMP     R0, #4 \n"
"    LDREQ   R1, [R4, #0x14] \n"
"    LDREQ   R5, [R4, #0x18] \n"
"    BEQ     loc_FFA25F10 \n"
"    CMP     R0, #5 \n"
"    LDREQ   R1, [R4, #0x1C] \n"
"    LDREQ   R5, [R4, #0x20] \n"
"    BEQ     loc_FFA25F10 \n"
"    CMP     R0, #6 \n"
"    BNE     loc_FFA25F24 \n"
"    LDR     R1, [R4, #0x24] \n"
"    LDR     R5, [R4, #0x28] \n"

"loc_FFA25F10:\n"
"    CMP     R5, #0 \n"
"    BNE     loc_FFA25F34 \n"

"loc_FFA25F18:\n"
"    MOV     R1, R4 \n"
"    MOV     R0, #7 \n"
"    B       loc_FFA25F9C \n"

"loc_FFA25F24:\n"
"    MOV     R1, #0x1D4 \n"
"    LDR     R0, =0xFFA26044 /*'dwFWrite.c'*/ \n"
"    BL      _DebugAssert \n"
"    B       loc_FFA25F18 \n"

"loc_FFA25F34:\n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R5, #0x1000000 \n"
"    MOVHI   R5, #0x1000000 \n"
"    BIC     R2, R0, #0xFF000000 \n"
"    CMP     R2, #0 \n"
"    BICNE   R0, R0, #0xFF000000 \n"
"    RSBNE   R0, R0, #0x1000000 \n"
"    CMPNE   R5, R0 \n"
"    MOVHI   R5, R0 \n"
"    LDR     R0, =0xE3C4 \n"
"    MOV     R2, R5 \n"
"    LDR     R0, [R0] \n"
"    BL      fwt_write \n"  // --> Patched. Old value = _Write.
"    LDR     R1, [R4, #4] \n"
"    CMP     R5, R0 \n"
"    ADD     R1, R1, R0 \n"
"    STR     R1, [R4, #4] \n"
"    BEQ     loc_FFA25F90 \n"
"    LDR     R0, =0x10B1 \n"
"    BL      sub_FF877A7C /*_IsControlEventActive_FW*/ \n"
"    LDR     R1, =0x9200005 \n"
"    STR     R1, [R4, #0x10] \n"
"    B       loc_FFA25F18 \n"

"loc_FFA25F90:\n"
"    LDR     R0, [R4] \n"
"    MOV     R1, R4 \n"
"    ADD     R0, R0, #1 \n"

"loc_FFA25F9C:\n"
"    LDMFD   SP!, {R4-R6,LR} \n"
"    B       sub_FFA25A68 \n"
);
}

/*************************************************************/
//** sub_FFA25FA4_my @ 0xFFA25FA4 - 0xFFA25FC0, length=8
void __attribute__((naked,noinline)) sub_FFA25FA4_my() {
asm volatile (
"    STMFD   SP!, {R4,R5,LR} \n"
"    LDR     R5, =0xE3C4 \n"
"    MOV     R4, R0 \n"
"    LDR     R0, [R5] \n"
"    SUB     SP, SP, #0x1C \n"
"    CMN     R0, #1 \n"
"    BEQ     sub_FFA25FD8 \n"
"    BL      fwt_close \n"  // --> Patched. Old value = _Close.
"    LDR     PC, =0xFFA25FC4 \n"  // Continue in firmware
);
}
