/*
 * movie_rec.c - auto-generated by CHDK code_gen.
 */
#include "conf.h"

static int bitrate_multiplier = 4; // unit: factory rate / 4
static int bitrate_changed = 0;
extern int video_target_framesize;
extern int video_target_framesize2;


static int orig_bitrate[2]; // original bitrates, saved at beginning of recording

void change_video_tables(int a, int b) {
    bitrate_multiplier = (a<<2)/b;
    bitrate_changed = 1;
}

// firmware: -12 (best) ... +20 (worst)
void  set_quality(int *x){ // -17 highest; +12 lowest
 if (conf.video_mode) *x=12-((conf.video_quality-1)*(12+17)/(99-1));
}

void save_original_bitrates() {
    orig_bitrate[0] = video_target_framesize;
    orig_bitrate[1] = video_target_framesize2;
    bitrate_changed = 1;
}

void modify_bitrate() {
    if (bitrate_changed) {
        bitrate_changed = 0;
        video_target_framesize = (orig_bitrate[0] * bitrate_multiplier) >> 2;
        video_target_framesize2 = (orig_bitrate[1] * bitrate_multiplier) >> 2;
    }
}


/*************************************************************/
//** movie_record_task @ 0xFF9A7E94 - 0xFF9A8024, length=101
void __attribute__((naked,noinline)) movie_record_task() {
asm volatile (
"    STMFD   SP!, {R2-R10,LR} \n"
"    LDR     R8, =0xFF9A7A94 \n"
"    LDR     R4, =0x7530 \n"
"    LDR     R9, =0x709 \n"
"    LDR     R10, =0x2710 \n"
"    MVN     R7, #0 \n"
"    MOV     R5, #1 \n"
"    MOV     R6, #0 \n"

"loc_FF9A7EB4:\n"
"    LDR     R0, [R4, #0x30] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_FF829E2C /*_ReceiveMessageQueue*/ \n"
"    LDR     R0, [R4, #0x38] \n"
"    CMP     R0, #0 \n"
"    LDRNE   R0, [R4, #0x14] \n"
"    CMPNE   R0, #2 \n"
"    LDRNE   R0, [R4, #0x4C] \n"
"    CMPNE   R0, #6 \n"
"    BNE     loc_FF9A8008 \n"
"    LDR     R0, [SP, #4] \n"
"    LDR     R1, [R0] \n"
"    SUB     R1, R1, #2 \n"
"    CMP     R1, #0xD \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF9A8008 \n"
"    B       loc_FF9A7F7C \n"
"    B       loc_FF9A7FA8 \n"
"    B       loc_FF9A7FB8 \n"
"    B       loc_FF9A7FC0 \n"
"    B       loc_FF9A7F84 \n"
"    B       loc_FF9A7FC8 \n"
"    B       loc_FF9A7FF4 \n"
"    B       loc_FF9A7FFC \n"
"    B       loc_FF9A7F90 \n"
"    B       loc_FF9A8008 \n"
"    B       loc_FF9A8004 \n"
"    B       loc_FF9A7F58 \n"
"    B       loc_FF9A7F2C \n"

"loc_FF9A7F2C:\n"
"    STR     R6, [R4, #0x48] \n"
"    STR     R6, [R4, #0x3C] \n"
"    STR     R7, [R4, #0xD4] \n"
"    STRH    R6, [R4, #8] \n"
"    STR     R8, [R4, #0xB4] \n"
"    LDR     R0, [R4, #0x14] \n"
"    ADD     R0, R0, #1 \n"
"    STR     R0, [R4, #0x14] \n"
"    MOV     R0, #6 \n"
"    STR     R0, [R4, #0x4C] \n"
"    B       loc_FF9A7F74 \n"

"loc_FF9A7F58:\n"
"    STR     R6, [R4, #0x48] \n"
"    STR     R7, [R4, #0xD4] \n"
"    STR     R8, [R4, #0xB4] \n"
"    LDR     R0, [R4, #0x14] \n"
"    ADD     R0, R0, #1 \n"
"    STR     R0, [R4, #0x14] \n"
"    STR     R5, [R4, #0x4C] \n"

"loc_FF9A7F74:\n"
"    STR     R5, [R4, #0xC] \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7F7C:\n"
"    BL      sub_FF9A777C \n"
"    BL      save_original_bitrates \n"      // + (executed at recording start)
"    B       loc_FF9A8008 \n"

"loc_FF9A7F84:\n"
"    LDR     R1, [R4, #0xB4] \n"
"    BLX     R1 \n"
//begin patch (only effective in VGA mode)
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
//end patch
"    B       loc_FF9A8008 \n"

"loc_FF9A7F90:\n"
"    LDR     R1, [R0, #0x18] \n"
"    LDR     R2, [R0, #0x28] \n"
"    LDR     R3, [R0, #0x24] \n"
"    LDR     R0, [R0, #4] \n"
"    BL      sub_FFAFE368 \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7FA8:\n"
"    LDR     R0, [R4, #0x4C] \n"
"    CMP     R0, #5 \n"
"    STRNE   R5, [R4, #0x3C] \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7FB8:\n"
"    BL      sub_FF9A73DC \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7FC0:\n"
"    BL      sub_FF9A729C \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7FC8:\n"
"    LDR     R0, =0x10385C \n"
"    LDR     R0, [R0, #8] \n"
"    CMP     R0, #0 \n"
"    LDRNE   R2, =0xFF9A71BC \n"
"    LDRNE   R0, =0xFF9A7244 \n"
"    MOVNE   R3, #0 \n"
"    MOVNE   R1, R3 \n"
"    BLNE    sub_FF86DFF4 \n"
"    MOV     R0, #3 \n"
"    STR     R0, [R4, #0x4C] \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7FF4:\n"
"    BL      sub_FF9A7130 \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A7FFC:\n"
"    BL      sub_FF9A880C \n"
"    B       loc_FF9A8008 \n"

"loc_FF9A8004:\n"
"    BL      sub_FF9A700C \n"

"loc_FF9A8008:\n"
"    LDR     R1, [SP, #4] \n"
"    LDR     R3, =0xFF9A6CE8 /*'MovieRecorder.c'*/ \n"
"    STR     R6, [R1] \n"
"    STR     R9, [SP] \n"
"    LDR     R0, [R4, #0x34] \n"
"    MOV     R2, R10 \n"
"    BL      sub_FF826770 /*_PostMessageQueueStrictly*/ \n"
"    B       loc_FF9A7EB4 \n"
);
}

/*************************************************************/
//** liveimage_task @ 0xFF914F9C - 0xFF91502C, length=37
void __attribute__((naked,noinline)) liveimage_task() {
asm volatile (
"    STMFD   SP!, {R3-R5,LR} \n"
"    LDR     R4, =0x57C0 \n"

"loc_FF914FA4:\n"
"    MOV     R2, #0 \n"
"    LDR     R0, [R4, #8] \n"
"    MOV     R1, SP \n"
"    BL      sub_FF829E2C /*_ReceiveMessageQueue*/ \n"
"    TST     R0, #1 \n"
"    BEQ     loc_FF914FD4 \n"
"    MOV     R2, #0x78 \n"
"    LDR     R1, =0xFF9151D4 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"
"    BL      _ExitTask \n"
"    LDMFD   SP!, {R3-R5,PC} \n"

"loc_FF914FD4:\n"
"    LDR     R1, [SP] \n"
"    LDR     R0, [R1] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FF915008 \n"
"    CMP     R0, #1 \n"
"    MOVEQ   R1, #1 \n"
"    BEQ     loc_FF914FFC \n"
"    CMP     R0, #2 \n"
"    BNE     loc_FF91501C \n"
"    MOV     R1, #2 \n"

"loc_FF914FFC:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF829BC0 /*_SetEventFlag*/ \n"
"    B       loc_FF914FA4 \n"

"loc_FF915008:\n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R0, #1 \n"
"    ADDNE   R0, R1, #4 \n"
"    BLNE    sub_FF915208_my \n"  // --> Patched. Old value = 0xFF915208.
"    B       loc_FF914FA4 \n"

"loc_FF91501C:\n"
"    MOV     R2, #0x97 \n"
"    LDR     R1, =0xFF9151D4 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"
"    B       loc_FF914FA4 \n"
);
}

/*************************************************************/
//** sub_FF915208_my @ 0xFF915208 - 0xFF9152B0, length=43
void __attribute__((naked,noinline)) sub_FF915208_my() {
asm volatile (
"    LDR     R1, [R0] \n"
"    CMP     R1, #0x18 \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF9152A4 \n"
"    B       sub_FF913798 \n"
"    B       sub_FF9138EC \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF915278 \n"
"    B       sub_FF914130 \n"
"    B       sub_FF91432C \n"
"    B       sub_FF9146A8 \n"
"    B       sub_FF913798 \n"
"    B       sub_FF913F18 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF915278 \n"
"    B       sub_FF914A28 \n"
"    B       sub_FF914A28 \n"
"    B       loc_FF9152A4 \n"
"    BX      LR \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    B       loc_FF9152A4 \n"
"    BX      LR \n"

"loc_FF915278:\n"
// HD movie codepath
"    LDR     R1, [R0, #0x64] \n"
"    CMP     R1, #1 \n"
"    BNE     sub_FF913CB4_my \n"  // --> Patched. Old value = 0xFF913CB4.
"    BEQ     sub_FF913AD0_my \n"  // --> Patched. Old value = 0xFF913AD0.

"loc_FF915288:\n"
"    B       sub_FF9138EC \n"

"loc_FF91528C:\n"
"    B       sub_FF914130 \n"

"loc_FF915290:\n"
"    B       sub_FF913798 \n"

"loc_FF915294:\n"
"    B       sub_FF91432C \n"

"loc_FF915298:\n"
"    B       sub_FF913F18 \n"

"loc_FF91529C:\n"
"    B       sub_FF9146A8 \n"

"loc_FF9152A0:\n"
"    B       sub_FF914A28 \n"

"loc_FF9152A4:\n"
"    MOV     R2, #0x69 \n"
"    LDR     R1, =0xFF9151D4 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    B       _DebugAssert \n"
);
}

/*************************************************************/
//** sub_FF913CB4_my @ 0xFF913CB4 - 0xFF913F14, length=153
void __attribute__((naked,noinline)) sub_FF913CB4_my() {
asm volatile (
// Need to execute our code after the firmware subroutine
// it's more complicated here than usual
"    PUSH    {LR} \n"                        // +
"    MOV     LR, PC \n"                      // +
"    LDR     PC, =0xFF913CB4 \n"  // Continue in firmware
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
"    POP     {PC} \n"                        // +
);
}

/*************************************************************/
//** sub_FF913AD0_my @ 0xFF913AD0 - 0xFF913CB0, length=121
void __attribute__((naked,noinline)) sub_FF913AD0_my() {
asm volatile (
// Need to execute our code after the firmware subroutine
// it's more complicated here than usual
"    PUSH    {LR} \n"                        // +
"    MOV     LR, PC \n"                      // +
"    LDR     PC, =0xFF913AD0 \n"  // Continue in firmware
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
"    POP     {PC} \n"                        // +
);
}
