/*
 * movie_rec.c - auto-generated by CHDK code_gen.
 */
#include "conf.h"

static int bitrate_multiplier = 4; // unit: factory rate / 4
static int bitrate_changed = 0;
extern int video_target_framesize;
extern int video_target_framesize2;


static int orig_bitrate[2]; // original bitrates, saved at beginning of recording

void change_video_tables(int a, int b) {
    bitrate_multiplier = (a<<2)/b;
    bitrate_changed = 1;
}

// firmware: -12 (best) ... +20 (worst)
void  set_quality(int *x){ // -17 highest; +12 lowest
 if (conf.video_mode) *x=12-((conf.video_quality-1)*(12+17)/(99-1));
}

void save_original_bitrates() {
    orig_bitrate[0] = video_target_framesize;
    orig_bitrate[1] = video_target_framesize2;
    bitrate_changed = 1;
}

void modify_bitrate() {
    if (bitrate_changed) {
        bitrate_changed = 0;
        video_target_framesize = (orig_bitrate[0] * bitrate_multiplier) >> 2;
        video_target_framesize2 = (orig_bitrate[1] * bitrate_multiplier) >> 2;
    }
}


/*************************************************************/
//** movie_record_task @ 0xFF9A9ECC - 0xFF9AA05C, length=101
void __attribute__((naked,noinline)) movie_record_task() {
asm volatile (
"    STMFD   SP!, {R2-R10,LR} \n"
"    LDR     R8, =0xFF9A9ACC \n"
"    LDR     R4, =0x7580 \n"
"    LDR     R9, =0x709 \n"
"    LDR     R10, =0x2710 \n"
"    MVN     R7, #0 \n"
"    MOV     R5, #1 \n"
"    MOV     R6, #0 \n"

"loc_FF9A9EEC:\n"
"    LDR     R0, [R4, #0x30] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_FF829E30 /*_ReceiveMessageQueue*/ \n"
"    LDR     R0, [R4, #0x38] \n"
"    CMP     R0, #0 \n"
"    LDRNE   R0, [R4, #0x14] \n"
"    CMPNE   R0, #2 \n"
"    LDRNE   R0, [R4, #0x4C] \n"
"    CMPNE   R0, #6 \n"
"    BNE     loc_FF9AA040 \n"
"    LDR     R0, [SP, #4] \n"
"    LDR     R1, [R0] \n"
"    SUB     R1, R1, #2 \n"
"    CMP     R1, #0xD \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF9AA040 \n"
"    B       loc_FF9A9FB4 \n"
"    B       loc_FF9A9FE0 \n"
"    B       loc_FF9A9FF0 \n"
"    B       loc_FF9A9FF8 \n"
"    B       loc_FF9A9FBC \n"
"    B       loc_FF9AA000 \n"
"    B       loc_FF9AA02C \n"
"    B       loc_FF9AA034 \n"
"    B       loc_FF9A9FC8 \n"
"    B       loc_FF9AA040 \n"
"    B       loc_FF9AA03C \n"
"    B       loc_FF9A9F90 \n"
"    B       loc_FF9A9F64 \n"

"loc_FF9A9F64:\n"
"    STR     R6, [R4, #0x48] \n"
"    STR     R6, [R4, #0x3C] \n"
"    STR     R7, [R4, #0xD4] \n"
"    STRH    R6, [R4, #8] \n"
"    STR     R8, [R4, #0xB4] \n"
"    LDR     R0, [R4, #0x14] \n"
"    ADD     R0, R0, #1 \n"
"    STR     R0, [R4, #0x14] \n"
"    MOV     R0, #6 \n"
"    STR     R0, [R4, #0x4C] \n"
"    B       loc_FF9A9FAC \n"

"loc_FF9A9F90:\n"
"    STR     R6, [R4, #0x48] \n"
"    STR     R7, [R4, #0xD4] \n"
"    STR     R8, [R4, #0xB4] \n"
"    LDR     R0, [R4, #0x14] \n"
"    ADD     R0, R0, #1 \n"
"    STR     R0, [R4, #0x14] \n"
"    STR     R5, [R4, #0x4C] \n"

"loc_FF9A9FAC:\n"
"    STR     R5, [R4, #0xC] \n"
"    B       loc_FF9AA040 \n"

"loc_FF9A9FB4:\n"
"    BL      sub_FF9A97B4 \n"
"    BL      save_original_bitrates \n"      // + (executed at recording start)
"    B       loc_FF9AA040 \n"

"loc_FF9A9FBC:\n"
"    LDR     R1, [R4, #0xB4] \n"
"    BLX     R1 \n"
//begin patch (only effective in VGA mode)
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
//end patch
"    B       loc_FF9AA040 \n"

"loc_FF9A9FC8:\n"
"    LDR     R1, [R0, #0x18] \n"
"    LDR     R2, [R0, #0x28] \n"
"    LDR     R3, [R0, #0x24] \n"
"    LDR     R0, [R0, #4] \n"
"    BL      sub_FFB011F8 \n"
"    B       loc_FF9AA040 \n"

"loc_FF9A9FE0:\n"
"    LDR     R0, [R4, #0x4C] \n"
"    CMP     R0, #5 \n"
"    STRNE   R5, [R4, #0x3C] \n"
"    B       loc_FF9AA040 \n"

"loc_FF9A9FF0:\n"
"    BL      sub_FF9A9414 \n"
"    B       loc_FF9AA040 \n"

"loc_FF9A9FF8:\n"
"    BL      sub_FF9A92D4 \n"
"    B       loc_FF9AA040 \n"

"loc_FF9AA000:\n"
"    LDR     R0, =0x103C34 \n"
"    LDR     R0, [R0, #8] \n"
"    CMP     R0, #0 \n"
"    LDRNE   R2, =0xFF9A91F4 \n"
"    LDRNE   R0, =0xFF9A927C \n"
"    MOVNE   R3, #0 \n"
"    MOVNE   R1, R3 \n"
"    BLNE    sub_FF86E09C \n"
"    MOV     R0, #3 \n"
"    STR     R0, [R4, #0x4C] \n"
"    B       loc_FF9AA040 \n"

"loc_FF9AA02C:\n"
"    BL      sub_FF9A9168 \n"
"    B       loc_FF9AA040 \n"

"loc_FF9AA034:\n"
"    BL      sub_FF9AA844 \n"
"    B       loc_FF9AA040 \n"

"loc_FF9AA03C:\n"
"    BL      sub_FF9A9044 \n"

"loc_FF9AA040:\n"
"    LDR     R1, [SP, #4] \n"
"    LDR     R3, =0xFF9A8D20 /*'MovieRecorder.c'*/ \n"
"    STR     R6, [R1] \n"
"    STR     R9, [SP] \n"
"    LDR     R0, [R4, #0x34] \n"
"    MOV     R2, R10 \n"
"    BL      sub_FF826774 /*_PostMessageQueueStrictly*/ \n"
"    B       loc_FF9A9EEC \n"
);
}

/*************************************************************/
//** liveimage_task @ 0xFF915268 - 0xFF9152F8, length=37
void __attribute__((naked,noinline)) liveimage_task() {
asm volatile (
"    STMFD   SP!, {R3-R5,LR} \n"
"    LDR     R4, =0x57DC \n"

"loc_FF915270:\n"
"    MOV     R2, #0 \n"
"    LDR     R0, [R4, #8] \n"
"    MOV     R1, SP \n"
"    BL      sub_FF829E30 /*_ReceiveMessageQueue*/ \n"
"    TST     R0, #1 \n"
"    BEQ     loc_FF9152A0 \n"
"    MOV     R2, #0x78 \n"
"    LDR     R1, =0xFF9154A0 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"
"    BL      _ExitTask \n"
"    LDMFD   SP!, {R3-R5,PC} \n"

"loc_FF9152A0:\n"
"    LDR     R1, [SP] \n"
"    LDR     R0, [R1] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FF9152D4 \n"
"    CMP     R0, #1 \n"
"    MOVEQ   R1, #1 \n"
"    BEQ     loc_FF9152C8 \n"
"    CMP     R0, #2 \n"
"    BNE     loc_FF9152E8 \n"
"    MOV     R1, #2 \n"

"loc_FF9152C8:\n"
"    LDR     R0, [R4, #0xC] \n"
"    BL      sub_FF829BC4 /*_SetEventFlag*/ \n"
"    B       loc_FF915270 \n"

"loc_FF9152D4:\n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R0, #1 \n"
"    ADDNE   R0, R1, #4 \n"
"    BLNE    sub_FF9154D4_my \n"  // --> Patched. Old value = 0xFF9154D4.
"    B       loc_FF915270 \n"

"loc_FF9152E8:\n"
"    MOV     R2, #0x97 \n"
"    LDR     R1, =0xFF9154A0 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"
"    B       loc_FF915270 \n"
);
}

/*************************************************************/
//** sub_FF9154D4_my @ 0xFF9154D4 - 0xFF91557C, length=43
void __attribute__((naked,noinline)) sub_FF9154D4_my() {
asm volatile (
"    LDR     R1, [R0] \n"
"    CMP     R1, #0x18 \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF915570 \n"
"    B       sub_FF913A64 \n"
"    B       sub_FF913BB8 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915544 \n"
"    B       sub_FF9143FC \n"
"    B       sub_FF9145F8 \n"
"    B       sub_FF914974 \n"
"    B       sub_FF913A64 \n"
"    B       sub_FF9141E4 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915544 \n"
"    B       sub_FF914CF4 \n"
"    B       sub_FF914CF4 \n"
"    B       loc_FF915570 \n"
"    BX      LR \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    B       loc_FF915570 \n"
"    BX      LR \n"

"loc_FF915544:\n"
// HD movie codepath
"    LDR     R1, [R0, #0x64] \n"
"    CMP     R1, #1 \n"
"    BNE     sub_FF913F80_my \n"  // --> Patched. Old value = 0xFF913F80.
"    BEQ     sub_FF913D9C_my \n"  // --> Patched. Old value = 0xFF913D9C.

"loc_FF915554:\n"
"    B       sub_FF913BB8 \n"

"loc_FF915558:\n"
"    B       sub_FF9143FC \n"

"loc_FF91555C:\n"
"    B       sub_FF913A64 \n"

"loc_FF915560:\n"
"    B       sub_FF9145F8 \n"

"loc_FF915564:\n"
"    B       sub_FF9141E4 \n"

"loc_FF915568:\n"
"    B       sub_FF914974 \n"

"loc_FF91556C:\n"
"    B       sub_FF914CF4 \n"

"loc_FF915570:\n"
"    MOV     R2, #0x69 \n"
"    LDR     R1, =0xFF9154A0 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    B       _DebugAssert \n"
);
}

/*************************************************************/
//** sub_FF913F80_my @ 0xFF913F80 - 0xFF9141E0, length=153
void __attribute__((naked,noinline)) sub_FF913F80_my() {
asm volatile (
// Need to execute our code after the firmware subroutine
// it's more complicated here than usual
"    PUSH    {LR} \n"                        // +
"    MOV     LR, PC \n"                      // +
"    LDR     PC, =0xFF913F80 \n"  // Continue in firmware
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
"    POP     {PC} \n"                        // +
);
}

/*************************************************************/
//** sub_FF913D9C_my @ 0xFF913D9C - 0xFF913F7C, length=121
void __attribute__((naked,noinline)) sub_FF913D9C_my() {
asm volatile (
// Need to execute our code after the firmware subroutine
// it's more complicated here than usual
"    PUSH    {LR} \n"                        // +
"    MOV     LR, PC \n"                      // +
"    LDR     PC, =0xFF913D9C \n"  // Continue in firmware
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
"    POP     {PC} \n"                        // +
);
}
