/*
 * movie_rec.c - auto-generated by CHDK code_gen.
 */
#include "conf.h"

static int bitrate_multiplier = 4; // unit: factory rate / 4
static int bitrate_changed = 0;
extern int video_target_framesize;
extern int video_target_framesize2;


static int orig_bitrate[2]; // original bitrates, saved at beginning of recording

void change_video_tables(int a, int b) {
    bitrate_multiplier = (a<<2)/b;
    bitrate_changed = 1;
}

// firmware: -12 (best) ... +20 (worst)
void  set_quality(int *x){ // -17 highest; +12 lowest
 if (conf.video_mode) *x=12-((conf.video_quality-1)*(12+17)/(99-1));
}

void save_original_bitrates() {
    orig_bitrate[0] = video_target_framesize;
    orig_bitrate[1] = video_target_framesize2;
    bitrate_changed = 1;
}

void modify_bitrate() {
    if (bitrate_changed) {
        bitrate_changed = 0;
        video_target_framesize = (orig_bitrate[0] * bitrate_multiplier) >> 2;
        video_target_framesize2 = (orig_bitrate[1] * bitrate_multiplier) >> 2;
    }
}


/*************************************************************/
//** movie_record_task @ 0xFF215358 - 0xFF21555C, length=130
void __attribute__((naked,noinline)) movie_record_task() {
asm volatile (
"    STMFD   SP!, {R2-R10,LR} \n"
"    LDR     R8, =0xFF214F08 \n"
"    LDR     R4, =0xA580 \n"
"    LDR     R9, =0x709 \n"
"    LDR     R10, =0x2710 \n"
"    MVN     R7, #0 \n"
"    MOV     R5, #1 \n"
"    MOV     R6, #0 \n"

"loc_FF215378:\n"
"    LDR     R0, [R4, #0x30] \n"
"    MOV     R2, #0 \n"
"    ADD     R1, SP, #4 \n"
"    BL      sub_006B849C /*_ReceiveMessageQueue*/ \n"
"    LDR     R0, [R4, #0x38] \n"
"    CMP     R0, #0 \n"
"    LDRNE   R0, [R4, #0x14] \n"
"    CMPNE   R0, #2 \n"
"    LDRNE   R0, [R4, #0x4C] \n"
"    CMPNE   R0, #6 \n"
"    BNE     loc_FF215540 \n"
"    LDR     R0, [SP, #4] \n"
"    LDR     R1, [R0] \n"
"    SUB     R1, R1, #2 \n"
"    CMP     R1, #0x12 \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF215540 \n"
"    B       loc_FF215454 \n"
"    B       loc_FF21547C \n"
"    B       loc_FF21548C \n"
"    B       loc_FF215494 \n"
"    B       loc_FF21549C \n"
"    B       loc_FF2154B8 \n"
"    B       loc_FF2154C0 \n"
"    B       loc_FF2154CC \n"
"    B       loc_FF2154D4 \n"
"    B       loc_FF21545C \n"
"    B       loc_FF215500 \n"
"    B       loc_FF21552C \n"
"    B       loc_FF215534 \n"
"    B       loc_FF215464 \n"
"    B       loc_FF215540 \n"
"    B       loc_FF21553C \n"
"    B       loc_FF215430 \n"
"    B       loc_FF215404 \n"

"loc_FF215404:\n"
"    STR     R6, [R4, #0x48] \n"
"    STR     R6, [R4, #0x3C] \n"
"    STR     R7, [R4, #0x10C] \n"
"    STRH    R6, [R4, #8] \n"
"    STR     R8, [R4, #0xEC] \n"
"    LDR     R0, [R4, #0x14] \n"
"    ADD     R0, R0, #1 \n"
"    STR     R0, [R4, #0x14] \n"
"    MOV     R0, #6 \n"
"    STR     R0, [R4, #0x4C] \n"
"    B       loc_FF21544C \n"

"loc_FF215430:\n"
"    STR     R6, [R4, #0x48] \n"
"    STR     R7, [R4, #0x10C] \n"
"    STR     R8, [R4, #0xEC] \n"
"    LDR     R0, [R4, #0x14] \n"
"    ADD     R0, R0, #1 \n"
"    STR     R0, [R4, #0x14] \n"
"    STR     R5, [R4, #0x4C] \n"

"loc_FF21544C:\n"
"    STR     R5, [R4, #0xC] \n"
"    B       loc_FF215540 \n"

"loc_FF215454:\n"
"    BL      sub_FF214B0C \n"
"    BL      save_original_bitrates \n"      // + (executed at recording start)
"    B       loc_FF215540 \n"

"loc_FF21545C:\n"
"    LDR     R1, [R4, #0xEC] \n"
"    B       loc_FF2154B0 \n"

"loc_FF215464:\n"
"    LDR     R1, [R0, #0x18] \n"
"    LDR     R2, [R0, #0x28] \n"
"    LDR     R3, [R0, #0x24] \n"
"    LDR     R0, [R0, #4] \n"
"    BL      sub_FF3CF9CC \n"
"    B       loc_FF215540 \n"

"loc_FF21547C:\n"
"    LDR     R0, [R4, #0x4C] \n"
"    CMP     R0, #5 \n"
"    STRNE   R5, [R4, #0x3C] \n"
"    B       loc_FF215540 \n"

"loc_FF21548C:\n"
"    BL      sub_FF2143AC \n"
"    B       loc_FF215540 \n"

"loc_FF215494:\n"
"    BL      sub_FF214284 \n"
"    B       loc_FF215540 \n"

"loc_FF21549C:\n"
"    BL      sub_FF213F38 \n"
"    LDR     R1, [R4, #0xBC] \n"
"    CMP     R1, #0 \n"
"    BEQ     loc_FF215540 \n"
"    LDR     R0, [R4, #0xC0] \n"

"loc_FF2154B0:\n"
"    BLX     R1 \n"
//begin patch (only effective in VGA mode)
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
//end patch
"    B       loc_FF215540 \n"

"loc_FF2154B8:\n"
"    BL      sub_FF213C74 \n"
"    B       loc_FF215540 \n"

"loc_FF2154C0:\n"
"    LDR     R0, =0xFF213C00 \n"
"    BL      sub_FF3CF688 \n"
"    B       loc_FF215540 \n"

"loc_FF2154CC:\n"
"    BL      sub_FF21388C \n"
"    B       loc_FF215540 \n"

"loc_FF2154D4:\n"
"    LDR     R1, [R4, #0xA4] \n"
"    LDR     R0, =0x49AF430C \n"
"    CMP     R1, #1 \n"
"    LDRNE   R1, =0xFF21382C \n"
"    LDRNE   R0, [R4, #0xA8] \n"
"    BNE     loc_FF2154F8 \n"
"    BL      sub_FF3D035C \n"
"    LDR     R1, =0xFF21382C \n"
"    MOV     R0, #0 \n"

"loc_FF2154F8:\n"
"    BL      sub_FF3CE948 \n"
"    B       loc_FF215540 \n"

"loc_FF215500:\n"
"    LDR     R0, =0x182CD0 \n"
"    LDR     R0, [R0, #8] \n"
"    CMP     R0, #0 \n"
"    LDRNE   R2, =0xFF213780 \n"
"    LDRNE   R0, =0xFF213808 \n"
"    MOVNE   R3, #0 \n"
"    MOVNE   R1, R3 \n"
"    BLNE    sub_FF078200 \n"
"    MOV     R0, #3 \n"
"    STR     R0, [R4, #0x4C] \n"
"    B       loc_FF215540 \n"

"loc_FF21552C:\n"
"    BL      sub_FF2136E8 \n"
"    B       loc_FF215540 \n"

"loc_FF215534:\n"
"    BL      sub_FF215F54 \n"
"    B       loc_FF215540 \n"

"loc_FF21553C:\n"
"    BL      sub_FF2135BC \n"

"loc_FF215540:\n"
"    LDR     R1, [SP, #4] \n"
"    LDR     R3, =0xFF2130F0 /*'MovieRecorder.c'*/ \n"
"    STR     R6, [R1] \n"
"    STR     R9, [SP] \n"
"    LDR     R0, [R4, #0x34] \n"
"    MOV     R2, R10 \n"
"    BL      sub_006B7D38 /*_PostMessageQueueStrictly*/ \n"
"    B       loc_FF215378 \n"
);
}

/*************************************************************/
//** liveimage_task @ 0xFF134978 - 0xFF134A30, length=47
void __attribute__((naked,noinline)) liveimage_task() {
asm volatile (
"    STMFD   SP!, {R3-R5,LR} \n"
"    LDR     R4, =0x5FA8 \n"
"    MOV     R5, #0 \n"

"loc_FF134984:\n"
"    LDR     R0, [R4, #0xC] \n"
"    MOV     R2, #0 \n"
"    MOV     R1, SP \n"
"    BL      sub_006B849C /*_ReceiveMessageQueue*/ \n"
"    TST     R0, #1 \n"
"    BEQ     loc_FF1349B4 \n"
"    MOV     R2, #0x78 \n"
"    LDR     R1, =0xFF134B90 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"
"    BL      _ExitTask \n"
"    LDMFD   SP!, {R3-R5,PC} \n"

"loc_FF1349B4:\n"
"    LDR     R1, [SP] \n"
"    LDR     R0, [R1] \n"
"    CMP     R0, #0 \n"
"    BEQ     loc_FF1349FC \n"
"    CMP     R0, #1 \n"
"    MOVEQ   R1, #1 \n"
"    BEQ     loc_FF134A14 \n"
"    CMP     R0, #2 \n"
"    BEQ     loc_FF134A10 \n"
"    CMP     R0, #3 \n"
"    BNE     loc_FF134A20 \n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R0, #1 \n"
"    BEQ     loc_FF134984 \n"
"    LDR     R0, [R4, #8] \n"
"    BLX     R0 \n"
"    STR     R5, [R4, #8] \n"
"    B       loc_FF134984 \n"

"loc_FF1349FC:\n"
"    LDR     R0, [R4, #4] \n"
"    CMP     R0, #1 \n"
"    ADDNE   R0, R1, #4 \n"
"    BLNE    sub_FF134C54_my \n"  // --> Patched. Old value = 0xFF134C54.
"    B       loc_FF134984 \n"

"loc_FF134A10:\n"
"    MOV     R1, #2 \n"

"loc_FF134A14:\n"
"    LDR     R0, [R4, #0x10] \n"
"    BL      sub_006B8230 /*_SetEventFlag*/ \n"
"    B       loc_FF134984 \n"

"loc_FF134A20:\n"
"    MOV     R2, #0x97 \n"
"    LDR     R1, =0xFF134B90 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    BL      _DebugAssert \n"
"    B       loc_FF134984 \n"
);
}

/*************************************************************/
//** sub_FF134C54_my @ 0xFF134C54 - 0xFF134D04, length=45
void __attribute__((naked,noinline)) sub_FF134C54_my() {
asm volatile (
"    LDR     R1, [R0] \n"
"    CMP     R1, #0x18 \n"
"    ADDCC   PC, PC, R1, LSL#2 \n"
"    B       loc_FF134CF8 \n"
"    B       sub_FF132EEC \n"
"    B       sub_FF133160 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CC8 \n"
"    B       sub_FF133AE4 \n"
"    B       sub_FF133CE0 \n"
"    B       sub_FF1340CC \n"
"    B       sub_FF132EEC \n"
"    B       sub_FF1338CC \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CC8 \n"
"    B       sub_FF1343F4 \n"
"    B       sub_FF1343F4 \n"
"    B       loc_FF134CF8 \n"
"    B       sub_FF13378C \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       loc_FF134CF8 \n"
"    B       sub_FF13303C \n"

"loc_FF134CC4:\n"
"    B       sub_FF13303C \n"

"loc_FF134CC8:\n"
// HD movie codepath
"    LDR     R1, [R0, #0x64] \n"
"    CMP     R1, #1 \n"
"    BNE     sub_FF133528_my \n"  // --> Patched. Old value = 0xFF133528.
"    BEQ     sub_FF133344_my \n"  // --> Patched. Old value = 0xFF133344.

"loc_FF134CD8:\n"
"    B       sub_FF133160 \n"

"loc_FF134CDC:\n"
"    B       sub_FF133AE4 \n"

"loc_FF134CE0:\n"
"    B       sub_FF132EEC \n"

"loc_FF134CE4:\n"
"    B       sub_FF133CE0 \n"

"loc_FF134CE8:\n"
"    B       sub_FF13378C \n"

"loc_FF134CEC:\n"
"    B       sub_FF1338CC \n"

"loc_FF134CF0:\n"
"    B       sub_FF1340CC \n"

"loc_FF134CF4:\n"
"    B       sub_FF1343F4 \n"

"loc_FF134CF8:\n"
"    MOV     R2, #0x69 \n"
"    LDR     R1, =0xFF134B90 /*'LiveImageTask.c'*/ \n"
"    MOV     R0, #0 \n"
"    B       _DebugAssert \n"
);
}

/*************************************************************/
//** sub_FF133528_my @ 0xFF133528 - 0xFF133788, length=153
void __attribute__((naked,noinline)) sub_FF133528_my() {
asm volatile (
// Need to execute our code after the firmware subroutine
// it's more complicated here than usual
"    PUSH    {LR} \n"                        // +
"    MOV     LR, PC \n"                      // +
"    LDR     PC, =0xFF133528 \n"  // Continue in firmware
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
"    POP     {PC} \n"                        // +
);
}

/*************************************************************/
//** sub_FF133344_my @ 0xFF133344 - 0xFF133524, length=121
void __attribute__((naked,noinline)) sub_FF133344_my() {
asm volatile (
// Need to execute our code after the firmware subroutine
// it's more complicated here than usual
"    PUSH    {LR} \n"                        // +
"    MOV     LR, PC \n"                      // +
"    LDR     PC, =0xFF133344 \n"  // Continue in firmware
"    LDR     R0, =video_compression_rate \n" // +
"    BL      set_quality \n"                 // +
"    BL      modify_bitrate \n"              // + (modifies target bitrate if requested)
"    POP     {PC} \n"                        // +
);
}
