#include "lolevel.h"
#include "platform.h"
#include "core.h"
#include "conf.h"
#define NR_AUTO (0) //this camera needs it to be set back to zero
static long *nrflag = (long*)0x1e858;

// NOTE sx280hs had
//#define NR_AUTO (0) // not needed (in fact, it makes the camera crash)
extern int active_raw_buffer;
// debug
extern void _LogCameraEvent(int id,const char *fmt,...);

extern char *hook_raw_image_addr(void);

void log_capt_seq(int m)
{
    _LogCameraEvent(0x60,"cs m:%d arb:%d rb:0x%08x i:%04d",
                    m,
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}

void log_capt_seq2(int m)
{
    _LogCameraEvent(0x60,"cs end m:%d arb:%d rb:0x%08x i:%04d",
                    m,
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}
void log_capt_seq_override(void)
{
    _LogCameraEvent(0x60,"cs override arb:%d rb:0x%08x i:%04d",
                    active_raw_buffer,
                    hook_raw_image_addr(),
                    get_exposure_counter());
}


#include "../../../generic/capt_seq.c"
//-s=task_CaptSeq -c=189 -f=chdk
// task_CaptSeq 0xfc15275f
void __attribute__((naked,noinline)) capt_seq_task() {
    asm volatile (
"    push    {r3, r4, r5, r6, r7, lr}\n"
"    ldr     r4, =0x0003c478\n"
"    movs    r6, #0\n"
"    ldr     r5, =0x0000ba2c\n"
"loc_fc152766:\n"
"    movs    r2, #0\n"
"    mov     r1, sp\n"
"    ldr     r0, [r5, #8]\n"
"    blx     sub_fc2cf35c\n" // j_ReceiveMessageQueue
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc152788\n"
"    movw    r2, #0x448\n"
"    ldr     r1, =0xfc152410\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"    blx     sub_fc2cf36c\n"
"    pop     {r3, r4, r5, r6, r7, pc}\n"
"loc_fc152788:\n"
"    ldr     r0, [sp]\n"
"    ldr     r0, [r0]\n"
"    cmp     r0, #1\n"
"    beq     loc_fc1527a0\n"
"    cmp     r0, #0x29\n"
"    beq     loc_fc1527a0\n"
"    cmp     r0, #0x1d\n"
"    beq     loc_fc1527a0\n"
"    cmp     r0, #0x21\n"
"    beq     loc_fc1527a0\n"
"    bl      sub_fc1dd988\n"
"loc_fc1527a0:\n"
"    ldr     r0, [sp]\n"
"    ldr     r1, [r0]\n"
"    cmp     r1, #0x2b\n"
"    bhs     loc_fc152888\n"
"    tbb     [pc, r1]\n" // (jumptable r1 43 elements)
"branchtable_fc1527ac:\n"
"    .byte((loc_fc1527d8 - branchtable_fc1527ac) / 2)\n" // (case 0)
"    .byte((loc_fc1527f0 - branchtable_fc1527ac) / 2)\n" // (case 1)
"    .byte((loc_fc1527f8 - branchtable_fc1527ac) / 2)\n" // (case 2)
"    .byte((loc_fc152806 - branchtable_fc1527ac) / 2)\n" // (case 3)
"    .byte((loc_fc152800 - branchtable_fc1527ac) / 2)\n" // (case 4)
"    .byte((loc_fc152812 - branchtable_fc1527ac) / 2)\n" // (case 5)
"    .byte((loc_fc152818 - branchtable_fc1527ac) / 2)\n" // (case 6)
"    .byte((loc_fc15281e - branchtable_fc1527ac) / 2)\n" // (case 7)
"    .byte((loc_fc152826 - branchtable_fc1527ac) / 2)\n" // (case 8)
"    .byte((loc_fc152866 - branchtable_fc1527ac) / 2)\n" // (case 9)
"    .byte((loc_fc152830 - branchtable_fc1527ac) / 2)\n" // (case 10)
"    .byte((loc_fc152838 - branchtable_fc1527ac) / 2)\n" // (case 11)
"    .byte((loc_fc15284c - branchtable_fc1527ac) / 2)\n" // (case 12)
"    .byte((loc_fc152854 - branchtable_fc1527ac) / 2)\n" // (case 13)
"    .byte((loc_fc15285a - branchtable_fc1527ac) / 2)\n" // (case 14)
"    .byte((loc_fc152860 - branchtable_fc1527ac) / 2)\n" // (case 15)
"    .byte((loc_fc152870 - branchtable_fc1527ac) / 2)\n" // (case 16)
"    .byte((loc_fc152876 - branchtable_fc1527ac) / 2)\n" // (case 17)
"    .byte((loc_fc15287c - branchtable_fc1527ac) / 2)\n" // (case 18)
"    .byte((loc_fc152882 - branchtable_fc1527ac) / 2)\n" // (case 19)
"    .byte((loc_fc15288a - branchtable_fc1527ac) / 2)\n" // (case 20)
"    .byte((loc_fc15288e - branchtable_fc1527ac) / 2)\n" // (case 21)
"    .byte((loc_fc152894 - branchtable_fc1527ac) / 2)\n" // (case 22)
"    .byte((loc_fc15289a - branchtable_fc1527ac) / 2)\n" // (case 23)
"    .byte((loc_fc1528a0 - branchtable_fc1527ac) / 2)\n" // (case 24)
"    .byte((loc_fc1528a6 - branchtable_fc1527ac) / 2)\n" // (case 25)
"    .byte((loc_fc1528ac - branchtable_fc1527ac) / 2)\n" // (case 26)
"    .byte((loc_fc1528b4 - branchtable_fc1527ac) / 2)\n" // (case 27)
"    .byte((loc_fc1528ba - branchtable_fc1527ac) / 2)\n" // (case 28)
"    .byte((loc_fc1528be - branchtable_fc1527ac) / 2)\n" // (case 29)
"    .byte((loc_fc1528c6 - branchtable_fc1527ac) / 2)\n" // (case 30)
"    .byte((loc_fc1528cc - branchtable_fc1527ac) / 2)\n" // (case 31)
"    .byte((loc_fc1528f6 - branchtable_fc1527ac) / 2)\n" // (case 32)
"    .byte((loc_fc1528fc - branchtable_fc1527ac) / 2)\n" // (case 33)
"    .byte((loc_fc152902 - branchtable_fc1527ac) / 2)\n" // (case 34)
"    .byte((loc_fc152908 - branchtable_fc1527ac) / 2)\n" // (case 35)
"    .byte((loc_fc15290e - branchtable_fc1527ac) / 2)\n" // (case 36)
"    .byte((loc_fc152914 - branchtable_fc1527ac) / 2)\n" // (case 37)
"    .byte((loc_fc15291c - branchtable_fc1527ac) / 2)\n" // (case 38)
"    .byte((loc_fc152922 - branchtable_fc1527ac) / 2)\n" // (case 39)
"    .byte((loc_fc152946 - branchtable_fc1527ac) / 2)\n" // (case 40)
"    .byte((loc_fc15294c - branchtable_fc1527ac) / 2)\n" // (case 41)
"    .byte((loc_fc152966 - branchtable_fc1527ac) / 2)\n" // (case 42)
".align 1\n"
"loc_fc1527d8:\n"
"    ldr     r0, [r0, #0xc]\n"
"    uxtb    r0, r0\n"
"    bl      sub_fc152cfa\n"
"bl log_capt_seq_override\n"
"    BL      shooting_expo_param_override\n" //sx280
"    bl      sub_fc150454\n"
"    ldr     r0, [r4, #0x28]\n"
"    cmp     r0, #0\n"
"    beq     loc_fc1527ee\n"
//"    bl      sub_fc1dcab8\n" //may need _my routine sx280
"    bl      sub_fc1dcab8_my\n"
"loc_fc1527ee:\n"
"    b       loc_fc152966\n"
"loc_fc1527f0:\n"
"    ldr     r0, [r0, #0x10]\n" //case 1 normal shoot
//"    bl      sub_fc1dc8e2\n" //my need _my routinej
"    bl      sub_fc1dc8e2_my\n"
"    b       loc_fc152966\n"
"loc_fc1527f8:\n"
"    movs    r0, #1\n"
"    bl      sub_fc152ff4\n"
"    b       loc_fc152966\n"
"loc_fc152800:\n"
"    bl      sub_fc152a72\n"
"    b       loc_fc15280e\n"
"loc_fc152806:\n"
"    ldr     r0, [r0, #0xc]\n"
"    uxtb    r0, r0\n"
"    bl      sub_fc152ce2\n"
"loc_fc15280e:\n"
"    str     r6, [r4, #0x28]\n"
"    b       loc_fc152966\n"
"loc_fc152812:\n"
"    bl      sub_fc152ce8\n"
"    b       loc_fc152966\n"
"loc_fc152818:\n"
"    bl      sub_fc152ef0\n"
"    b       loc_fc15282a\n"
"loc_fc15281e:\n"
"    ldr     r0, [r0, #0x10]\n"
"    bl      sub_fc1dcb60\n"
"    b       loc_fc152966\n"
"loc_fc152826:\n"
"    bl      sub_fc152f7a\n"
"loc_fc15282a:\n"
"    bl      sub_fc150454\n"
"    b       loc_fc152966\n"
"loc_fc152830:\n"
"    ldr     r0, [r4, #0x54]\n"
"    bl      sub_fc153580\n"
"    b       loc_fc152966\n"
"loc_fc152838:\n"
"    bl      sub_fc15380c\n"
"    b       loc_fc152966\n"

".ltorg\n"
/*
" literals here
*/
"loc_fc15284c:\n"
"    ldr     r0, [r0, #0xc]\n"
"    bl      sub_fc153858\n"
"    b       loc_fc152966\n"
"loc_fc152854:\n"
"    bl      sub_fc1539d2\n"
"    b       loc_fc152966\n"
"loc_fc15285a:\n"
"    bl      sub_fc153da0\n"
"    b       loc_fc152966\n"
"loc_fc152860:\n"
"    bl      sub_fc153e36\n"
"    b       loc_fc152966\n"
"loc_fc152866:\n"
"    ldr     r0, [r0, #0xc]\n"
"    uxtb    r0, r0\n"
"    bl      sub_fc152ce2\n"
"    b       loc_fc152966\n"
"loc_fc152870:\n"
"    bl      sub_fc1db428\n"
"    b       loc_fc152966\n"
"loc_fc152876:\n"
"    bl      sub_fc1db610\n"
"    b       loc_fc152966\n"
"loc_fc15287c:\n"
"    bl      sub_fc1db6ac\n"
"    b       loc_fc152966\n"
"loc_fc152882:\n"
"    bl      sub_fc1db728\n"
"    b       loc_fc152966\n"
"loc_fc152888:\n"
"    b       loc_fc152958\n"
"loc_fc15288a:\n"
"    movs    r0, #0\n"
"    b       loc_fc1528ae\n"
"loc_fc15288e:\n"
"    bl      sub_fc1dbb14\n"
"    b       loc_fc152966\n"
"loc_fc152894:\n"
"    bl      sub_fc1dbb74\n"
"    b       loc_fc152966\n"
"loc_fc15289a:\n"
"    bl      sub_fc1dbb78\n"
"    b       loc_fc152966\n"
"loc_fc1528a0:\n"
"    bl      sub_fc1dbb88\n"
"    b       loc_fc152966\n"
"loc_fc1528a6:\n"
"    bl      sub_fc1dbc00\n"
"    b       loc_fc152966\n"
"loc_fc1528ac:\n"
"    movs    r0, #1\n"
"loc_fc1528ae:\n"
"    bl      sub_fc1db9f4\n"
"    b       loc_fc152966\n"
"loc_fc1528b4:\n"
"    bl      sub_fc153102\n"
"    b       loc_fc152966\n"
"loc_fc1528ba:\n"
"    movs    r0, #0\n"
"    b       loc_fc1528c0\n"
"loc_fc1528be:\n"
"    ldr     r0, [r0, #0xc]\n"
"loc_fc1528c0:\n"
"    bl      sub_fc153164\n"
"    b       loc_fc152966\n"
"loc_fc1528c6:\n"
"    bl      sub_fc1db8e8\n"
"    b       loc_fc152966\n"
"loc_fc1528cc:\n"
"    ldr     r1, =0x0003c4da\n"
"    movs    r2, #2\n"
"    movs    r0, #0x72\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1528e8\n"
"    movw    r2, #0x508\n"
"    ldr     r1, =0xfc152410\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc1528e8:\n"
"    ldrh.w  r0, [r4, #0x62]\n"
"    cmp     r0, #1\n"
"    bne     loc_fc152966\n"
"    bl      sub_fc1db8e2\n"
"    b       loc_fc152966\n"
"loc_fc1528f6:\n"
"    bl      sub_fc1db966\n"
"    b       loc_fc152966\n"
"loc_fc1528fc:\n"
"    bl      sub_fc1dd364\n"
"    b       loc_fc152966\n"
"loc_fc152902:\n"
"    bl      sub_fc150d7a\n"
"    b       loc_fc152966\n"
"loc_fc152908:\n"
"    bl      sub_fc2aa49e\n"
"    b       loc_fc152966\n"
"loc_fc15290e:\n"
"    bl      sub_fc2aa578\n"
"    b       loc_fc152966\n"
"loc_fc152914:\n"
"    ldr     r0, [r0, #0xc]\n"
"    bl      sub_fc1dbcd4\n"
"    b       loc_fc152966\n"
"loc_fc15291c:\n"
"    bl      sub_fc1dbd3c\n"
"    b       loc_fc152966\n"
"loc_fc152922:\n"
"    bl      sub_fc15893e\n"
"    ldrh.w  r0, [r4, #0x1a4]\n"
"    cmp     r0, #4\n"
"    beq     loc_fc152938\n"
"    ldrh    r0, [r4]\n"
"    sub.w   r1, r0, #0x4200\n"
"    subs    r1, #0x36\n"
"    bne     loc_fc152966\n"
"loc_fc152938:\n"
"    bl      sub_fc2aa578\n"
"    bl      sub_fc2aaa8e\n"
"    bl      sub_fc2aa8d6\n"
"    b       loc_fc152966\n"
"loc_fc152946:\n"
"    movs    r2, #0\n"
"    movs    r1, #0x11\n"
"    b       loc_fc152950\n"
"loc_fc15294c:\n"
"    movs    r2, #0\n"
"    movs    r1, #0x10\n"
"loc_fc152950:\n"
"    movs    r0, #0\n"
"    bl      sub_fc150f62\n"
"    b       loc_fc152966\n"
"loc_fc152958:\n"
"    movw    r2, #0x572\n"
"    ldr     r1, =0xfc152410\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc152966:\n"
// debug after message handled
"ldr     r0, [sp]\n"
"ldr     r0, [r0]\n"
"bl log_capt_seq2\n"
"    BL      capt_seq_hook_set_nr\n" //  dark frame control
"    ldr     r0, [sp]\n"
"    ldr     r1, [r0, #4]\n"
"    ldr     r0, [r5, #4]\n"
"    blx     sub_fc2cf33c\n" // j_SetEventFlag
"    ldr     r7, [sp]\n"
"    ldr     r0, [r7, #8]\n"
"    cbnz    r0, loc_fc152984\n"
"    movw    r2, #0x128\n"
"    ldr     r1, =0xfc152410\n" //  *"SsShootTask.c"
"    movs    r0, #0\n"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc152984:\n"
"    str     r6, [r7, #8]\n"
"    b       loc_fc152766\n"

".ltorg\n"
   );
}
// -s=0xfc1dcab9 -c=56 -f=chdk
void __attribute__((naked,noinline)) sub_fc1dcab8_my() {
    asm volatile (
"    push    {r3, r4, r5, r6, r7, lr}\n"
"    bl      sub_fc151ece\n"
"    mov     r4, r0\n"
"    movs    r0, #0xc\n"
"    bl      sub_fc2d7944\n"
"    ldr     r6, =0x00014348\n"
"    lsls    r0, r0, #0x1f\n"
"    mov.w   r5, #1\n"
"    bne     loc_fc1dcb52\n"
"    movs    r2, #2\n"
"    mov     r1, sp\n"
"    movw    r0, #0x10d\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1dcaec\n"
"    movs    r0, #0\n"
"    movw    r2, #0x16d\n"
"    ldr     r1, =0xfc1dcc38\n" //  *"SsCaptureCtrl.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc1dcaec:\n"
"    ldrsh.w r0, [sp]\n"
"    bl      sub_fc1377fe\n"
"    bl      sub_fc1376d6\n"
"    cmp     r0, #1\n"
"    bls     loc_fc1dcb56\n"
"    movs    r0, #0\n"
"    bl      sub_fc13778e\n"
"    bl      sub_fc152cee\n"
"    bl      sub_fc154bcc\n"
"    mov     r1, r4\n"
"    bl      sub_fc154c1a\n"
"    movs    r2, #4\n"
"    movw    r0, #0x113\n"
"    add.w   r1, r4, #0x58\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x2d\n"
"    add.w   r1, r4, #0x5c\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x41\n"
"    add.w   r1, r4, #8\n"
"    bl      _SetPropertyCase\n"
"    bl      sub_fc1dd18e\n"
"    mvn     r1, #0x1000\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    mov     r0, r4\n"
"    bl      sub_fc1dc688\n"
"    mov     r0, r4\n"
//"    bl      sub_fc39ff8c\n"
"    bl      sub_fc39ff8c_my\n" //->
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1dcb54\n"
"loc_fc1dcb52:\n"
"    str     r5, [r6]\n"
"loc_fc1dcb54:\n"
//"    BL      capt_seq_hook_raw_here \n" // + ???
"    pop     {r3, r4, r5, r6, r7, pc}\n"
"loc_fc1dcb56:\n"
"    bl      sub_fc150d70\n"
"    bl      sub_fc2d797c\n"
"    pop     {r3, r4, r5, r6, r7, pc}\n"
".ltorg\n"
    );
}
 
// -s=0xfc1dc8e3 -c=177 -f=chdk
void __attribute__((naked,noinline)) sub_fc1dc8e2_my() {
    asm volatile (
"    push    {r2, r3, r4, r5, r6, lr}\n"
"    ldr     r6, =0x0003c478\n"
"    mov     r4, r0\n"
"    movs    r5, #0\n"
"    ldr     r0, [r6, #0x28]\n"
"    cbz     r0, loc_fc1dc90a\n"
"    ldr     r0, =0x00014348\n"
"    ldr     r0, [r0]\n"
"    cbz     r0, loc_fc1dc8f6\n"
"    movs    r5, #0x1d\n"
"loc_fc1dc8f6:\n"
"    mov     r2, r4\n"
"    movs    r1, #2\n"
"    mov     r0, r5\n"
"    bl      sub_fc150f62\n"
"    mov     r1, r5\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dd7e6\n"
"    b       loc_fc1dcab2\n"
"loc_fc1dc90a:\n"
"    bl      sub_fc154bcc\n"
"    mov     r1, r4\n"
"    bl      sub_fc154c1a\n"
"    movs    r2, #4\n"
"    movw    r0, #0x113\n"
"    add.w   r1, r4, #0x58\n"
"    bl      _SetPropertyCase\n"
"    movs    r2, #4\n"
"    movs    r0, #0x2d\n"
"    add.w   r1, r4, #0x5c\n"
"    bl      _SetPropertyCase\n"
"    ldr.w   r0, [r6, #0x10c]\n"
"    cbnz    r0, loc_fc1dc944\n"
"    ldrh.w  r0, [r6, #0x1a2]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc1dc94a\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc1dc95a\n"
"    b       loc_fc1dc94a\n"
"loc_fc1dc944:\n"
"    ldr     r0, [r4, #0xc]\n"
"    cmp     r0, #1\n"
"    bne     loc_fc1dc95a\n"
"loc_fc1dc94a:\n"
"    movs    r0, #0xc\n"
"    bl      sub_fc2d7944\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1dc95a\n"
"    bl      sub_fc150d70\n"
"    movs    r5, #1\n"
"loc_fc1dc95a:\n"
"    lsls    r0, r5, #0x1f\n"
"    bne     loc_fc1dca5c\n"
"    ldr.w   r0, [r6, #0xec]\n"
"    cbz     r0, loc_fc1dc97e\n"
"    ldrh.w  r0, [r6, #0x1a2]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc1dc972\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc1dc9be\n"
"loc_fc1dc972:\n"
"    ldr.w   r0, [r6, #0x10c]\n"
"    cbz     r0, loc_fc1dc97e\n"
"    ldr     r0, [r4, #0xc]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc1dc9be\n"
"loc_fc1dc97e:\n"
"    movs    r2, #2\n"
"    movw    r0, #0x10d\n"
"    add     r1, sp, #4\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1dc998\n"
"    movs    r2, #0xc9\n"
"    movs    r0, #0\n"
"    ldr     r1, =0xfc1dcc38\n" //  *"SsCaptureCtrl.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc1dc998:\n"
"    ldrsh.w r0, [sp, #4]\n"
"    bl      sub_fc1377fe\n"
"    bl      sub_fc1376d6\n"
"    cmp     r0, #1\n"
"    bls     loc_fc1dc9b0\n"
"    movs    r0, #0\n"
"    bl      sub_fc13778e\n"
"    b       loc_fc1dc9be\n"
"loc_fc1dc9b0:\n"
"    bl      sub_fc150d70\n"
"    bl      sub_fc2d797c\n"
"    movs    r5, #1\n"
"    lsls    r0, r5, #0x1f\n"
"    bne     loc_fc1dcaa0\n"
"loc_fc1dc9be:\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dd3ae\n"
"    mov     r5, r0\n"
"    lsls    r0, r0, #0x1f\n"
"    bne     loc_fc1dcaa0\n"
"    bl      sub_fc1dd18e\n"
"    mvn     r1, #0x1000\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    mov     r0, r4\n"
"    bl      sub_fc39fc6a\n"
"    mov     r5, r0\n"
"    lsls    r0, r0, #0x1f\n"
"    bne     loc_fc1dcaa0\n"
"    bl      sub_fc152cee\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc688\n"
"    ldr.w   r0, [r6, #0x130]\n"
"    cbnz    r0, loc_fc1dca00\n"
"    ldrh.w  r0, [r6, #0x1a2]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc1dca00\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc1dca06\n"
"loc_fc1dca00:\n"
"    movs    r0, #2\n"
"    bl      sub_fc15980a\n"
"loc_fc1dca06:\n"
"    ldr.w   r0, [r6, #0xa8]\n"
"    cmp     r0, #0\n"
"    beq     loc_fc1dca7c\n"
"    ldrh.w  r0, [r6, #0x1a2]\n"
"    movw    r5, #0x1000\n"
"    cmp     r0, #3\n"
"    beq     loc_fc1dca36\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bls     loc_fc1dca36\n"
"    bl      sub_fc1dd18e\n"
"    movw    r3, #0x112\n"
"    movw    r2, #0x3a98\n"
"    mov     r1, r5\n"
"    str     r3, [sp]\n"
"    ldr     r3, =0xfc1dcc38\n" //  *"SsCaptureCtrl.c"
"    bl      sub_fc2d7af8\n"
"loc_fc1dca36:\n"
"    movs    r2, #4\n"
"    movw    r0, #0x185\n"
"    add     r1, sp, #4\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc1dca52\n"
"    movs    r0, #0\n"
"    movw    r2, #0x116\n"
"    ldr     r1, =0xfc1dcc38\n" //  *"SsCaptureCtrl.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc1dca52:\n"
"    ldr     r0, [sp, #4]\n"
"    cbnz    r0, loc_fc1dca66\n"
"    bl      sub_fc1dd18e\n"
"    b       loc_fc1dca5e\n"
"loc_fc1dca5c:\n"
"    b       loc_fc1dcaa0\n"
"loc_fc1dca5e:\n"
"    mov     r1, r5\n"
"    blx     sub_fc2cf33c\n" // j_SetEventFlag
"    b       loc_fc1dca7c\n"
"loc_fc1dca66:\n"
"    bl      sub_fc1dd18e\n"
"    mov     r1, r5\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    ldr     r2, =0xfc1dc8d1\n"
"    mov     r3, r5\n"
"    ldr     r0, [sp, #4]\n"
"    mov     r1, r2\n"
"    bl      sub_fc322d84\n"
"loc_fc1dca7c:\n"
"    ldr.w   r0, [r6, #0xb0]\n"
"    cbz     r0, loc_fc1dca8a\n"
"    mov     r0, r4\n"
"    bl      sub_fc3a0754\n"
"    b       loc_fc1dcab2\n"
"loc_fc1dca8a:\n"
"    ldr.w   r0, [r6, #0xb4]\n"
"    cmp     r0, #0\n"
"    mov     r0, r4\n"
"    beq     loc_fc1dca9a\n"
"    bl      sub_fc3a03c2\n"
"    b       loc_fc1dcab2\n"
"loc_fc1dca9a:\n"
//"    bl      sub_fc39ff8c\n"
"    bl      sub_fc39ff8c_my\n" // SsStandardCaptureSeq.c hook
"    b       loc_fc1dcab2\n"
"loc_fc1dcaa0:\n"
"    movs    r1, #2\n"
"    mov     r2, r4\n"
"    mov     r0, r5\n"
"    bl      sub_fc150f62\n"
"    mov     r1, r5\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dd91c\n"
"loc_fc1dcab2:\n"
"    movs    r0, #0\n"
"    str     r0, [r6, #0x28]\n"
"    pop     {r2, r3, r4, r5, r6, pc}\n"
    );
}
// -s=0xfc39ff8d -c=201 -f=chdk
void __attribute__((naked,noinline)) sub_fc39ff8c_my() {
    asm volatile ( 
"    push.w  {r2, r3, r4, r5, r6, r7, r8, sb, sl, lr}\n"
"    ldr     r7, =0x0003c478\n"
"    mov     r4, r0\n"
"    ldr.w   r0, [r7, #0x16c]\n"
"    cbz     r0, loc_fc39ffa8\n"
"    ldrh.w  r0, [r7, #0x1a2]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc39ffa8\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc39ffb2\n"
"loc_fc39ffa8:\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc61e\n"
"    bl      sub_fc1dd04a\n"
"loc_fc39ffb2:\n"
"    ldr.w   r0, [r7, #0xa4]\n"
"    cbnz    r0, loc_fc39ffce\n"
"    ldrh.w  r0, [r7, #0x1a2]\n"
"    cmp     r0, #3\n"
"    beq     loc_fc39ffc6\n"
"    ldr     r0, [r4, #8]\n"
"    cmp     r0, #1\n"
"    bhi     loc_fc39ffce\n"
"loc_fc39ffc6:\n"
"    bl      sub_fc153152\n"
"    bl      sub_fc1dcc6a\n"
"loc_fc39ffce:\n"
"    movs    r2, #4\n"
"    movw    r0, #0x134\n"
"    add     r1, sp, #4\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc39ffea\n"
"    movs    r0, #0\n"
"    movw    r2, #0x193\n"
"    ldr     r1, =0xfc3a033c\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc39ffea:\n"
"    ldr     r0, [sp, #4]\n"
"    ubfx    r0, r0, #8, #8\n"
"    cmp     r0, #6\n"
"    bne     loc_fc39fffa\n"
"    ldr     r0, =0xfc39ff2f\n"
"    movs    r1, #0\n"
"    b       loc_fc39fffe\n"
"loc_fc39fffa:\n"
"    ldr     r0, =0xfc1dc2e3\n"
"    mov     r1, r4\n"
"loc_fc39fffe:\n"
"    bl      sub_fc16fe1c\n"
"    ldr.w   r0, [r7, #0x18c]\n"
"    cbz     r0, loc_fc3a000c\n"
"    bl      sub_fc1dc556\n"
"loc_fc3a000c:\n"
"    movs    r0, #0\n"
"    bl      sub_fc15655e\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc734\n"
"    ldr     r1, =0x000265c4\n"
"    movs    r2, #4\n"
"    movs    r0, #0x8d\n"
"    bl      _GetPropertyCase\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc3a0032\n"
"    movs    r0, #0\n"
"    movw    r2, #0x1ae\n"
"    ldr     r1, =0xfc3a033c\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc3a0032:\n"
"    bl      sub_fc156618\n"
"    bl      sub_fc1dc7d0\n"
"    movs    r1, #0\n"
"    mov     r0, r4\n"
"    bl      sub_fc39ff30\n"
"    mov     r6, r0\n"
"    BL      wait_until_remote_button_is_released\n" // + remote hook
"bl log_remote_hook\n"
"    ldr     r0, [sp, #4]\n"
"    ubfx    r0, r0, #8, #8\n"
"    cmp     r0, #6\n"
"    bne     loc_fc3a0052\n"
"    ldr     r2, =0xfc1dc525\n"
"    b       loc_fc3a0054\n"
"loc_fc3a0052:\n"
"    ldr     r2, =0xfc1dc53b\n"
"loc_fc3a0054:\n"
"    ldrh    r0, [r4, #0x18]\n"
"    ldr     r5, =0x000265c4\n"
"    cbz     r0, loc_fc3a0062\n"
"    cmp     r0, #1\n"
"    beq     loc_fc3a0078\n"
"    cmp     r0, #4\n"
"    bne     loc_fc3a00de\n"
"loc_fc3a0062:\n"
"    str     r6, [sp]\n"
"    mov     r3, r2\n"
"    ldr     r1, [r4, #0x5c]\n"
"    mov     r0, r4\n"
"    ldr     r2, [r5]\n"
"    bl      sub_fc1dc136\n"
"    mov     r5, r0\n"
"    bl      sub_fc28bb1a\n"
"    b       loc_fc3a00ec\n"
"loc_fc3a0078:\n"
"    str     r6, [sp]\n"
"    mov     r3, r2\n"
"    ldr     r1, [r4, #0x5c]\n"
"    mov     r8, r5\n"
"    ldr     r2, [r5]\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc196\n"
"    movs    r2, #1\n"
"    mov     r5, r0\n"
"    movs    r1, #0\n"
"    movs    r0, #0x45\n"
"    bl      sub_fc277210\n"
"    lsls    r0, r5, #0x1f\n"
"    bne     loc_fc3a00ec\n"
"    ldr.w   r0, [r7, #0x100]\n"
"    cbz     r0, loc_fc3a00ae\n"
"    ldr     r1, [r4, #8]\n"
"    ldr     r2, =0x00212cc4\n"
"    ldr     r0, [r4, #0x5c]\n"
"    add.w   r1, r2, r1, lsl #2\n"
"    str     r0, [r1, #-0x4]\n"
"    b       loc_fc3a00d8\n"
"loc_fc3a00ae:\n"
"    ldr     r0, =0xfc39ff2f\n"
"    movs    r1, #0\n"
"    bl      sub_fc16fe1c\n"
"    movs    r1, #1\n"
"    mov     r0, r4\n"
"    bl      sub_fc39ff30\n"
"    mov     r6, r0\n"
"    ldr.w   r0, [r8]\n"
"    mov     r5, r8\n"
"    bl      sub_fc1dc5c0\n"
"    ldr     r1, [r4, #0x5c]\n"
"    mov     r3, r6\n"
"    ldr     r2, [r5]\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc204\n"
"    mov     r5, r0\n"
"loc_fc3a00d8:\n"
"    bl      sub_fc1dc0e0\n"
"    b       loc_fc3a00ec\n"
"loc_fc3a00de:\n"
"    movs    r0, #0\n"
"    movw    r2, #0x1e1\n"
"    ldr     r1, =0xfc3a033c\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"    movs    r5, #0x1d\n"
"loc_fc3a00ec:\n"
"    bl      sub_fc1dc7d4\n"
"    ldr.w   r8, =0xfc39ff2f\n"
"    lsls    r0, r5, #0x1f\n"
"    bne     loc_fc3a0148\n"
"    ldr.w   r0, [r7, #0x108]\n"
"    cbnz    r0, loc_fc3a0114\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dddca\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc3a0114\n"
"    movs    r0, #0\n"
"    movw    r2, #0x207\n"
"    ldr     r1, =0xfc3a033c\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc3a0114:\n"
"bl log_rh\n"
"BL capt_seq_hook_raw_here\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc7c0\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dc794\n"
"    cmp     r6, r8\n"
"    beq     loc_fc3a0148\n"
"    bl      sub_fc1dd18e\n"
"    movs    r1, #4\n"
"    movw    sb, #0x214\n"
"    ldr     r3, =0xfc3a033c\n" //  *"SsStandardCaptureSeq.c"
"    movw    r2, #0x3a98\n"
"    str.w   sb, [sp]\n"
"    bl      sub_fc2d7af8\n"
"    cbz     r0, loc_fc3a0148\n"
"    movs    r0, #0\n"
"    mov     r2, sb\n"
"    ldr     r1, =0xfc3a033c\n" //  *"SsStandardCaptureSeq.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc3a0148:\n"
"    ldr.w   r0, [r7, #0x18c]\n"
"    cbz     r0, loc_fc3a0158\n"
"    movs    r2, #1\n"
"    movs    r1, #0\n"
"    movs    r0, #0x46\n"
"    bl      sub_fc277210\n"
"loc_fc3a0158:\n"
"    movs    r1, #2\n"
"    mov     r2, r4\n"
"    mov     r0, r5\n"
"    bl      sub_fc150f62\n"
"    ldr     r0, [r7, #0x28]\n"
"    cmp     r0, #0\n"
"    mov     r0, r8\n"
"    beq     loc_fc3a017e\n"
"    cmp     r6, r0\n"
"    beq     loc_fc3a0172\n"
"    movs    r1, #1\n"
"    b       loc_fc3a0174\n"
"loc_fc3a0172:\n"
"    movs    r1, #0\n"
"loc_fc3a0174:\n"
"    mov     r2, r5\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dd7a4\n"
"    b       loc_fc3a0190\n"
"loc_fc3a017e:\n"
"    cmp     r6, r0\n"
"    beq     loc_fc3a0186\n"
"    movs    r1, #1\n"
"    b       loc_fc3a0188\n"
"loc_fc3a0186:\n"
"    movs    r1, #0\n"
"loc_fc3a0188:\n"
"    mov     r2, r5\n"
"    mov     r0, r4\n"
"    bl      sub_fc1dd75e\n"
"loc_fc3a0190:\n"
"    mov     r0, r5\n"
"    pop.w   {r2, r3, r4, r5, r6, r7, r8, sb, sl, pc}\n"

".ltorg\n"
     );
}

void log_remote_hook(void) {
    _LogCameraEvent(0x60,"remote hook");
}
void log_rh(void) {
    _LogCameraEvent(0x60,"raw hook");
}

//exp_drv_task  -s=task_ExpDrv -c=428 -f=chdk

void __attribute__((naked,noinline)) exp_drv_task() {
    asm volatile (
// task_ExpDrv 0xfc291cdf
"    push.w  {r4, r5, r6, r7, r8, sb, sl, fp, lr}\n"
"    sub     sp, #0x2c\n"
"    ldr.w   sb, =0x0000d1b0\n"
"    ldr.w   sl, =0xfffff400\n"
"    movs    r0, #0\n"
"    ldr     r6, =0x0005e458\n"
"    add.w   r8, sp, #0x1c\n"
"    movw    fp, #0xbb8\n"
"    str     r0, [sp, #0xc]\n"
"loc_fc291cfa:\n"
"    ldr.w   r0, [sb, #0x20]\n"
"    movs    r2, #0\n"
"    add     r1, sp, #0x28\n"
"    mov     r4, sb\n"
"    blx     sub_fc2cf35c\n" // j_ReceiveMessageQueue
"    ldr     r0, [sp, #0xc]\n"
"    cmp     r0, #1\n"
"    bne     loc_fc291d32\n"
"    ldr     r0, [sp, #0x28]\n"
"    ldr     r0, [r0]\n"
"    cmp     r0, #0x14\n"
"loc_fc291d14:\n"
"    beq     loc_fc291e14\n"
"    cmp     r0, #0x15\n"
"    beq     loc_fc291d14\n"
"    cmp     r0, #0x16\n"
"    beq     loc_fc291d14\n"
"    cmp     r0, #0x17\n"
"    beq     loc_fc291d14\n"
"    cmp     r0, #0x18\n"
"    beq     loc_fc291e24\n"
"    cmp     r0, #0x2e\n"
"    beq     loc_fc291dce\n"
"    movs    r0, #0\n"
"    add     r1, sp, #0xc\n"
"    bl      sub_fc291c9a\n"
"loc_fc291d32:\n"
"    ldr     r0, [sp, #0x28]\n"
"    ldr     r1, [r0]\n"
"    cmp     r1, #0x34\n"
"    bne     loc_fc291d50\n"
"    bl      sub_fc292b92\n"
"    ldr.w   r0, [sb, #0x1c]\n"
"    movs    r1, #1\n"
"    blx     sub_fc2cf33c\n" // j_SetEventFlag
"    blx     sub_fc2cf36c\n"
"    add     sp, #0x2c\n"
//"    b       loc_fc291a24\n" //out of range
" ldmia.w sp!, {r4, r5, r6, r7, r8, r9, sl, fp, pc}\n"
//// 0xfc291a24
//"    pop.w   {r4, r5, r6, r7, r8, sb, sl, fp, pc}\n"

"loc_fc291d50:\n"
"    cmp     r1, #0x33\n"
"    bne     loc_fc291d62\n"
"    add.w   r0, r0, #0xac\n"
"    ldrd    r2, r1, [r0]\n"
"    mov     r0, r1\n"
"    blx     r2\n"
"    b       loc_fc292172\n"
"loc_fc291d62:\n"
"    cmp     r1, #0x2c\n"
"    bne     loc_fc291d98\n"
"    ldr     r0, [r4, #0x1c]\n"
"    movs    r1, #0x80\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    ldr     r0, =0xfc28db45\n"
"    movs    r1, #0x80\n"
"    bl      sub_fc14d27a\n"
"    ldr     r0, [r4, #0x1c]\n"
"    movs    r1, #0x80\n"
"    mov     r2, fp\n"
"    blx     sub_fc2cf1cc\n" // j_WaitForAllEventFlag
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc291d8a\n"
"    movw    r2, #0x17d8\n"
"    b       loc_fc291e1a\n"
"loc_fc291d8a:\n"
"    ldr     r1, [sp, #0x28]\n"
"    add.w   r1, r1, #0xac\n"
"    ldrd    r1, r0, [r1]\n"
"    blx     r1\n"
"    b       loc_fc292172\n"
"loc_fc291d98:\n"
"    cmp     r1, #0x2d\n"
"    bne     loc_fc291dca\n"
"    add     r1, sp, #0xc\n"
"    bl      sub_fc291c9a\n"
"    movw    r5, #0x100\n"
"    ldr     r0, [r4, #0x1c]\n"
"    mov     r1, r5\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    ldr     r0, =0xfc28db4f\n"
"    mov     r1, r5\n"
"    bl      sub_fc14dbfa\n"
"    ldr     r0, [r4, #0x1c]\n"
"    mov     r2, fp\n"
"    mov     r1, r5\n"
"    blx     sub_fc2cf1cc\n" // j_WaitForAllEventFlag
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc291d8a\n"
"    movw    r2, #0x17e2\n"
"    b       loc_fc291e1a\n"
"loc_fc291dca:\n"
"    cmp     r1, #0x2e\n"
"    bne     loc_fc291dd8\n"
"loc_fc291dce:\n"
"    ldr     r0, [sp, #0x28]\n"
"    add     r1, sp, #0xc\n"
"    bl      sub_fc291c9a\n"
"    b       loc_fc291d8a\n"
"loc_fc291dd8:\n"
"    cmp     r1, #0x31\n"
"    bne     loc_fc291dea\n"
"    bl      sub_fc16d89c\n"
"    bl      sub_fc16e228\n"
"    bl      sub_fc16df0a\n"
"    b       loc_fc291d8a\n"
"loc_fc291dea:\n"
"    cmp     r1, #0x32\n"
"    bne     loc_fc291e24\n"
"    ldr     r0, [r4, #0x1c]\n"
"    movs    r1, #4\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    ldr     r1, =0xfc28db63\n"
"    movs    r2, #4\n"
"    mov     r0, sl\n"
"    bl      sub_fc292be4\n"
"    bl      sub_fc16d5fe\n"
"    ldr     r0, [r4, #0x1c]\n"
"    movs    r1, #4\n"
"    mov     r2, fp\n"
"    blx     sub_fc2cf3e4\n" // j_WaitForAnyEventFlag
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc291d8a\n"
"    b       loc_fc291e16\n"
"loc_fc291e14:\n"
"    b       loc_fc291e24\n"
"loc_fc291e16:\n"
"    movw    r2, #0x181a\n"
"loc_fc291e1a:\n"
"    ldr     r1, =0xfc28e370\n" //  **"ExpDrv.c"
"    movs    r0, #0\n"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"    b       loc_fc291d8a\n"
"loc_fc291e24:\n"
"    ldr     r0, [sp, #0x28]\n"
"    movs    r5, #1\n"
"    ldr     r1, [r0]\n"
"    cmp     r1, #0x12\n"
"    beq     loc_fc291e32\n"
"    cmp     r1, #0x13\n"
"    bne     loc_fc291e70\n"
"loc_fc291e32:\n"
"    ldr.w   r1, [r0, #0x94]\n"
"    mov     r4, r8\n"
"    add.w   r1, r1, r1, lsl #1\n"
"    add.w   r1, r0, r1, lsl #2\n"
"    subs    r1, #8\n"
"    ldm     r1!, {r2, r3, r7}\n"
"    stm     r4!, {r2, r3, r7}\n"
"    bl      sub_fc290588\n"
"    ldr     r0, [sp, #0x28]\n"
"    add.w   r0, r0, #0x94\n"
"    ldrd    r3, r2, [r0, #0x18]\n"
"    ldr     r1, [r0]\n"
"    sub.w   r0, r0, #0x90\n"
"    blx     r3\n"
"    ldr     r0, [sp, #0x28]\n"
"    bl      sub_fc292dfa\n"
"    ldr     r0, [sp, #0x28]\n"
"    add.w   r0, r0, #0x94\n"
"    ldr     r1, [r0]\n"
"    ldrd    r3, r2, [r0, #0x20]\n"
"    b       loc_fc292098\n"
"loc_fc291e70:\n"
"    cmp     r1, #0x14\n"
"    beq     loc_fc291e84\n"
"    cmp     r1, #0x15\n"
"    beq     loc_fc291e84\n"
"    cmp     r1, #0x16\n"
"    beq     loc_fc291e84\n"
"    cmp     r1, #0x17\n"
"    beq     loc_fc291e84\n"
"    cmp     r1, #0x18\n"
"    bne     loc_fc291ef6\n"
"loc_fc291e84:\n"
"    add     r3, sp, #0xc\n"
"    mov     r2, sp\n"
"    add     r1, sp, #0x1c\n"
"    bl      sub_fc29075c\n"
"    cmp     r0, #1\n"
"    mov     r4, r0\n"
"    beq     loc_fc291e98\n"
"    cmp     r4, #5\n"
"    bne     loc_fc291eae\n"
"loc_fc291e98:\n"
"    ldr     r0, [sp, #0x28]\n"
"    mov     r2, r4\n"
"    add.w   r0, r0, #0x94\n"
"    ldrd    r7, r3, [r0, #0x18]\n"
"    ldr     r1, [r0]\n"
"    sub.w   r0, r0, #0x90\n"
"    blx     r7\n"
"    b       loc_fc291ed4\n"
"loc_fc291eae:\n"
"    cmp     r4, #2\n"
"    beq     loc_fc291eb6\n"
"    cmp     r4, #6\n"
"    bne     loc_fc291ee0\n"
"loc_fc291eb6:\n"
"    ldr     r0, [sp, #0x28]\n"
"    mov     r2, r4\n"
"    add.w   r0, r0, #0x94\n"
"    ldrd    r7, r3, [r0, #0x18]\n"
"    ldr     r1, [r0]\n"
"    sub.w   r0, r0, #0x90\n"
"    blx     r7\n"
"    ldr     r0, [sp, #0x28]\n"
"    add     r1, sp, #0x1c\n"
"    mov     r2, sp\n"
"    bl      sub_fc291a28\n"
"loc_fc291ed4:\n"
"    ldr     r2, [sp, #0xc]\n"
"    mov     r1, r4\n"
"    ldr     r0, [sp, #0x28]\n"
"    bl      sub_fc291c4a\n"
"    b       loc_fc29209e\n"
"loc_fc291ee0:\n"
"    ldr     r0, [sp, #0x28]\n"
"    mov     r2, r4\n"
"    add.w   r0, r0, #0x94\n"
"    ldrd    r7, r3, [r0, #0x18]\n"
"    ldr     r1, [r0]\n"
"    sub.w   r0, r0, #0x90\n"
"    blx     r7\n"
"    b       loc_fc29209e\n"
"loc_fc291ef6:\n"
"    cmp     r1, #0x28\n"
"    beq     loc_fc291efe\n"
"    cmp     r1, #0x29\n"
"    bne     loc_fc291f30\n"
"loc_fc291efe:\n"
"    ldr.w   r1, [r0, #0x94]\n"
"    mov     r4, r8\n"
"    add.w   r1, r1, r1, lsl #1\n"
"    add.w   r1, r0, r1, lsl #2\n"
"    subs    r1, #8\n"
"    ldm     r1!, {r2, r3, r7}\n"
"    stm     r4!, {r2, r3, r7}\n"
"    bl      sub_fc28f6bc\n"
"    ldr     r0, [sp, #0x28]\n"
"    add.w   r0, r0, #0x94\n"
"    ldrd    r3, r2, [r0, #0x18]\n"
"    ldr     r1, [r0]\n"
"    sub.w   r0, r0, #0x90\n"
"    blx     r3\n"
"    ldr     r0, [sp, #0x28]\n"
"    bl      sub_fc28faac\n"
"    b       loc_fc29209e\n"
"loc_fc291f30:\n"
"    adds    r1, r0, #4\n"
"    mov     r4, r8\n"
"    ldm     r1!, {r2, r3, r7}\n"
"    stm     r4!, {r2, r3, r7}\n"
"    ldr     r1, [r0]\n"
"    cmp     r1, #0x2c\n"
"    bhs     loc_fc291f72\n"
"    tbb     [pc, r1]\n" // (jumptable r1 44 elements)
"branchtable_fc291f42:\n"
"    .byte((loc_fc291f6e - branchtable_fc291f42) / 2)\n" // (case 0)
"    .byte((loc_fc291f6e - branchtable_fc291f42) / 2)\n" // (case 1)
"    .byte((loc_fc291f74 - branchtable_fc291f42) / 2)\n" // (case 2)
"    .byte((loc_fc291f7a - branchtable_fc291f42) / 2)\n" // (case 3)
"    .byte((loc_fc291f7a - branchtable_fc291f42) / 2)\n" // (case 4)
"    .byte((loc_fc291f7a - branchtable_fc291f42) / 2)\n" // (case 5)
"    .byte((loc_fc291f6e - branchtable_fc291f42) / 2)\n" // (case 6)
"    .byte((loc_fc291f74 - branchtable_fc291f42) / 2)\n" // (case 7)
"    .byte((loc_fc291f7a - branchtable_fc291f42) / 2)\n" // (case 8)
"    .byte((loc_fc291f7a - branchtable_fc291f42) / 2)\n" // (case 9)
"    .byte((loc_fc291f8c - branchtable_fc291f42) / 2)\n" // (case 10)
"    .byte((loc_fc291f8c - branchtable_fc291f42) / 2)\n" // (case 11)
"    .byte((loc_fc29207c - branchtable_fc291f42) / 2)\n" // (case 12)
"    .byte((loc_fc292082 - branchtable_fc291f42) / 2)\n" // (case 13)
"    .byte((loc_fc292082 - branchtable_fc291f42) / 2)\n" // (case 14)
"    .byte((loc_fc292082 - branchtable_fc291f42) / 2)\n" // (case 15)
"    .byte((loc_fc292082 - branchtable_fc291f42) / 2)\n" // (case 16)
"    .byte((loc_fc292088 - branchtable_fc291f42) / 2)\n" // (case 17)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 18)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 19)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 20)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 21)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 22)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 23)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 24)
"    .byte((loc_fc291f80 - branchtable_fc291f42) / 2)\n" // (case 25)
"    .byte((loc_fc291f86 - branchtable_fc291f42) / 2)\n" // (case 26)
"    .byte((loc_fc291f86 - branchtable_fc291f42) / 2)\n" // (case 27)
"    .byte((loc_fc291f86 - branchtable_fc291f42) / 2)\n" // (case 28)
"    .byte((loc_fc291fbc - branchtable_fc291f42) / 2)\n" // (case 29)
"    .byte((loc_fc291fbc - branchtable_fc291f42) / 2)\n" // (case 30)
"    .byte((loc_fc291fbc - branchtable_fc291f42) / 2)\n" // (case 31)
"    .byte((loc_fc291fc2 - branchtable_fc291f42) / 2)\n" // (case 32)
"    .byte((loc_fc291fec - branchtable_fc291f42) / 2)\n" // (case 33)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 34)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 35)
"    .byte((loc_fc292016 - branchtable_fc291f42) / 2)\n" // (case 36)
"    .byte((loc_fc292040 - branchtable_fc291f42) / 2)\n" // (case 37)
"    .byte((loc_fc29206a - branchtable_fc291f42) / 2)\n" // (case 38)
"    .byte((loc_fc29206a - branchtable_fc291f42) / 2)\n" // (case 39)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 40)
"    .byte((loc_fc29208c - branchtable_fc291f42) / 2)\n" // (case 41)
"    .byte((loc_fc292070 - branchtable_fc291f42) / 2)\n" // (case 42)
"    .byte((loc_fc292076 - branchtable_fc291f42) / 2)\n" // (case 43)
".align 1\n"
"loc_fc291f6e:\n"
"    bl      sub_fc28e0c0\n"
"loc_fc291f72:\n"
"    b       loc_fc29208c\n"
"loc_fc291f74:\n"
"    bl      sub_fc28e324\n"
"    b       loc_fc29208c\n"
"loc_fc291f7a:\n"
"    bl      sub_fc28e54e\n"
"    b       loc_fc29208c\n"
"loc_fc291f80:\n"
"    bl      sub_fc28e7f2\n"
"    b       loc_fc29208c\n"
"loc_fc291f86:\n"
"    bl      sub_fc28e9a6\n"
"    b       loc_fc29208c\n"
"loc_fc291f8c:\n"
//"    bl      sub_fc28edd8\n"
"    bl      sub_fc28edd8_my\n"//  --->
"    movs    r5, #0\n"
"    b       loc_fc29208c\n"
".ltorg\n"
/*
"    b       loc_fc292678\n"
"    stc2    p11, c13, [r8], #-0xec\n"
"    stc2    p11, c13, [r8], #-0x23c\n"
"    stc2    p1, c13, [r8], #-0x2c0\n"
"    movs    r0, r0\n"
"    blt     loc_fc29205a\n"
"    stc2    p4, c14, [r8], #-0x160\n"
"    movs    r5, r0\n"
"    bl      sub_fbe92fae\n"
"    blt     loc_fc29203e\n"
"    stc2    p11, c13, [r8], #-0x13c\n"
"    stc2    p11, c13, [r8], #-0x18c\n"
"    stc2    p7, c15, [r8], #-0x3f0\n"
// ff89
*/
"loc_fc291fbc:\n"
"    bl      sub_fc28eed2\n"
"    b       loc_fc29208c\n"
"loc_fc291fc2:\n"
"    ldrh    r1, [r0, #4]\n"
"    strh.w  r1, [sp, #0x1c]\n"
"    ldrh    r1, [r6, #2]\n"
"    strh.w  r1, [sp, #0x1e]\n"
"    ldrh    r1, [r6, #4]\n"
"    strh.w  r1, [sp, #0x20]\n"
"    ldrh    r1, [r6, #6]\n"
"    strh.w  r1, [sp, #0x22]\n"
"    ldrh    r1, [r0, #0xc]\n"
"    strh.w  r1, [sp, #0x24]\n"
"    ldrh    r1, [r6, #0xa]\n"
"    strh.w  r1, [sp, #0x26]\n"
"    bl      sub_fc28f402\n"
"    b       loc_fc29208c\n"
"loc_fc291fec:\n"
"    ldrh    r1, [r0, #4]\n"
"    strh.w  r1, [sp, #0x1c]\n"
"    ldrh    r1, [r6, #2]\n"
"    strh.w  r1, [sp, #0x1e]\n"
"    ldrh    r1, [r6, #4]\n"
"    strh.w  r1, [sp, #0x20]\n"
"    ldrh    r1, [r6, #6]\n"
"    strh.w  r1, [sp, #0x22]\n"
"    ldrh    r1, [r6, #8]\n"
"    strh.w  r1, [sp, #0x24]\n"
"    ldrh    r1, [r6, #0xa]\n"
"    strh.w  r1, [sp, #0x26]\n"
"    bl      sub_fc292c50\n"
"    b       loc_fc29208c\n"
"loc_fc292016:\n"
"    ldrh    r1, [r6]\n"
"    strh.w  r1, [sp, #0x1c]\n"
"    ldrh    r1, [r0, #6]\n"
"    strh.w  r1, [sp, #0x1e]\n"
"    ldrh    r1, [r6, #4]\n"
"    strh.w  r1, [sp, #0x20]\n"
"    ldrh    r1, [r6, #6]\n"
"    strh.w  r1, [sp, #0x22]\n"
"    ldrh    r1, [r6, #8]\n"
"    strh.w  r1, [sp, #0x24]\n"
"    ldrh    r1, [r6, #0xa]\n"
"    strh.w  r1, [sp, #0x26]\n"
"    bl      sub_fc292cd6\n"
"loc_fc29203e:\n"
"    b       loc_fc29208c\n"
"loc_fc292040:\n"
"    ldrh    r1, [r6]\n"
"    strh.w  r1, [sp, #0x1c]\n"
"    ldrh    r1, [r6, #2]\n"
"    strh.w  r1, [sp, #0x1e]\n"
"    ldrh    r1, [r6, #4]\n"
"    strh.w  r1, [sp, #0x20]\n"
"    ldrh    r1, [r6, #6]\n"
"    strh.w  r1, [sp, #0x22]\n"
"    ldrh    r1, [r0, #0xc]\n"
"loc_fc29205a:\n"
"    strh.w  r1, [sp, #0x24]\n"
"    ldrh    r1, [r6, #0xa]\n"
"    strh.w  r1, [sp, #0x26]\n"
"    bl      sub_fc292d8c\n"
"    b       loc_fc29208c\n"
"loc_fc29206a:\n"
"    bl      sub_fc28f4e2\n"
"    b       loc_fc29208c\n"
"loc_fc292070:\n"
"    bl      sub_fc28fb74\n"
"    b       loc_fc29208c\n"
"loc_fc292076:\n"
"    bl      sub_fc28ff56\n"
"    b       loc_fc29208c\n"
"loc_fc29207c:\n"
"    bl      sub_fc29015c\n"
"    b       loc_fc29208c\n"
"loc_fc292082:\n"
"    bl      sub_fc2902b2\n"
"    b       loc_fc29208c\n"
"loc_fc292088:\n"
"    bl      sub_fc2903ce\n"
"loc_fc29208c:\n"
"    ldr     r0, [sp, #0x28]\n"
"    add.w   r0, r0, #0x94\n"
"    ldrd    r3, r2, [r0, #0x18]\n"
"    ldr     r1, [r0]\n"
"loc_fc292098:\n"
"    sub.w   r0, r0, #0x90\n"
"    blx     r3\n"
"loc_fc29209e:\n"
"    ldr     r0, [sp, #0x28]\n"
"    ldr     r0, [r0]\n"
"    cmp     r0, #0x10\n"
"    beq     loc_fc2920c2\n"
"    bgt     loc_fc2920b6\n"
"    cmp     r0, #1\n"
"    beq     loc_fc2920c2\n"
"    cmp     r0, #4\n"
"    beq     loc_fc2920c2\n"
"    cmp     r0, #0xe\n"
"    bne     loc_fc2920f0\n"
"    b       loc_fc2920c2\n"
"loc_fc2920b6:\n"
"    cmp     r0, #0x13\n"
"    beq     loc_fc2920c2\n"
"    cmp     r0, #0x18\n"
"    beq     loc_fc2920c2\n"
"    cmp     r0, #0x1b\n"
"    bne     loc_fc2920f0\n"
"loc_fc2920c2:\n"
"    ldrsh.w r1, [r6]\n"
"    mov     r2, sl\n"
"    cmp     r1, sl\n"
"    beq     loc_fc2920d4\n"
"    ldrsh.w r0, [r6, #8]\n"
"    cmp     r0, r2\n"
"    bne     loc_fc2920e8\n"
"loc_fc2920d4:\n"
"    add     r0, sp, #0x10\n"
"    bl      sub_fc2dd216\n"
"    ldrh.w  r0, [sp, #0x10]\n"
"    strh.w  r0, [sp, #0x1c]\n"
"    ldrh.w  r0, [sp, #0x18]\n"
"    b       loc_fc2920ec\n"
"loc_fc2920e8:\n"
"    strh.w  r1, [sp, #0x1c]\n"
"loc_fc2920ec:\n"
"    strh.w  r0, [sp, #0x24]\n"
"loc_fc2920f0:\n"
"    cmp     r5, #1\n"
"    ldr     r0, [sp, #0x28]\n"
"    bne     loc_fc292128\n"
"    movs    r2, #0xc\n"
"    ldr.w   r1, [r0, #0x94]\n"
"    add.w   r1, r1, r1, lsl #1\n"
"    add.w   r4, r0, r1, lsl #2\n"
"    ldr     r0, =0x0005e458\n"
"    subs    r4, #8\n"
"    add     r1, sp, #0x1c\n"
"    blx     sub_fc2cf43c\n"
"    ldr     r0, =0x0005e458\n"
"    movs    r2, #0xc\n"
"    add     r1, sp, #0x1c\n"
"    adds    r0, #0xc\n"
"    blx     sub_fc2cf43c\n"
"    ldr     r0, =0x0005e458\n"
"    movs    r2, #0xc\n"
"    mov     r1, r4\n"
"    adds    r0, #0x18\n"
"    blx     sub_fc2cf43c\n"
"    b       loc_fc292172\n"
"loc_fc292128:\n"
"    ldr     r0, [r0]\n"
"    mov.w   r3, #1\n"
"    cmp     r0, #0xb\n"
"    bne     loc_fc292152\n"
"    movs    r2, #0\n"
"    mov     r1, r3\n"
"    strd    r2, r3, [sp]\n"
"    movs    r0, #0\n"
"    mov     r2, r3\n"
"    bl      sub_fc28df12\n"
"    movs    r3, #1\n"
"    movs    r2, #0\n"
"    mov     r1, r3\n"
"    movs    r0, #0\n"
"    strd    r2, r3, [sp]\n"
"    mov     r2, r3\n"
"    b       loc_fc29216e\n"
"loc_fc292152:\n"
"    movs    r2, #1\n"
"    strd    r2, r3, [sp]\n"
"    mov     r3, r2\n"
"    mov     r1, r2\n"
"    mov     r0, r2\n"
"    bl      sub_fc28df12\n"
"    movs    r3, #1\n"
"    str     r3, [sp]\n"
"    mov     r2, r3\n"
"    mov     r1, r3\n"
"    mov     r0, r3\n"
"    str     r3, [sp, #4]\n"
"loc_fc29216e:\n"
"    bl      sub_fc28e046\n"
"loc_fc292172:\n"
"    ldr     r0, [sp, #0x28]\n"
"    bl      sub_fc292b92\n"
"    b       loc_fc291cfa\n"
".ltorg\n"
    );
}
//loc_fc28edd8: -s=0xfc28edd9 -c=  -f=chdk
void __attribute__((naked,noinline)) sub_fc28edd8_my() {
asm volatile (
"    push.w  {r4, r5, r6, r7, r8, lr}\n"
"    ldr     r7, =0x0000d1b0\n"
"    movs    r1, #0x3e\n"
"    mov     r4, r0\n"
"    ldr     r0, [r7, #0x1c]\n"
"    blx     sub_fc2cf3ec\n" // j_ClearEventFlag
"    movs    r2, #0\n"
"    ldrsh.w r0, [r4, #4]\n"
"    movs    r3, #1\n"
"    mov     r1, r2\n"
"    bl      sub_fc28dba4\n"
"    mov     r6, r0\n"
"    ldrsh.w r0, [r4, #6]\n"
"    bl      sub_fc28dd42\n"
"    ldrsh.w r0, [r4, #8]\n"
"    bl      sub_fc28dd86\n"
"    ldrsh.w r0, [r4, #0xa]\n"
"    bl      sub_fc28ddca\n"
"    ldrsh.w r0, [r4, #0xc]\n"
"    movs    r1, #0\n"
"    bl      sub_fc28de0e\n"
"    mov     r5, r0\n"
"    ldr     r0, [r4]\n"
"    ldr.w   r8, =0x0005e470\n"
"    cmp     r0, #0xb\n"
"    bne     loc_fc28ee2c\n"
"    movs    r6, #0\n"
"    mov     r5, r6\n"
"    b       loc_fc28ee44\n"
"loc_fc28ee2c:\n"
"    cmp     r6, #1\n"
"    bne     loc_fc28ee44\n"
"    ldrsh.w r0, [r4, #4]\n"
"    movs    r2, #2\n"
"    ldr     r1, =0xfc28db3b\n"
"    bl      sub_fc14d46a\n"
"    strh    r0, [r4, #4]\n"
"    movs    r0, #0\n"
"    str     r0, [r7, #0x28]\n"
"    b       loc_fc28ee4a\n"
"loc_fc28ee44:\n"
"    ldrh.w  r0, [r8]\n"
"    strh    r0, [r4, #4]\n"
"loc_fc28ee4a:\n"
"    cmp     r5, #1\n"
"    bne     loc_fc28ee5c\n"
"    ldrsh.w r0, [r4, #0xc]\n"
"    movs    r2, #0x20\n"
"    ldr     r1, =0xfc28db8f\n"
"    bl      sub_fc292c26\n"
"    b       loc_fc28ee60\n"
"loc_fc28ee5c:\n"
"    ldrh.w  r0, [r8, #8]\n"
"loc_fc28ee60:\n"
"    strh    r0, [r4, #0xc]\n"
"    ldrsh.w r0, [r4, #6]\n"
//"    bl      sub_fc16d658\n"
"    bl      sub_fc16d658_my\n"
"ldr pc,=0xfc28ee6b\n" //continue in ROM thumb
".ltorg\n"
/*
fc28ee66: 	f6de fbf7 	bl	sub_fc16d658
fc28ee6a: 	f9b4 0008 	ldrsh.w	r0, [r4, #8]
fc28ee6e: 	2101      	movs	r1, #1

*/
 );
}
//loc_fc16d658:
void __attribute__((naked,noinline)) sub_fc16d658_my() {
asm volatile (
"    push    {r4, r5, r6, lr}\n"
"    ldr     r5, =0x0000cd4c\n"
"    mov     r4, r0\n"
"    ldr     r0, [r5, #4]\n"
"    cmp     r0, #1\n"
"    beq     loc_fc16d670\n"
"    movs    r0, #0\n"
"    movw    r2, #0x16b\n"
"    ldr     r1, =0xfc16d6b8\n" //  *"Shutter.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc16d670:\n"
"    ldr     r0, =0xfffff400\n"
"    cmp     r4, r0\n"
"    bne     loc_fc16d67a\n"
"    ldrsh.w r4, [r5, #2]\n"
"loc_fc16d67a:\n"
"    strh    r4, [r5, #2]\n"
"    cmp     r4, r0\n"
"    bne     loc_fc16d68c\n"
"    movs    r0, #0\n"
"    movw    r2, #0x171\n"
"    ldr     r1, =0xfc16d6b8\n" //  *"Shutter.c"
"    blx     sub_fc2cf41c\n" // j_DebugAssert
"loc_fc16d68c:\n"
"    mov     r0, r4\n"
"    bl      apex2us\n"
//"    mov     r4, r0\n"
//"    bl      sub_fc194f4e\n"
//"    mov     r0, r4\n"
"    bl      sub_fc199bb8\n"
"    lsls    r0, r0, #0x1f\n"
"    beq     loc_fc16d6b2\n"
"    pop.w   {r4, r5, r6, lr}\n"
"    movs    r0, #0\n"
"    movw    r2, #0x176\n"
"    ldr     r1, =0xfc16d6b8\n" //  *"Shutter.c"
//"    b.w     loc_fc2ce964\n"
"ldr pc, =0xfc2ce965\n" //replace above with thumb
"loc_fc16d6b2:\n"
"    pop     {r4, r5, r6, pc}\n"
".ltorg\n"
 );
}


 


